(*/////////////////////////////////////////////////////////////////////////////
//                                                                           //
//   Part of Imagelib VCL/DLL Library Corporate Suite 4.0                    //
//                                                                           //
//   All rights reserved. (c) Copyright 1995, 1996, 1997, 1998.              //
//   SkyLine Tools a division by Creative Development LTD.                   //
//                                                                           //
//   Created by: Jan Dekkers,                                                //
//               Jillian Pinsker,                                            //
//               Reginald Armond,                                            //
//               Che-Chern Lin,                                              //
//               Alex Zitser,                                                //
//               Charles Ye,                                                 //
//               Song Han,                                                   //
//               Vitaly Bondarenko,                                          //
//               Jane Scarano,                                               //
//               Misha Popov;                                                //
//                                                                           //
//   and many others who provided feedback, gave tips and comments.          //
//                                                                           //
//   Call 1-800 404-3832  or 1-818 346-4200 to order ImageLib Corp. Suite.   //
//                                                                           //
/////////////////////////////////////////////////////////////////////////////*)

unit dbdocu;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  ILDocImg,
  ExtCtrls,
  StdCtrls,
  Buttons,
  Dllsp96,
  Dll96V1,
  Spin,
  Mask,
  Menus,
  ILDBDocI,
  DB,
  DBTables,
  DBCtrls,
  ComCtrls,
  MMSave,
  MMOpen,
  ilddoctb;


type
  TDBDocuForm = class(TForm)
    OpenDialog1: TMMOpenDialog;
    SaveDialog1: TMMSaveDialog;
    Panel1: TPanel;
    AppendTiff: TRadioButton;
    OverwriteTiff: TRadioButton;
    InsertTiff: TRadioButton;
    Label4: TLabel;
    InsertAtEdit: TSpinEdit;
    Panel2: TPanel;
    ComboBox1: TComboBox;
    Label2: TLabel;
    Label7: TLabel;
    MainMenu1: TMainMenu;
    SaveToFile1: TMenuItem;
    SaveToStream1: TMenuItem;
    fAsTif1: TMenuItem;
    fAsGif1: TMenuItem;
    fAsJpg1: TMenuItem;
    fAsPng1: TMenuItem;
    fAsPcx1: TMenuItem;
    fAsBmp1: TMenuItem;
    fAsTga1: TMenuItem;
    sAsTif1: TMenuItem;
    sAsGif1: TMenuItem;
    sAsJpg1: TMenuItem;
    sAsPng1: TMenuItem;
    sAsPcx1: TMenuItem;
    sAsBmp1: TMenuItem;
    sAsTga1: TMenuItem;
    Panel4: TPanel;
    Button16: TButton;
    Button14: TButton;
    Button1: TButton;
    Button18: TButton;
    Button27: TButton;
    Button15: TButton;
    Label1: TLabel;
    SpinEdit2: TSpinEdit;
    SpinEdit3: TSpinEdit;
    Button11: TButton;
    Button17: TButton;
    SpinEdit4: TSpinEdit;
    Label6: TLabel;
    Button13: TButton;
    RotateAngle: TMaskEdit;
    Label8: TLabel;
    Label3: TLabel;
    TiffCombo: TComboBox;
    Button2: TButton;
    ScaleCombo: TComboBox;
    Edit1: TMenuItem;
    Copy1: TMenuItem;
    Paste1: TMenuItem;
    Cut1: TMenuItem;
    Button3: TButton;
    Panel5: TPanel;
    ILDocumentImage1: ILDBDocumentImage;
    Button5: TButton;
    Button7: TButton;
    Button6: TButton;
    Label5: TLabel;
    Panel6: TPanel;
    Label11: TLabel;
    ComboBox2: TComboBox;
    ComboBox3: TComboBox;
    ComboBox4: TComboBox;
    SpeedButton8: TSpeedButton;
    DataSource1: TDataSource;
    Table1: TTable;
    DBNavigator1: TDBNavigator;
    Label9: TLabel;
    ProgressBar1: TProgressBar;
    Panel3: TPanel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    SpeedButton6: TSpeedButton;
    SpeedButton7: TSpeedButton;
    Label10: TLabel;
    Table1ANNOFILENA: TStringField;
    Table1DBDOCIMAGE: TBlobField;
    Table1DESCRIPT: TStringField;
    SpeedButton9: TSpeedButton;
    Zoom1: TMenuItem;
    BestFit1: TMenuItem;
    ILDBDocImageToolbar1: TILDBDocImageToolbar;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure WriteTifOptions(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure InsertAtEditChange(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure SpeedButton6Click(Sender: TObject);
    procedure SpeedButton7Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure Button13Click(Sender: TObject);
    procedure Button14Click(Sender: TObject);
    procedure Button15Click(Sender: TObject);
    procedure Button16Click(Sender: TObject);
    procedure Button17Click(Sender: TObject);
    procedure ILDocumentImage1Progress(Sender        : TObject;
                                       Progress      : Smallint;
                                       PMessage      : String;
                                   var CancelProcess : Boolean);
    procedure Button18Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button27Click(Sender: TObject);
    procedure fAsTif1Click(Sender: TObject);
    procedure fAsGif1Click(Sender: TObject);
    procedure fAsJpg1Click(Sender: TObject);
    procedure fAsPng1Click(Sender: TObject);
    procedure fAsPcx1Click(Sender: TObject);
    procedure fAsBmp1Click(Sender: TObject);
    procedure fAsTga1Click(Sender: TObject);
    procedure sAsTif1Click(Sender: TObject);
    procedure sAsGif1Click(Sender: TObject);
    procedure sAsJpg1Click(Sender: TObject);
    procedure sAsPng1Click(Sender: TObject);
    procedure sAsPcx1Click(Sender: TObject);
    procedure sAsBmp1Click(Sender: TObject);
    procedure sAsTga1Click(Sender: TObject);
    procedure ScaleComboChange(Sender: TObject);
    procedure Copy1Click(Sender: TObject);
    procedure Paste1Click(Sender: TObject);
    procedure Cut1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure TiffComboChange(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure ILDocumentImage1Tag(Sender: TObject;
                                  iTag,
                                  iLen: Smallint;
                                  lValue: Longint;
                                  sStrData,
                                  iTagName: string;
                                  iReadOnly: Boolean;
                                  iPage: Smallint;
                                  var CancelProcess: Boolean);
    procedure Button6Click(Sender: TObject);
    procedure ComboBox2Change(Sender: TObject);
    procedure ComboBox3Change(Sender: TObject);
    procedure ComboBox4Change(Sender: TObject);
    procedure SpeedButton8Click(Sender: TObject);
    procedure DataSource1DataChange(Sender: TObject; Field: TField);
    procedure SpeedButton9Click(Sender: TObject);
    procedure ILDocumentImage1Rubberband(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y, XX, YY: Integer);
    procedure ILDocumentImage1Info(Sender: TObject; im_Width,
      im_Height: Longint; im_BPP: Smallint; im_Size: Longint; im_TiffPages,
      im_TiffThisPage: Smallint; im_Compression: string;
      im_ByFile: Boolean; im_Filename: string);
    procedure BestFit1Click(Sender: TObject);
  private
    { Private declarations }
    function NameOnly(PName : string) : string;
  public
    { Public declarations }
    DocumentStream : TMemoryStream;
    ShowOfStream : TMemoryStream;
    SaveScale : SmallInt;
    ScaleOption : TScaleToGray;
    UseTifFile : Boolean;
    writeresolution : Integer;
    WidthforZoom  : Integer;
    HeightforZoom  : Integer;
  end;


var
  DBDocuForm    : TDBDocuForm;

implementation

{$R *.DFM}

{-----------------------------------------------------------------------------
return filename only. no path, no extension
-----------------------------------------------------------------------------}
function TDBDocuForm.NameOnly(PName : string) : string;
begin
  Result:=ChangeFileExt(ExtractFileName(PName), '');
end;

{-----------------------------------------------------------------------------

-----------------------------------------------------------------------------}
procedure TDBDocuForm.FormDestroy(Sender: TObject);
begin
    DocumentStream.Free;
    ShowOfStream.Free;
end;

{-----------------------------------------------------------------------------

-----------------------------------------------------------------------------}
procedure TDBDocuForm.FormCreate(Sender: TObject);
begin
     {Set the scale percent initial value}
     If FileExists(ExtractFilePath(Application.ExeName)+'dbdoc.dbf') then begin
       {if the table exists open it on creation}
       Table1.DataBaseName:=ExtractFilePath(Application.ExeName);
       Table1.TableName:='dbdoc.dbf';
       Table1.Active:=True;
     end;
     ILDocumentImage1.ScalePercent:=50;
     DocumentStream :=TMemoryStream.Create;
     ShowOfStream :=TMemoryStream.Create;
     ComboBox1.ItemIndex:=6;
     ScaleOption :=TScaleToGray(6);
     SaveScale:=50;
     writeresolution:=4;
end;

{-----------------------------------------------------------------------------

-----------------------------------------------------------------------------}
procedure TDBDocuForm.Button1Click(Sender: TObject);
begin
 SpinEdit2.Value:=1;
 SpinEdit3.Value:=1;
 try
  Screen.Cursor:=crHourGlass;
 {Open a tif file}
  if OpenDialog1.Execute then
   ILDocumentImage1.LoadFromFile(OpenDialog1.FileName);
 finally
  Screen.Cursor:=crDefault;
 end;
end;

{-----------------------------------------------------------------------------

-----------------------------------------------------------------------------}
procedure TDBDocuForm.WriteTifOptions(Sender: TObject);
begin
   Label4.Visible:=False;
   InsertAtEdit.Visible:=False;

   if TRadioButton(Sender) = AppendTiff then
      ILDocumentImage1.TifSaveOptions := tiffAppend;

   if TRadioButton(Sender) = OverwriteTiff then
      ILDocumentImage1.TifSaveOptions := tiffReplace;

   if TRadioButton(Sender) = InsertTiff then begin
      Label4.Visible:=True;
      InsertAtEdit.Visible:=True;
      ILDocumentImage1.TifSaveOptions := tiffInsert;
   end;
end;

{-----------------------------------------------------------------------------

-----------------------------------------------------------------------------}
procedure TDBDocuForm.InsertAtEditChange(Sender: TObject);
begin
  ILDocumentImage1.TifInsertAt:=InsertAtEdit.Value-1;
end;


{-----------------------------------------------------------------------------
Scale the image according scale options in percent
-----------------------------------------------------------------------------}
procedure TDBDocuForm.ScaleComboChange(Sender: TObject);
var
 Sc : Double;
begin
try
  Screen.Cursor:=crHourGlass;
  if ScaleCombo.ItemIndex = -1 then begin
    Sc:=StrToFloat(ScaleCombo.Text);
    if Sc < 1 then sc :=ILDocumentImage1.ScalePercent;
    ILDocumentImage1.ScalePercent:=Sc;
   end else
    ILDocumentImage1.ScalePercent:=(ScaleCombo.ItemIndex+1) * 10;
 finally
  Screen.Cursor:=crDefault;
 end;
end;

{-----------------------------------------------------------------------------
Set write resolution
-----------------------------------------------------------------------------}

procedure TDBDocuForm.ComboBox4Change(Sender: TObject);
begin
 Case ComboBox4.ItemIndex of
  0:    begin
           ILDocumentImage1.ImageWriteRes:=sMonoChrome;
           writeresolution:=2;
        end;
  1:    begin
           ILDocumentImage1.ImageWriteRes:=sColor16;
           writeresolution:=4;
        end;
  2:    begin
           ILDocumentImage1.ImageWriteRes:=sColor256;
           writeresolution:=8;
        end;
  3:    begin
           ILDocumentImage1.ImageWriteRes:=sColorTrue;
           writeresolution:=24;
        end;
 end;
end;

{-----------------------------------------------------------------------------
Set grayscale for saving purposes
-----------------------------------------------------------------------------}
procedure TDBDocuForm.ComboBox2Change(Sender: TObject);
begin
   {When saving images use this to scale. }
   ScaleOption := TScaleToGray(ComboBox2.ItemIndex);
end;


{-----------------------------------------------------------------------------
Set scale for saving to stream/file purposes
-----------------------------------------------------------------------------}

procedure TDBDocuForm.ComboBox3Change(Sender: TObject);
var
 Sc : Double;
begin
try
  Screen.Cursor:=crHourGlass;
  if ComboBox3.ItemIndex = -1 then begin
    Sc:=StrToFloat(ComboBox3.Text);
    if Sc < 1 then sc :=ILDocumentImage1.ScalePercent;
    SaveScale:=Round(Sc);
   end else
    SaveScale:=(ComboBox3.ItemIndex+1) * 10;
 finally
  Screen.Cursor:=crDefault;
 end;
end;

{-----------------------------------------------------------------------------

-----------------------------------------------------------------------------}
procedure TDBDocuForm.ComboBox1Change(Sender: TObject);
begin
try
 Screen.Cursor:=crHourGlass;

  {Scale the image according scale options

  'S_Gray_None'     No Scale to Gray
  'S_Gray_16_8'     8 neighbor pixels 16 levels of gray (4 bit image)
  'S_Gray_16_12'    12-neighbour pixels 16 levels of gray (4 bit image)
  'S_Gray_16_20'    20-neighbour pixels 16 levels of gray (4 bit image)
  'S_Gray_16_24'    24-neighbour pixels 16 levels of gray (4 bit image)
  'S_Gray_256_24'   24-neighbour pixels 256 levels of gray (8 bit image)
**'S_Gray_Anti_16'  16 gray antiailaising (4 bit image) (BEST CHOICE) **
  'S_Gray_Anti_256' 256 gray antiailaising (8 bit image)}

   ILDocumentImage1.ScaleDoc := TScaleToGray(ComboBox1.ItemIndex);

 finally
  Screen.Cursor:=crDefault;
 end;
end;

{-----------------------------------------------------------------------------

-----------------------------------------------------------------------------}
procedure TDBDocuForm.SpeedButton1Click(Sender: TObject);
begin
try
 Screen.Cursor:=crHourGlass;
 {Go to the first page in the tiff file or stream}
 ILDocumentImage1.First;

 finally
  Screen.Cursor:=crDefault;
 end;
end;

{-----------------------------------------------------------------------------

-----------------------------------------------------------------------------}
procedure TDBDocuForm.SpeedButton2Click(Sender: TObject);
begin
try
 Screen.Cursor:=crHourGlass;
 {Go to the prior page in the tiff file or stream}
 ILDocumentImage1.Prior;

 finally
  Screen.Cursor:=crDefault;
 end;
end;

{-----------------------------------------------------------------------------

-----------------------------------------------------------------------------}
procedure TDBDocuForm.SpeedButton3Click(Sender: TObject);
begin
try
 Screen.Cursor:=crHourGlass;
 {Go to the next page in the tiff file or stream}

 ILDocumentImage1.Next;

 finally
  Screen.Cursor:=crDefault;
 end;
end;

{-----------------------------------------------------------------------------

-----------------------------------------------------------------------------}
procedure TDBDocuForm.SpeedButton4Click(Sender: TObject);
begin
try
 Screen.Cursor:=crHourGlass;
 {Go to the last page in the tiff file or stream}
 ILDocumentImage1.Last;

 finally
  Screen.Cursor:=crDefault;
 end;
end;

{-----------------------------------------------------------------------------

-----------------------------------------------------------------------------}
procedure TDBDocuForm.SpeedButton5Click(Sender: TObject);
begin
try
 Screen.Cursor:=crHourGlass;
 {delete the current page from the tiff file or stream.
  Note, the page is marked for deletion. To actually
  delete marked pages call Pack}
  ILDocumentImage1.Delete;

 finally
  Screen.Cursor:=crDefault;
 end;
end;

{-----------------------------------------------------------------------------

-----------------------------------------------------------------------------}
procedure TDBDocuForm.SpeedButton6Click(Sender: TObject);
begin
try
 Screen.Cursor:=crHourGlass;
 {Update the current tiff page file or stream }
 {Note, the old page is marked for deletion and the new one
  is added with using the old page number. To actually
  delete marked pages call Pack}
  ILDocumentImage1.UpdateTiff;
 finally
  Screen.Cursor:=crDefault;
 end;
end;

{-----------------------------------------------------------------------------

-----------------------------------------------------------------------------}
procedure TDBDocuForm.SpeedButton7Click(Sender: TObject);
begin
try
 Screen.Cursor:=crHourGlass;
 {This will remove all marked for deletion tiffpages from the tiff
 file or stream. This could be a lengthy operation depending how many pages are
 subject for deletion}
 ILDocumentImage1.Pack;

 finally
  Screen.Cursor:=crDefault;
 end;
end;

{-----------------------------------------------------------------------------

-----------------------------------------------------------------------------}
procedure TDBDocuForm.Button11Click(Sender: TObject);
begin
try
 Screen.Cursor:=crHourGlass;

 {This will swap 2 pages with eachother}
 ILDocumentImage1.Swap( SpinEdit2.Value-1, SpinEdit3.Value-1);

 finally
  Screen.Cursor:=crDefault;
 end;
end;

{-----------------------------------------------------------------------------

-----------------------------------------------------------------------------}
procedure TDBDocuForm.Button13Click(Sender: TObject);
begin
try
 Screen.Cursor:=crHourGlass;

 {Rotate the current tif page. Call Update to post to tiff file or stream}
  ILDocumentImage1.Rotate(StrToFloat(RotateAngle.Text), {Angle}
                          clWhite); {Background color}
 finally
  Screen.Cursor:=crDefault;
 end;
end;

{-----------------------------------------------------------------------------

-----------------------------------------------------------------------------}
procedure TDBDocuForm.Button14Click(Sender: TObject);
begin
try
 Screen.Cursor:=crHourGlass;
 {Inverts the current tif page. Call Update to post to tiff file or stream}
 ILDocumentImage1.Invert;

 finally
  Screen.Cursor:=crDefault;
 end;
end;

{-----------------------------------------------------------------------------
 Find the deskew value and rotate the current tif page if needed.
  Note:  Call Update to post to tiff file or stream.
-----------------------------------------------------------------------------}
procedure TDBDocuForm.Button15Click(Sender: TObject);
begin
try
 Screen.Cursor:=crHourGlass;
  ILDocumentImage1.Deskew(0);
  {Deskew(0) 0 when Background color is white
             1 when Background color is Black}
 finally
  Screen.Cursor:=crDefault;
 end;
end;

{-----------------------------------------------------------------------------
Remove unwanted border
-----------------------------------------------------------------------------}
procedure TDBDocuForm.Button16Click(Sender: TObject);
begin
try
 Screen.Cursor:=crHourGlass;

 ILDocumentImage1.BorderRemove(250);

 finally
  Screen.Cursor:=crDefault;
 end;
end;

{-----------------------------------------------------------------------------
Scan # of pages
-----------------------------------------------------------------------------}
procedure TDBDocuForm.Button17Click(Sender: TObject);
begin
try
 Screen.Cursor:=crHourGlass;

 ILDocumentImage1.ScanPages(SpinEdit4.Value);

 finally
  Screen.Cursor:=crDefault;
 end;
end;

{-----------------------------------------------------------------------------

-----------------------------------------------------------------------------}

procedure TDBDocuForm.Button6Click(Sender: TObject);
begin
   SelectTwainSource(Handle);
end;

{-----------------------------------------------------------------------------

-----------------------------------------------------------------------------}

procedure TDBDocuForm.Button3Click(Sender: TObject);
begin
try
 Screen.Cursor:=crHourGlass;

 ILDocumentImage1.ScanPagesToStream(SpinEdit4.Value, DocumentStream);
 ILDocumentImage1.LoadfromStream(DocumentStream);

 finally
  Screen.Cursor:=crDefault;
 end;
end;

{-----------------------------------------------------------------------------

-----------------------------------------------------------------------------}
procedure TDBDocuForm.ILDocumentImage1Progress(Sender        : TObject;
                                             Progress      : Smallint;
                                             PMessage      : String;
                                         var CancelProcess : Boolean);
begin
    CancelProcess := Application.Terminated;
    
    {Set the message caption}
    Panel5.Caption:='Status '+PMessage;

    {Process the First call}
    if Progress < 5  then begin
     ProgressBar1.Position:=0;
     Application.ProcessMessages;
    end;

    {Process the Last call}
    if Progress > 99  then begin
     ProgressBar1.Position:=Progress;
     {reset the message caption}
     Panel5.Caption:='';
     Application.ProcessMessages;
    end;

    {Some speed improvement when only processing each fifth call}
    if Progress > ProgressBar1.Position+5 then begin
     ProgressBar1.Position:=Progress;
     Application.ProcessMessages;
    end;

end;

{-----------------------------------------------------------------------------
This shows how to read a tif into a memorystream
-----------------------------------------------------------------------------}
procedure TDBDocuForm.Button18Click(Sender: TObject);
begin
try
 Screen.Cursor:=crHourGlass;

 SpinEdit2.Value:=1;
 SpinEdit3.Value:=1;

 if OpenDialog1.Execute then begin
   {Open a tif stream}
    DocumentStream.LoadfromFile(OpenDialog1.FileName);
    ILDocumentImage1.LoadfromStream(DocumentStream);
 end;

 finally
  Screen.Cursor:=crDefault;
 end;
end;

{-----------------------------------------------------------------------------
This Saves the document stream (tiff) to a file
-----------------------------------------------------------------------------}
procedure TDBDocuForm.Button27Click(Sender: TObject);
begin
If (DocumentStream = nil) or (DocumentStream.Size < 1)then raise ErrorInvalid.Create(iNoStream);

try
 Screen.Cursor:=crHourGlass;

 SaveDialog1.Filter:='tif|*.tif';
 if SaveDialog1.Execute then
     DocumentStream.SaveToFile(SaveDialog1.FileName);

 finally
  Screen.Cursor:=crDefault;
 end;
end;

{-----------------------------------------------------------------------------
How to set the Tif write compression and save it
-----------------------------------------------------------------------------}
procedure TDBDocuForm.fAsTif1Click(Sender: TObject);
begin
try
 Screen.Cursor:=crHourGlass;
 SaveDialog1.Filter:='tif|*.tif';
 if SaveDialog1.Execute then begin
     ILDocumentImage1.WriteTifFile(SaveDialog1.FileName,
                                   SaveScale, 
                                   ScaleOption,
                                   writeresolution);{resolution 1, 4,8,24}
 end;
 finally
  Screen.Cursor:=crDefault;
 end;
end;

{-----------------------------------------------------------------------------
How to Save the document to a Gif File
-----------------------------------------------------------------------------}
procedure TDBDocuForm.fAsGif1Click(Sender: TObject);
begin
try
 Screen.Cursor:=crHourGlass;
 SaveDialog1.Filter:='gif|*.gif';
 if SaveDialog1.Execute then
    ILDocumentImage1.WriteGifFile(SaveDialog1.FileName,
                                  SaveScale, 
                                  ScaleOption,
                                  writeresolution); {resolution 4,8,24}
 finally
  Screen.Cursor:=crDefault;
 end;
end;


{-----------------------------------------------------------------------------
How to Save the document to a Jpeg File
-----------------------------------------------------------------------------}
procedure TDBDocuForm.fAsJpg1Click(Sender: TObject);
begin
try
 Screen.Cursor:=crHourGlass;
 SaveDialog1.Filter:='jpg|*.jpg';
 if SaveDialog1.Execute then
    ILDocumentImage1.WriteJpgFile(SaveDialog1.FileName,
                                  SaveScale, 
                                  ScaleOption,
                                  75,  {Quality 0 .. 100}
                                  5,   {Smooth 0 .. 100}
                                  writeresolution); {resolution 8,24 - 8 is gray scale}
 finally
  Screen.Cursor:=crDefault;
 end;
end;

{-----------------------------------------------------------------------------
How to Save the document to a Png File
-----------------------------------------------------------------------------}
procedure TDBDocuForm.fAsPng1Click(Sender: TObject);
begin
try
 Screen.Cursor:=crHourGlass;
 SaveDialog1.Filter:='png|*.png';
 if SaveDialog1.Execute then
    ILDocumentImage1.WritePngFile(SaveDialog1.FileName,
                                  SaveScale, 
                                  ScaleOption,
                                  0,  {0 is normal, 1 is interlaced}
                                  writeresolution); {resolution 4,8,24}
 finally
  Screen.Cursor:=crDefault;
 end;
end;


{-----------------------------------------------------------------------------
How to Save the document to a Pcx File
-----------------------------------------------------------------------------}
procedure TDBDocuForm.fAsPcx1Click(Sender: TObject);
begin
try
 Screen.Cursor:=crHourGlass;
 SaveDialog1.Filter:='pcx|*.pcx';
 if SaveDialog1.Execute then
    ILDocumentImage1.WritePcxFile(SaveDialog1.FileName,
                                  SaveScale, 
                                  ScaleOption,
                                  writeresolution);{resolution 4,8,24}
 finally
  Screen.Cursor:=crDefault;
 end;
end;

{-----------------------------------------------------------------------------
How to Save the document to a Bmp File
-----------------------------------------------------------------------------}
procedure TDBDocuForm.fAsBmp1Click(Sender: TObject);
begin
try
 Screen.Cursor:=crHourGlass;
 SaveDialog1.Filter:='bmp|*.bmp';
 if SaveDialog1.Execute then
    ILDocumentImage1.WriteBmpFile(SaveDialog1.FileName,
                                  SaveScale, 
                                  ScaleOption,
                                  writeresolution);{resolution 4,8,24}
 finally
  Screen.Cursor:=crDefault;
 end;
end;

{-----------------------------------------------------------------------------
How to Save the document to a Tga File
-----------------------------------------------------------------------------}
procedure TDBDocuForm.fAsTga1Click(Sender: TObject);
begin
try
 Screen.Cursor:=crHourGlass;
 SaveDialog1.Filter:='tga|*.tga';
 if SaveDialog1.Execute then
    ILDocumentImage1.WriteTgaFile(SaveDialog1.FileName,
                                  SaveScale, 
                                  ScaleOption,
                                  writeresolution);{resolution 4,8,24}
 finally
  Screen.Cursor:=crDefault;
 end;
end;


{-----------------------------------------------------------------------------
How to Save the document to a Eps File
-----------------------------------------------------------------------------}
{-----------------------------------------------------------------------------
This shows how to write a tif to a memorystream
-----------------------------------------------------------------------------}
procedure TDBDocuForm.sAsTif1Click(Sender: TObject);
begin
try
 Screen.Cursor:=crHourGlass;
 {We don't do any thing with this stream here but you could}
 ILDocumentImage1.WriteTifStream(DocumentStream,
                                 SaveScale,
                                 ScaleOption,
                                 writeresolution);

 finally
  Screen.Cursor:=crDefault;
 end;
end;

{-----------------------------------------------------------------------------
This shows how to write a Gif to a memorystream
-----------------------------------------------------------------------------}
procedure TDBDocuForm.sAsGif1Click(Sender: TObject);
begin
try
 Screen.Cursor:=crHourGlass;

    ILDocumentImage1.WriteGifStream(ShowOfStream,
                                    SaveScale,
                                    ScaleOption,
                                    writeresolution);
 finally
  Screen.Cursor:=crDefault;
 end;
end;

{-----------------------------------------------------------------------------
This shows how to write a Jpeg to a memorystream
-----------------------------------------------------------------------------}
procedure TDBDocuForm.sAsJpg1Click(Sender: TObject);
begin
try
 Screen.Cursor:=crHourGlass;

    ILDocumentImage1.WriteJpgStream(ShowOfStream,
                                    SaveScale, 
                                    ScaleOption,
                                    75,  {Quality 0 .. 100}
                                    5,   {Smooth 0 .. 100}
                                    writeresolution); {resolution 8,24 - 8 is gray scale}
 finally
  Screen.Cursor:=crDefault;
 end;
end;


{-----------------------------------------------------------------------------
This shows how to write a Png to a memorystream
-----------------------------------------------------------------------------}
procedure TDBDocuForm.sAsPng1Click(Sender: TObject);
begin
try
 Screen.Cursor:=crHourGlass;

    ILDocumentImage1.WritePngStream(ShowOfStream,
                                    SaveScale, 
                                    ScaleOption,
                                    0,  {0 is normal, 1 is interlaced}
                                    writeresolution); {resolution 4,8,24}
 finally
  Screen.Cursor:=crDefault;
 end;
end;

{-----------------------------------------------------------------------------
This shows how to write a Pcx to a memorystream
-----------------------------------------------------------------------------}
procedure TDBDocuForm.sAsPcx1Click(Sender: TObject);
begin
try
 Screen.Cursor:=crHourGlass;

    ILDocumentImage1.WritePcxStream(ShowOfStream,
                                    SaveScale, 
                                    ScaleOption,
                                    writeresolution);{resolution 4,8,24}
 finally
  Screen.Cursor:=crDefault;
 end;
end;

{-----------------------------------------------------------------------------
This shows how to write a Bmp to a memorystream
-----------------------------------------------------------------------------}
procedure TDBDocuForm.sAsBmp1Click(Sender: TObject);
begin
try
 Screen.Cursor:=crHourGlass;

    ILDocumentImage1.WriteBmpStream(ShowOfStream,
                                    SaveScale, 
                                    ScaleOption,
                                    writeresolution);{resolution 4,8,24}
 finally
  Screen.Cursor:=crDefault;
 end;
end;


{-----------------------------------------------------------------------------
This shows how to write a Tga to a memorystream
-----------------------------------------------------------------------------}
procedure TDBDocuForm.sAsTga1Click(Sender: TObject);
begin
try
 Screen.Cursor:=crHourGlass;

    ILDocumentImage1.WriteTgaStream(ShowOfStream,
                                    SaveScale, 
                                    ScaleOption,
                                    writeresolution);{resolution 4,8,24}
 finally
  Screen.Cursor:=crDefault;
 end;
end;

{-----------------------------------------------------------------------------
This shows how to write a Eps to a memorystream
-----------------------------------------------------------------------------}
{-----------------------------------------------------------------------------

-----------------------------------------------------------------------------}
procedure TDBDocuForm.Copy1Click(Sender: TObject);
begin
try
  Screen.Cursor:=crHourGlass;
  ILDocumentImage1.CopyToClipboard;
 finally
  Screen.Cursor:=crDefault;
 end;
end;

{-----------------------------------------------------------------------------

-----------------------------------------------------------------------------}

procedure TDBDocuForm.Paste1Click(Sender: TObject);
begin
try
  Screen.Cursor:=crHourGlass;
  ILDocumentImage1.PasteFromClipboard;
 finally
  Screen.Cursor:=crDefault;
 end;
end;

{-----------------------------------------------------------------------------

-----------------------------------------------------------------------------}

procedure TDBDocuForm.Cut1Click(Sender: TObject);
begin
try
  Screen.Cursor:=crHourGlass;
  ILDocumentImage1.CutToClipboard;
 finally
  Screen.Cursor:=crDefault;
 end;
end;

{-----------------------------------------------------------------------------

-----------------------------------------------------------------------------}

procedure TDBDocuForm.TiffComboChange(Sender: TObject);
begin
 {Set the compression method to save tiffs}
  if TiffCombo.Text ='NONE' then begin
    ILDocumentImage1.TifSaveCompress:=sNONE;
  end;

 if TiffCombo.Text ='CCITT' then begin
    ILDocumentImage1.TifSaveCompress:=sCCITT;
 end;

 if TiffCombo.Text ='FAXCCITT3' then begin
    ILDocumentImage1.TifSaveCompress:=sFAXCCITT3;
 end;

 if TiffCombo.Text ='FAXCCITT4' then begin
    ILDocumentImage1.TifSaveCompress:=sFAXCCITT4;
 end;

 if TiffCombo.Text ='LZW' then begin
    ILDocumentImage1.TifSaveCompress:=sLZW;
 end;

 if TiffCombo.Text ='PACKBITS' then begin
    ILDocumentImage1.TifSaveCompress:=sPACKBITS;
 end;
end;

{-----------------------------------------------------------------------------

-----------------------------------------------------------------------------}

{-----------------------------------------------------------------------------

-----------------------------------------------------------------------------}

procedure TDBDocuForm.Button5Click(Sender: TObject);
begin
    ILDocumentImage1.HardDrawAnnotation;
    ILDocumentImage1.ClearAnnotation;
end;

{-----------------------------------------------------------------------------

-----------------------------------------------------------------------------}


procedure TDBDocuForm.Button7Click(Sender: TObject);
begin
     ILDocumentImage1.Edittags;
end;

{-----------------------------------------------------------------------------
This Event returns all tags from the tiff page. Do NOT try to write to a read only tag
unless you know what you are doing.
-----------------------------------------------------------------------------}
procedure TDBDocuForm.ILDocumentImage1Tag(Sender: TObject;
                                        iTag,              {Tag number}
                                        iLen: Smallint;    {Length of string sStrData}
                                        lValue: Longint;   {Integer value}
                                        sStrData,          {String Value}
                                        iTagName: string;  {Name of tag}
                                        iReadOnly: Boolean;{Can write back to tag}
                                        iPage: Smallint;   {What page is this tag for}
                                        var CancelProcess: Boolean); {Stop loading tags}
begin
{ You can write a tag back as follow:
 if Not iReadOnly then
  TDocuForm.writetag(iTag,           //Tag number
                     lValue,         //Integer value
                     sStrData);      //String value (Will be truncated when longer then orginal
}
end;

{-----------------------------------------------------------------------------
Write the X and Y Resolution to the tif file. Shows how to write tags using the enumerations
-----------------------------------------------------------------------------}
procedure TDBDocuForm.Button2Click(Sender: TObject);
begin
 {TTifTagEnum, Numeric value, String Value}
  ILDocumentImage1.WriteEnumTag(ilt_XRESOLUTION, 300, '');
  ILDocumentImage1.WriteEnumTag(ilt_YRESOLUTION, 400, '');
 {
  TTifTagEnum = (ilt_NEWSUBFILETYPE,
                 ilt_FILETYPE,
                 ilt_IMAGEWIDTH,
                 ilt_IMAGELENGTH,
                 ilt_BITSPERSAMPLE,
                 ilt_COMPRESSION,
                 ilt_PHOTOMETRICINTERPRETATION,
                 ilt_THRESHHOLDING,
                 ilt_CELLWIDTH,
                 ilt_CELLLENGTH,
                 ilt_FILLORDER,
                 ilt_DOCUMENTNAME,
                 ilt_IMAGEDESCRIPTION,
                 ilt_MAKE,
                 ilt_MODEL,
                 ilt_STRIPOFFSETS,
                 ilt_ORIENTATION,
                 ilt_SAMPLESPERPIXEL,
                 ilt_ROWSPERSTRIP,
                 ilt_STRIPBYTECOUNTS,
                 ilt_MINIMUMVALUE,
                 ilt_MAXIMUMVALUE,
                 ilt_XRESOLUTION,
                 ilt_YRESOLUTION,
                 ilt_PLANARCONFIG,
                 ilt_PAGENAME,
                 ilt_XPOSITION,
                 ilt_YPOSITION,
                 ilt_FREEOFFSETS,
                 ilt_FREEBYTECOUNTS,
                 ilt_GRAYRESPONSEUNITS,
                 ilt_GRAYSCALERRESPONSE,
                 ilt_GROUP3OPTIONS,
                 ilt_GROUP4OPTIONS,
                 ilt_RESOLUTIONUNIT,
                 ilt_PAGENUMBER,
                 ilt_COLORRESPONSEUNIT,
                 ilt_COLORRESPONSECURVES,
                 ilt_SOFTWARE,
                 ilt_ARTIST,
                 ilt_PREDICTOR,
                 ilt_COLORMAP,
                 ilt_COPYRIGHT);
}
end;

{-----------------------------------------------------------------------------

-----------------------------------------------------------------------------}

procedure TDBDocuForm.SpeedButton8Click(Sender: TObject);
Var
 AnnoFileName : String;
begin
    ILDocumentImage1.EditAnnotat := SpeedButton8.Down;
    if not SpeedButton8.Down then begin
     if Table1ANNOFILENA.Value <> '' then
       ILDocumentImage1.SaveAnnotation(ILDocumentImage1.TiffPage,Table1ANNOFILENA.Value)
     else begin
       AnnoFileName := NameOnly(Table1.TableName);
       AnnoFileName:=AnnoFileName+IntToStr(Table1.RecNo)+'.ant';
       ILDocumentImage1.SaveAnnotation(ILDocumentImage1.TiffPage, AnnoFileName);
       Table1.Edit;
       Table1ANNOFILENA.Value:=AnnoFileName;
       Table1.Post;
     end;
    end;
end;

{-----------------------------------------------------------------------------

-----------------------------------------------------------------------------}
procedure TDBDocuForm.DataSource1DataChange(Sender: TObject;
  Field: TField);
begin
    ILDocumentImage1.ClearAnnotation;
    if (not SpeedButton8.Down) and (FileExists(Table1ANNOFILENA.Value)) then begin
       ILDocumentImage1.LoadAnnotation(ILDocumentImage1.TiffPage,Table1ANNOFILENA.Value);
    end;
end;

{-----------------------------------------------------------------------------

-----------------------------------------------------------------------------}
procedure TDBDocuForm.SpeedButton9Click(Sender: TObject);
begin
  (*Switch between panning and zooming. Note: Zooming in document imaging will take
  more time then in other ImageLib components because it actually create a new
  resized grayscale image*)

   if SpeedButton9.Down then begin
      SpeedButton9.Caption:='Panning';
   end else begin
      SpeedButton9.Caption:='Zooming';
   end;
   ILDocumentImage1.AllowRubberBand := not SpeedButton9.Down;
end;


{-----------------------------------------------------------------------------

-----------------------------------------------------------------------------}
procedure TDBDocuForm.ILDocumentImage1Rubberband(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y, XX, YY: Integer);
begin
    //Here is where the actual zoom takes place
    Screen.Cursor:=crHourglass;
    ILDocumentImage1.ZoomArea(Rect(X,Y,XX,YY));
    Screen.Cursor:=crDefault;
end;

{-----------------------------------------------------------------------------
This event is fired by the get info method
-----------------------------------------------------------------------------}
procedure TDBDocuForm.ILDocumentImage1Info(Sender: TObject;
                                           im_Width,            {Width of the image}
                                           im_Height: Longint;  {Heigth of the image}
                                           im_BPP: Smallint;    {Bits per pixel}
                                           im_Size: Longint;    {Size of the whole file or stream}
                                           im_TiffPages,        {How many tif pages in file or stream}
                                           im_TiffThisPage: Smallint;{Which Tiff page we are viewing}
                                           im_Compression: string;{Whats the current page compression}
                                           im_ByFile: Boolean;  {True if using file, false when stream}
                                           im_Filename: string);{Whats the file name}
begin
     UseTifFile := im_ByFile;
     SpinEdit2.MaxValue:=im_TiffPages;
     SpinEdit3.MaxValue:=im_TiffPages;
     Caption:='Page '+IntToStr(im_TiffThisPage+1)+
              ' of '+IntToStr(im_TiffPages)+' Pages '+
              im_Filename+' '+im_Compression+' W:'+IntToStr(im_Width)+
              ' H:'+IntToStr(im_Height)+' Bpp:'+IntToStr(im_Bpp);
    WidthforZoom :=  im_Width ;
    HeightforZoom :=  im_Height ;
end;



procedure TDBDocuForm.BestFit1Click(Sender: TObject);
var
   StorageforWidth : Double;
begin
    StorageforWidth := (ILDocumentImage1.Width  * 100) / WidthforZoom ;
    ILDocumentImage1.ScalePercent := (ILDocumentImage1.Height  * 100)/ HeightforZoom ;
    if (StorageforWidth < ILDocumentImage1.ScalePercent) then
        ILDocumentImage1.ScalePercent := StorageforWidth;
    ILDocumentImage1.ZoomArea(Rect(1,1,WidthforZoom ,HeightforZoom ));
end;

end.




