(*/////////////////////////////////////////////////////////////////////////////
//                                                                           //
//   Part of Imagelib VCL/DLL Library Corporate Suite 4.0                    //
//                                                                           //
//   All rights reserved. (c) Copyright 1995, 1996, 1997, 1998.              //
//   SkyLine Tools a division by Creative Development LTD.                   //
//                                                                           //
//   Created by: Jan Dekkers,                                                //
//               Jillian Pinsker,                                            //
//               Reginald Armond,                                            //
//               Che-Chern Lin,                                              //
//               Alex Zitser,                                                //
//               Charles Ye,                                                 //
//               Song Han,                                                   //
//               Vitaly Bondarenko,                                          //
//               Jane Scarano,                                               //
//               Misha Popov;                                                //
//                                                                           //
//   and many others who provided feedback, gave tips and comments.          //
//                                                                           //
//   Call 1-800 404-3832  or 1-818 346-4200 to order ImageLib Corp. Suite.   //
//                                                                           //
/////////////////////////////////////////////////////////////////////////////*)

unit docunit;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  ILDocImg,
  ExtCtrls,
  StdCtrls,
  Buttons,
  Dllsp96,
  Dll96V1,
  Spin,
  Mask,
  Menus,
  MMSave,
  MMOpen,
  ComCtrls,
  Printers,
  ildoctb,
  ILAnnSet;


type
  TDocuForm = class(TForm)
    OpenDialog1: TMMOpenDialog;
    SaveDialog1: TMMSaveDialog;
    Panel1: TPanel;
    AppendTiff: TRadioButton;
    OverwriteTiff: TRadioButton;
    InsertTiff: TRadioButton;
    Label4: TLabel;
    InsertAtEdit: TSpinEdit;
    Panel2: TPanel;
    ComboBox1: TComboBox;
    Panel3: TPanel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    SpeedButton6: TSpeedButton;
    SpeedButton7: TSpeedButton;
    Label2: TLabel;
    Label7: TLabel;
    MainMenu1: TMainMenu;
    SaveToFile1: TMenuItem;
    SaveToStream1: TMenuItem;
    fAsTif1: TMenuItem;
    fAsGif1: TMenuItem;
    fAsJpg1: TMenuItem;
    fAsPng1: TMenuItem;
    fAsPcx1: TMenuItem;
    fAsBmp1: TMenuItem;
    fAsTga1: TMenuItem;
    sAsTif1: TMenuItem;
    sAsGif1: TMenuItem;
    sAsJpg1: TMenuItem;
    sAsPng1: TMenuItem;
    sAsPcx1: TMenuItem;
    sAsBmp1: TMenuItem;
    sAsTga1: TMenuItem;
    Panel4: TPanel;
    Button16: TButton;
    Button14: TButton;
    Button1: TButton;
    Button18: TButton;
    Button27: TButton;
    Button15: TButton;
    Label1: TLabel;
    SpinEdit2: TSpinEdit;
    SpinEdit3: TSpinEdit;
    Button11: TButton;
    Button17: TButton;
    SpinEdit4: TSpinEdit;
    Label6: TLabel;
    Button13: TButton;
    RotateAngle: TMaskEdit;
    Label8: TLabel;
    Label3: TLabel;
    TiffCombo: TComboBox;
    Button2: TButton;
    ScaleCombo: TComboBox;
    Edit1: TMenuItem;
    Copy1: TMenuItem;
    Paste1: TMenuItem;
    Cut1: TMenuItem;
    Button3: TButton;
    ILDocumentImage1: ILDocumentImage;
    Button5: TButton;
    Button7: TButton;
    Button6: TButton;
    Label5: TLabel;
    Panel6: TPanel;
    Label11: TLabel;
    ComboBox2: TComboBox;
    ComboBox3: TComboBox;
    ComboBox4: TComboBox;
    SpeedButton8: TSpeedButton;
    SpeedButton9: TSpeedButton;
    Button4: TButton;
    Import: TMenuItem;
    ImportFiles1: TMenuItem;
    Zoom1: TMenuItem;
    BestFit1: TMenuItem;
    Mirror1: TMenuItem;
    Horizontal1: TMenuItem;
    Vertical1: TMenuItem;
    HorzVert1: TMenuItem;
    PixelAccess1: TMenuItem;
    HowTo1: TMenuItem;
    Crop1: TMenuItem;
    IlDocImageToolbar1: TIlDocImageToolbar;
    StatusBar1: TStatusBar;
    ProgressBar1: TProgressBar;
    Print1: TMenuItem;
    Print2: TMenuItem;
    PrintwithAnnotations1: TMenuItem;
    AnnoSettings1: TAnnoSettings;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure WriteTifOptions(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure InsertAtEditChange(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure SpeedButton6Click(Sender: TObject);
    procedure SpeedButton7Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure Button13Click(Sender: TObject);
    procedure Button14Click(Sender: TObject);
    procedure Button15Click(Sender: TObject);
    procedure Button16Click(Sender: TObject);
    procedure Button17Click(Sender: TObject);
    procedure ILDocumentImage1Progress(Sender        : TObject;
                                       Progress      : Smallint;
                                       PMessage      : String;
                                   var CancelProcess : Boolean);
    procedure Button18Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button27Click(Sender: TObject);
    procedure fAsTif1Click(Sender: TObject);
    procedure fAsGif1Click(Sender: TObject);
    procedure fAsJpg1Click(Sender: TObject);
    procedure fAsPng1Click(Sender: TObject);
    procedure fAsPcx1Click(Sender: TObject);
    procedure fAsBmp1Click(Sender: TObject);
    procedure fAsTga1Click(Sender: TObject);
    procedure sAsTif1Click(Sender: TObject);
    procedure sAsGif1Click(Sender: TObject);
    procedure sAsJpg1Click(Sender: TObject);
    procedure sAsPng1Click(Sender: TObject);
    procedure sAsPcx1Click(Sender: TObject);
    procedure sAsBmp1Click(Sender: TObject);
    procedure sAsTga1Click(Sender: TObject);
    procedure ScaleComboChange(Sender: TObject);
    procedure Copy1Click(Sender: TObject);
    procedure Paste1Click(Sender: TObject);
    procedure Cut1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure TiffComboChange(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure ILDocumentImage1Tag(Sender: TObject; iTag, iLen: Smallint;
      lValue: Longint; sStrData, iTagName: string; iReadOnly: Boolean;
      iPage: Smallint; var CancelProcess: Boolean);
    procedure Button6Click(Sender: TObject);
    procedure ComboBox2Change(Sender: TObject);
    procedure ComboBox3Change(Sender: TObject);
    procedure ComboBox4Change(Sender: TObject);
    procedure SpeedButton8Click(Sender: TObject);
    procedure SpeedButton9Click(Sender: TObject);
    procedure ILDocumentImage1Rubberband(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y, XX, YY: Integer);
    procedure Button4Click(Sender: TObject);
    procedure ImportFiles1Click(Sender: TObject);
    procedure ILDocumentImage1Info(Sender: TObject; im_Width,
      im_Height: Longint; im_BPP: Smallint; im_Size: Longint; im_TiffPages,
      im_TiffThisPage: Smallint; im_Compression: string;
      im_ByFile: Boolean; im_Filename: string);
    procedure BestFit1Click(Sender: TObject);
    procedure Mirror(Sender: TObject);
    procedure HowTo1Click(Sender: TObject);
    procedure Crop1Click(Sender: TObject);
    procedure PrintwithAnnotations1Click(Sender: TObject);
    procedure Print2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    DocumentStream : TMemoryStream;
    ShowOfStream : TMemoryStream;
    SaveScale : SmallInt;
    ScaleOption : TScaleToGray;
    UseTifFile : Boolean;
    WidthforZoom,
    HeightforZoom,
    writeresolution : Integer;
  end;


var
  DocuForm      : TDocuForm;

  
implementation

{$R *.DFM}


procedure TDocuForm.FormDestroy(Sender: TObject);
begin
    DocumentStream.Free;
    ShowOfStream.Free;
end;

{-----------------------------------------------------------------------------

-----------------------------------------------------------------------------}
procedure TDocuForm.FormCreate(Sender: TObject);
begin
     {Set the scale percent initial value}
     ILDocumentImage1.ScalePercent:=50;
     {Memory stream used to show of reaed and write to stream functions}
     DocumentStream :=TMemoryStream.Create;
     {Memory stream used to show of reaed and write to stream functions}
     ShowOfStream :=TMemoryStream.Create;
     {Set the Scale to gray initial to anti 16}
     ComboBox1.ItemIndex:=6;
     {Set the Scale to gray initial to anti 16}
     ScaleOption :=TScaleToGray(6);
     {Set the save to scale initial to 50 percent}
     SaveScale:=50;
     {Set the write resolution initial to 16 levels of gray (4 bit}
     writeresolution:=4;
     //@@@ ADDED
     ComboBox4.ItemIndex:=0;
end;

{-----------------------------------------------------------------------------

-----------------------------------------------------------------------------}
procedure TDocuForm.Button1Click(Sender: TObject);
begin
 SpinEdit2.Value:=1;
 SpinEdit3.Value:=1;
 try
  Screen.Cursor:=crHourGlass;

 {Open a tif file}
  if OpenDialog1.Execute then
    ILDocumentImage1.ReadTifFile(OpenDialog1.FileName,
                                 OpenDialog1.TiffSelectedPage, {Page}
                                 1);{resolution 1, 4,8,24}

 finally
  Screen.Cursor:=crDefault;
 end;
end;


{-----------------------------------------------------------------------------
What should we do with the doc file is this already exist
-----------------------------------------------------------------------------}
procedure TDocuForm.WriteTifOptions(Sender: TObject);
begin
   Label4.Visible:=False;
   InsertAtEdit.Visible:=False;

   {Append to the current tiff file}
   if TRadioButton(Sender) = AppendTiff then
      ILDocumentImage1.TifSaveOptions := tiffAppend;

   {Replace the current tif file}
   if TRadioButton(Sender) = OverwriteTiff then
      ILDocumentImage1.TifSaveOptions := tiffReplace;

   {Insert in the current tif file at position InsertAtEdit.Value-1}
   if TRadioButton(Sender) = InsertTiff then begin
      Label4.Visible:=True;
      InsertAtEdit.Visible:=True;
      ILDocumentImage1.TifSaveOptions := tiffInsert;
   end;
end;

{-----------------------------------------------------------------------------
If inserttif then insert at...
-----------------------------------------------------------------------------}
procedure TDocuForm.InsertAtEditChange(Sender: TObject);
begin
  ILDocumentImage1.TifInsertAt:=InsertAtEdit.Value-1;
end;


{-----------------------------------------------------------------------------
Scale the image according scale options in percent
-----------------------------------------------------------------------------}
procedure TDocuForm.ScaleComboChange(Sender: TObject);
var
 Sc : Double;
begin
try
  Screen.Cursor:=crHourGlass;
  if ScaleCombo.ItemIndex = -1 then begin
    Sc:=StrToFloat(ScaleCombo.Text);
    if Sc < 1 then sc :=ILDocumentImage1.ScalePercent;
    ILDocumentImage1.ScalePercent:=Sc;
   end else
    ILDocumentImage1.ScalePercent:=(ScaleCombo.ItemIndex+1) * 10;
 finally
  Screen.Cursor:=crDefault;
 end;
end;

{-----------------------------------------------------------------------------
Set write resolution
-----------------------------------------------------------------------------}

procedure TDocuForm.ComboBox4Change(Sender: TObject);
begin
 Case ComboBox4.ItemIndex of
  0:    begin
           ILDocumentImage1.ImageWriteRes:=sColor16;
           writeresolution:=4;
        end;
  1:    begin
           ILDocumentImage1.ImageWriteRes:=sColor256;
           writeresolution:=8;
        end;
  2:    begin
           ILDocumentImage1.ImageWriteRes:=sColorTrue;
           writeresolution:=24;
        end;
 end;
end;

{-----------------------------------------------------------------------------
Set grayscale for saving purposes
-----------------------------------------------------------------------------}
procedure TDocuForm.ComboBox2Change(Sender: TObject);
begin
   {When saving images use this to scale. }
   ScaleOption := TScaleToGray(ComboBox2.ItemIndex);
end;


{-----------------------------------------------------------------------------
Set scale for saving to stream/file purposes
-----------------------------------------------------------------------------}

procedure TDocuForm.ComboBox3Change(Sender: TObject);
var
 Sc : Double;
begin
try
  Screen.Cursor:=crHourGlass;
  if ComboBox3.ItemIndex = -1 then begin
    Sc:=StrToFloat(ComboBox3.Text);
    if Sc < 1 then sc :=ILDocumentImage1.ScalePercent;
    SaveScale:=Round(Sc);
   end else
    SaveScale:=(ComboBox3.ItemIndex+1) * 10;
 finally
  Screen.Cursor:=crDefault;
 end;
end;

{-----------------------------------------------------------------------------
  {Scale the image according scale options
-----------------------------------------------------------------------------}
procedure TDocuForm.ComboBox1Change(Sender: TObject);
begin
try
 Screen.Cursor:=crHourGlass;
{  'S_Gray_None'     No Scale to Gray
  'S_Gray_16_8'     8 neighbor pixels 16 levels of gray (4 bit image)
  'S_Gray_16_12'    12-neighbour pixels 16 levels of gray (4 bit image)
  'S_Gray_16_20'    20-neighbour pixels 16 levels of gray (4 bit image)
  'S_Gray_16_24'    24-neighbour pixels 16 levels of gray (4 bit image)
  'S_Gray_256_24'   24-neighbour pixels 256 levels of gray (8 bit image)
**'S_Gray_Anti_16'  16 gray antiailaising (4 bit image) (BEST CHOICE) **
  'S_Gray_Anti_256' 256 gray antiailaising (8 bit image)}

   ILDocumentImage1.ScaleDoc := TScaleToGray(ComboBox1.ItemIndex);

 finally
  Screen.Cursor:=crDefault;
 end;
end;

{-----------------------------------------------------------------------------

-----------------------------------------------------------------------------}
procedure TDocuForm.SpeedButton1Click(Sender: TObject);
begin
try
 Screen.Cursor:=crHourGlass;
 {Go to the first page in the tiff file or stream}
 ILDocumentImage1.First;

 finally
  Screen.Cursor:=crDefault;
 end;
end;

{-----------------------------------------------------------------------------

-----------------------------------------------------------------------------}
procedure TDocuForm.SpeedButton2Click(Sender: TObject);
begin
try
 Screen.Cursor:=crHourGlass;
 {Go to the prior page in the tiff file or stream}
 ILDocumentImage1.Prior;

 finally
  Screen.Cursor:=crDefault;
 end;
end;

{-----------------------------------------------------------------------------

-----------------------------------------------------------------------------}
procedure TDocuForm.SpeedButton3Click(Sender: TObject);
begin
try
 Screen.Cursor:=crHourGlass;
 {Go to the next page in the tiff file or stream}
 ILDocumentImage1.Next;

 finally
  Screen.Cursor:=crDefault;
 end;
end;

{-----------------------------------------------------------------------------

-----------------------------------------------------------------------------}
procedure TDocuForm.SpeedButton4Click(Sender: TObject);
begin
try
 Screen.Cursor:=crHourGlass;
 {Go to the last page in the tiff file or stream}
 ILDocumentImage1.Last;

 finally
  Screen.Cursor:=crDefault;
 end;
end;

{-----------------------------------------------------------------------------

-----------------------------------------------------------------------------}
procedure TDocuForm.SpeedButton5Click(Sender: TObject);
begin
try
 Screen.Cursor:=crHourGlass;
 {delete the current page from the tiff file or stream.
  Note, the page is marked for deletion. To actually
  delete marked pages call Pack}
  ILDocumentImage1.Delete;

 finally
  Screen.Cursor:=crDefault;
 end;
end;

{-----------------------------------------------------------------------------

-----------------------------------------------------------------------------}
procedure TDocuForm.SpeedButton6Click(Sender: TObject);
begin
try
 Screen.Cursor:=crHourGlass;
 {Update the current tiff page file or stream }
 {Note, the old page is marked for deletion and the new one
  is added with using the old page number. To actually
  delete marked pages call Pack}
  ILDocumentImage1.UpdateTiff;
 finally
  Screen.Cursor:=crDefault;
 end;
end;

{-----------------------------------------------------------------------------

-----------------------------------------------------------------------------}
procedure TDocuForm.SpeedButton7Click(Sender: TObject);
begin
try
 Screen.Cursor:=crHourGlass;
 {This will remove all marked for deletion tiffpages from the tiff
 file or stream. This could be a lengthy operation depending how many pages are
 subject for deletion}
 ILDocumentImage1.Pack;

 finally
  Screen.Cursor:=crDefault;
 end;
end;

{-----------------------------------------------------------------------------

-----------------------------------------------------------------------------}
procedure TDocuForm.Button11Click(Sender: TObject);
begin
try
 Screen.Cursor:=crHourGlass;

 {This will swap 2 pages with eachother}
 ILDocumentImage1.Swap( SpinEdit2.Value-1, SpinEdit3.Value-1);

 //This will move a page
 //ILDocumentImage1.MovePage( SpinEdit2.Value-1, SpinEdit3.Value-1);

 finally
  Screen.Cursor:=crDefault;
 end;
end;

{-----------------------------------------------------------------------------

-----------------------------------------------------------------------------}
procedure TDocuForm.Button13Click(Sender: TObject);
begin
try
 Screen.Cursor:=crHourGlass;
 {Rotate the current tif page. Call Update to post to tiff file or stream}
  ILDocumentImage1.Rotate(StrToFloat(RotateAngle.Text), {Angle}
                          clWhite); {Background color}
 finally
  Screen.Cursor:=crDefault;
 end;
end;

{-----------------------------------------------------------------------------

-----------------------------------------------------------------------------}
procedure TDocuForm.Button14Click(Sender: TObject);
begin
try
 Screen.Cursor:=crHourGlass;

 {Inverts the current tif page. Call Update to post to tiff file or stream}
 ILDocumentImage1.Invert;

 finally
  Screen.Cursor:=crDefault;
 end;
end;

{-----------------------------------------------------------------------------
 Find the deskew value and rotate the current tif page if needed.
  Note:  Call Update to post to tiff file or stream.
-----------------------------------------------------------------------------}
procedure TDocuForm.Button15Click(Sender: TObject);
begin
try
  Screen.Cursor:=crHourGlass;
  ILDocumentImage1.Deskew(0);
  {Deskew(0) 0 when Background color is white
             1 when Background color is Black}
 finally
  Screen.Cursor:=crDefault;
 end;
end;

{-----------------------------------------------------------------------------
Remove unwanted border
-----------------------------------------------------------------------------}
procedure TDocuForm.Button16Click(Sender: TObject);
begin
try
 Screen.Cursor:=crHourGlass;

 ILDocumentImage1.BorderRemove(250);

 finally
  Screen.Cursor:=crDefault;
 end;
end;

{-----------------------------------------------------------------------------
Scan # of pages
-----------------------------------------------------------------------------}
procedure TDocuForm.Button17Click(Sender: TObject);
begin
try
 Screen.Cursor:=crHourGlass;

 ILDocumentImage1.ScanPages(SpinEdit4.Value);

 finally
  Screen.Cursor:=crDefault;
 end;
end;

{-----------------------------------------------------------------------------

-----------------------------------------------------------------------------}

procedure TDocuForm.Button6Click(Sender: TObject);
begin
   SelectTwainSource(Handle);
end;

{-----------------------------------------------------------------------------

-----------------------------------------------------------------------------}

procedure TDocuForm.Button3Click(Sender: TObject);
begin
 try
  Screen.Cursor:=crHourGlass;

  ILDocumentImage1.ScanPagesToStream(SpinEdit4.Value, DocumentStream);

 finally
  Screen.Cursor:=crDefault;
 end;
end;

{-----------------------------------------------------------------------------

-----------------------------------------------------------------------------}
procedure TDocuForm.ILDocumentImage1Progress(Sender        : TObject;
                                             Progress      : Smallint;
                                             PMessage      : String;
                                         var CancelProcess : Boolean);
begin
    CancelProcess := Application.Terminated;

    {Set the message caption}
    StatusBar1.Panels[0].Text:='Status '+PMessage;

    {Process the First call}
    if Progress < 5  then begin
     ProgressBar1.Position:=0;
     Application.ProcessMessages;
    end;

    {Process the Last call}
    if Progress > 99  then begin
     ProgressBar1.Position:=Progress;
     {reset the message caption}
     StatusBar1.Panels[0].Text:='';
     Application.ProcessMessages;
    end;

    {Some speed improvement when only processing each fifth call}
    if Progress > ProgressBar1.Position+5 then begin
     ProgressBar1.Position:=Progress;
     Application.ProcessMessages;
    end;

end;

{-----------------------------------------------------------------------------
This shows how to read a tif into a memorystream
-----------------------------------------------------------------------------}
procedure TDocuForm.Button18Click(Sender: TObject);
begin
try
 Screen.Cursor:=crHourGlass;

 SpinEdit2.Value:=1;
 SpinEdit3.Value:=1;

 if OpenDialog1.Execute then begin
   {Open a tif stream}
    DocumentStream.LoadfromFile(OpenDialog1.FileName);
    ILDocumentImage1.ReadTifStream(DocumentStream,
                                   0, {Page}
                                   1);{resolution 1, 4,8,24}
 end;

 finally
  Screen.Cursor:=crDefault;
 end;
end;

{-----------------------------------------------------------------------------
This Saves the document stream (tiff) to a file
-----------------------------------------------------------------------------}
procedure TDocuForm.Button27Click(Sender: TObject);
begin
If (DocumentStream = nil) or (DocumentStream.Size < 1)then raise ErrorInvalid.Create(iNoStream);

try
 Screen.Cursor:=crHourGlass;

 SaveDialog1.Filter:='tif|*.tif';
 if SaveDialog1.Execute then
     DocumentStream.SaveToFile(SaveDialog1.FileName);

 finally
  Screen.Cursor:=crDefault;
 end;
end;

{-----------------------------------------------------------------------------
How to save the curren doc
-----------------------------------------------------------------------------}
procedure TDocuForm.fAsTif1Click(Sender: TObject);
begin
try
 Screen.Cursor:=crHourGlass;
 SaveDialog1.Filter:='tif|*.tif';
 if SaveDialog1.Execute then begin
     ILDocumentImage1.WriteTifFile(SaveDialog1.FileName,
                                   SaveScale,        //Scale size
                                   ScaleOption,      //What Sclae option to use
                                   writeresolution);{resolution 1, 4,8,24}
 end;
 finally
  Screen.Cursor:=crDefault;
 end;
end;

{-----------------------------------------------------------------------------
How to Save the document to a Gif File
-----------------------------------------------------------------------------}
procedure TDocuForm.fAsGif1Click(Sender: TObject);
begin
try
 Screen.Cursor:=crHourGlass;
 SaveDialog1.Filter:='gif|*.gif';
 if SaveDialog1.Execute then
    ILDocumentImage1.WriteGifFile(SaveDialog1.FileName,
                                  SaveScale,        //Scale size
                                  ScaleOption,      //What Sclae option to use
                                  writeresolution); {resolution 4,8,24}
 finally
  Screen.Cursor:=crDefault;
 end;
end;


{-----------------------------------------------------------------------------
How to Save the document to a Jpeg File
-----------------------------------------------------------------------------}
procedure TDocuForm.fAsJpg1Click(Sender: TObject);
begin
try
 Screen.Cursor:=crHourGlass;
 SaveDialog1.Filter:='jpg|*.jpg';
 if SaveDialog1.Execute then
    ILDocumentImage1.WriteJpgFile(SaveDialog1.FileName,
                                  SaveScale,        //Scale size
                                  ScaleOption,      //What Sclae option to use
                                  75,  {Quality 0 .. 100}
                                  5,   {Smooth 0 .. 100}
                                  writeresolution); {resolution 8,24 - 8 is gray scale}
 finally
  Screen.Cursor:=crDefault;
 end;
end;

{-----------------------------------------------------------------------------
How to Save the document to a Png File
-----------------------------------------------------------------------------}
procedure TDocuForm.fAsPng1Click(Sender: TObject);
begin
try
 Screen.Cursor:=crHourGlass;
 SaveDialog1.Filter:='png|*.png';
 if SaveDialog1.Execute then
    ILDocumentImage1.WritePngFile(SaveDialog1.FileName,
                                  SaveScale,        //Scale size
                                  ScaleOption,      //What Sclae option to use
                                  0,  {0 is normal, 1 is interlaced}
                                  writeresolution); {resolution 4,8,24}
 finally
  Screen.Cursor:=crDefault;
 end;
end;


{-----------------------------------------------------------------------------
How to Save the document to a Pcx File
-----------------------------------------------------------------------------}
procedure TDocuForm.fAsPcx1Click(Sender: TObject);
begin
try
 Screen.Cursor:=crHourGlass;
 SaveDialog1.Filter:='pcx|*.pcx';
 if SaveDialog1.Execute then
    ILDocumentImage1.WritePcxFile(SaveDialog1.FileName,
                                  SaveScale,
                                  ScaleOption,
                                  writeresolution);{resolution 4,8,24}
 finally
  Screen.Cursor:=crDefault;
 end;
end;

{-----------------------------------------------------------------------------
How to Save the document to a Bmp File
-----------------------------------------------------------------------------}
procedure TDocuForm.fAsBmp1Click(Sender: TObject);
begin
try
 Screen.Cursor:=crHourGlass;
 SaveDialog1.Filter:='bmp|*.bmp';
 if SaveDialog1.Execute then
    ILDocumentImage1.WriteBmpFile(SaveDialog1.FileName,
                                  SaveScale,
                                  ScaleOption,
                                  writeresolution);{resolution 4,8,24}
 finally
  Screen.Cursor:=crDefault;
 end;
end;

{-----------------------------------------------------------------------------
How to Save the document to a Tga File
-----------------------------------------------------------------------------}
procedure TDocuForm.fAsTga1Click(Sender: TObject);
begin
try
 Screen.Cursor:=crHourGlass;
 SaveDialog1.Filter:='tga|*.tga';
 if SaveDialog1.Execute then
    ILDocumentImage1.WriteTgaFile(SaveDialog1.FileName,
                                  SaveScale,
                                  ScaleOption,
                                  writeresolution);{resolution 4,8,24}
 finally
  Screen.Cursor:=crDefault;
 end;
end;


{-----------------------------------------------------------------------------
How to Save the document to a Eps File
-----------------------------------------------------------------------------}
{-----------------------------------------------------------------------------
This shows how to write a tif to a memorystream
-----------------------------------------------------------------------------}
procedure TDocuForm.sAsTif1Click(Sender: TObject);
begin
try
 Screen.Cursor:=crHourGlass;
 {We don't do any thing with this stream here but you could}
 ILDocumentImage1.WriteTifStream(DocumentStream,
                                 SaveScale,
                                 ScaleOption,
                                 writeresolution);

 finally
  Screen.Cursor:=crDefault;
 end;
end;

{-----------------------------------------------------------------------------
This shows how to write a Gif to a memorystream
-----------------------------------------------------------------------------}
procedure TDocuForm.sAsGif1Click(Sender: TObject);
begin
try
 Screen.Cursor:=crHourGlass;

    ILDocumentImage1.WriteGifStream(ShowOfStream,
                                    SaveScale,
                                    ScaleOption,
                                    writeresolution);
 finally
  Screen.Cursor:=crDefault;
 end;
end;

{-----------------------------------------------------------------------------
This shows how to write a Jpeg to a memorystream
-----------------------------------------------------------------------------}
procedure TDocuForm.sAsJpg1Click(Sender: TObject);
begin
try
 Screen.Cursor:=crHourGlass;

    ILDocumentImage1.WriteJpgStream(ShowOfStream,
                                    SaveScale,
                                    ScaleOption,
                                    75,  {Quality 0 .. 100}
                                    5,   {Smooth 0 .. 100}
                                    writeresolution); {resolution 8,24 - 8 is gray scale}
 finally
  Screen.Cursor:=crDefault;
 end;
end;


{-----------------------------------------------------------------------------
This shows how to write a Png to a memorystream
-----------------------------------------------------------------------------}
procedure TDocuForm.sAsPng1Click(Sender: TObject);
begin
try
 Screen.Cursor:=crHourGlass;

    ILDocumentImage1.WritePngStream(ShowOfStream,
                                    SaveScale,
                                    ScaleOption,
                                    0,  {0 is normal, 1 is interlaced}
                                    writeresolution); {resolution 4,8,24}
 finally
  Screen.Cursor:=crDefault;
 end;
end;

{-----------------------------------------------------------------------------
This shows how to write a Pcx to a memorystream
-----------------------------------------------------------------------------}
procedure TDocuForm.sAsPcx1Click(Sender: TObject);
begin
try
 Screen.Cursor:=crHourGlass;

    ILDocumentImage1.WritePcxStream(ShowOfStream,
                                    SaveScale,
                                    ScaleOption,
                                    writeresolution);{resolution 4,8,24}
 finally
  Screen.Cursor:=crDefault;
 end;
end;

{-----------------------------------------------------------------------------
This shows how to write a Bmp to a memorystream
-----------------------------------------------------------------------------}
procedure TDocuForm.sAsBmp1Click(Sender: TObject);
begin
try
 Screen.Cursor:=crHourGlass;

    ILDocumentImage1.WriteBmpStream(ShowOfStream,
                                    SaveScale,
                                    ScaleOption,
                                    writeresolution);{resolution 4,8,24}
 finally
  Screen.Cursor:=crDefault;
 end;
end;


{-----------------------------------------------------------------------------
This shows how to write a Tga to a memorystream
-----------------------------------------------------------------------------}
procedure TDocuForm.sAsTga1Click(Sender: TObject);
begin
try
 Screen.Cursor:=crHourGlass;

    ILDocumentImage1.WriteTgaStream(ShowOfStream,
                                    SaveScale,
                                    ScaleOption,
                                    writeresolution);{resolution 4,8,24}
 finally
  Screen.Cursor:=crDefault;
 end;
end;

{-----------------------------------------------------------------------------

-----------------------------------------------------------------------------}
procedure TDocuForm.Copy1Click(Sender: TObject);
begin
try
  Screen.Cursor:=crHourGlass;
  ILDocumentImage1.CopyToClipboard;
 finally
  Screen.Cursor:=crDefault;
 end;
end;

{-----------------------------------------------------------------------------

-----------------------------------------------------------------------------}

procedure TDocuForm.Paste1Click(Sender: TObject);
begin
try
  Screen.Cursor:=crHourGlass;
  ILDocumentImage1.PasteFromClipboard;
 finally
  Screen.Cursor:=crDefault;
 end;
end;

{-----------------------------------------------------------------------------

-----------------------------------------------------------------------------}

procedure TDocuForm.Cut1Click(Sender: TObject);
begin
try
  Screen.Cursor:=crHourGlass;
  ILDocumentImage1.CutToClipboard;
 finally
  Screen.Cursor:=crDefault;
 end;
end;

{-----------------------------------------------------------------------------

-----------------------------------------------------------------------------}

procedure TDocuForm.TiffComboChange(Sender: TObject);
begin
 {Set the compression method to save tiffs}
  if TiffCombo.Text ='NONE' then begin
    ILDocumentImage1.TifSaveCompress:=sNONE;
  end;

 if TiffCombo.Text ='CCITT' then begin
    ILDocumentImage1.TifSaveCompress:=sCCITT;
 end;

 if TiffCombo.Text ='FAXCCITT3' then begin
    ILDocumentImage1.TifSaveCompress:=sFAXCCITT3;
 end;

 if TiffCombo.Text ='FAXCCITT4' then begin
    ILDocumentImage1.TifSaveCompress:=sFAXCCITT4;
 end;

 if TiffCombo.Text ='LZW' then begin
    ILDocumentImage1.TifSaveCompress:=sLZW;
 end;

 if TiffCombo.Text ='PACKBITS' then begin
    ILDocumentImage1.TifSaveCompress:=sPACKBITS;
 end;
end;

{-----------------------------------------------------------------------------

-----------------------------------------------------------------------------}

procedure TDocuForm.Button5Click(Sender: TObject);
begin
//@@@
    ILDocumentImage1.HardDrawAnnotation;//Burn the annotations into the image
    ILDocumentImage1.ClearAnnotation;//Clear the existing on top annotations
    ILDocumentImage1.UpdateTiff;//Write the onscreen tif to the file
end;

{-----------------------------------------------------------------------------

-----------------------------------------------------------------------------}


procedure TDocuForm.Button7Click(Sender: TObject);
begin
     ILDocumentImage1.Edittags;
end;

{-----------------------------------------------------------------------------
This Event returns all tags from the tiff page. Do NOT try to write to a read only tag
unless you know what you are doing.
-----------------------------------------------------------------------------}
procedure TDocuForm.ILDocumentImage1Tag(Sender: TObject;
                                        iTag,              {Tag number}
                                        iLen: Smallint;    {Length of string sStrData}
                                        lValue: Longint;   {Integer value}
                                        sStrData,          {String Value}
                                        iTagName: string;  {Name of tag}
                                        iReadOnly: Boolean;{Can write back to tag}
                                        iPage: Smallint;   {What page is this tag for}
                                        var CancelProcess: Boolean); {Stop loading tags}
begin
{ You can write a tag back as follow:
 if Not iReadOnly then
  TDocuForm.writetag(iTag,           //Tag number
                     lValue,         //Integer value
                     sStrData);      //String value (Will be truncated when longer then orginal
}
end;

{-----------------------------------------------------------------------------
Write the X and Y Resolution to the tif file. Shows how to write tags using the enumerations
-----------------------------------------------------------------------------}
procedure TDocuForm.Button2Click(Sender: TObject);
var
  iLen:SmallInt;
  lValue:LongInt;
  sStrData:String;
begin
  iLen:=0;
  lValue:=0;
  ILDocumentImage1.ReadEnumTag(ilt_XRESOLUTION,iLen,lValue,sStrData);


  {TTifTagEnum, Numreric value, String Value}
 { ILDocumentImage1.WriteEnumTag(ilt_XRESOLUTION,300,'');
  ILDocumentImage1.WriteEnumTag(ilt_YRESOLUTION,400,'');
 }

  {
  TTifTagEnum = (ilt_NEWSUBFILETYPE,
                 ilt_FILETYPE,
                 ilt_IMAGEWIDTH,
                 ilt_IMAGELENGTH,
                 ilt_BITSPERSAMPLE,
                 ilt_COMPRESSION,
                 ilt_PHOTOMETRICINTERPRETATION,
                 ilt_THRESHHOLDING,
                 ilt_CELLWIDTH,
                 ilt_CELLLENGTH,
                 ilt_FILLORDER,
                 ilt_DOCUMENTNAME,
                 ilt_IMAGEDESCRIPTION,
                 ilt_MAKE,
                 ilt_MODEL,
                 ilt_STRIPOFFSETS,
                 ilt_ORIENTATION,
                 ilt_SAMPLESPERPIXEL,
                 ilt_ROWSPERSTRIP,
                 ilt_STRIPBYTECOUNTS,
                 ilt_MINIMUMVALUE,
                 ilt_MAXIMUMVALUE,
                 ilt_XRESOLUTION,
                 ilt_YRESOLUTION,
                 ilt_PLANARCONFIG,
                 ilt_PAGENAME,
                 ilt_XPOSITION,
                 ilt_YPOSITION,
                 ilt_FREEOFFSETS,
                 ilt_FREEBYTECOUNTS,
                 ilt_GRAYRESPONSEUNITS,
                 ilt_GRAYSCALERRESPONSE,
                 ilt_GROUP3OPTIONS,
                 ilt_GROUP4OPTIONS,
                 ilt_RESOLUTIONUNIT,
                 ilt_PAGENUMBER,
                 ilt_COLORRESPONSEUNIT,
                 ilt_COLORRESPONSECURVES,
                 ilt_SOFTWARE,
                 ilt_ARTIST,
                 ilt_PREDICTOR,
                 ilt_COLORMAP,
                 ilt_COPYRIGHT);
}
end;

{-----------------------------------------------------------------------------

-----------------------------------------------------------------------------}

procedure TDocuForm.SpeedButton8Click(Sender: TObject);
begin
    ILDocumentImage1.EditAnnotat := SpeedButton8.Down;
end;

{-----------------------------------------------------------------------------
  (*Switch between panning and zooming. Note: Zooming in document imaging will take
  more time then in other ImageLib components because it actually create a new
  reside grayscale image*)
-----------------------------------------------------------------------------}
procedure TDocuForm.SpeedButton9Click(Sender: TObject);
begin
   if SpeedButton9.Down then begin
      SpeedButton9.Caption:='Panning';
   end else begin
      SpeedButton9.Caption:='Zooming';
   end;
   ILDocumentImage1.AllowRubberBand := not SpeedButton9.Down;
end;

{-----------------------------------------------------------------------------
//Here is where the actual zoom takes place
-----------------------------------------------------------------------------}

procedure TDocuForm.ILDocumentImage1Rubberband(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y, XX, YY: Integer);
begin
    Screen.Cursor:=crHourglass;
    ILDocumentImage1.ZoomArea(Rect(X,Y,XX,YY));
    Screen.Cursor:=crDefault;
end;

{-----------------------------------------------------------------------------

-----------------------------------------------------------------------------}

procedure TDocuForm.Button4Click(Sender: TObject);
begin
   ILDocumentImage1.Scrolling := not ILDocumentImage1.Scrolling
end;

{-----------------------------------------------------------------------------
This will import Jpg, Gif, Pcx, Pcd, Tga and Bmp into the docimage component
-----------------------------------------------------------------------------}
procedure TDocuForm.ImportFiles1Click(Sender: TObject);
begin
 OpenDialog1.Filter:='Jpg, Gif, Pcx, Pcd, Tga and Bmp |*.Jpg;*.Gif;*.Pcx;*.Pcd;*.Tga;*.Bmp';
 try
   if OpenDialog1.Execute then
    ILDocumentImage1.ImportFile(OpenDialog1.FileName,
                                lAutoMatic, //resolution
                                False); //Dither

  finally
   OpenDialog1.Filter:='tif|*.tif';
  end;
end;

{-----------------------------------------------------------------------------
This event is fired by the get info method
-----------------------------------------------------------------------------}
procedure TDocuForm.ILDocumentImage1Info(Sender: TObject;
                                         im_Width,            {Width of the image}
                                         im_Height: Longint;  {Heigth of the image}
                                         im_BPP: Smallint;    {Bits per pixel}
                                         im_Size: Longint;    {Size of the whole file or stream}
                                         im_TiffPages,        {How many tif pages in file or stream}
                                         im_TiffThisPage: Smallint;{Which Tiff page we are viewing}
                                         im_Compression: string;{Whats the current page compression}
                                         im_ByFile: Boolean;  {True if using file, false when stream}
                                         im_Filename: string);{Whats the file name}
begin
     {are we using by file or by stream}
     UseTifFile := im_ByFile;
     {Set the swap spin edits max values}
     SpinEdit2.MaxValue:=im_TiffPages;
     SpinEdit3.MaxValue:=im_TiffPages;
     {Set the caption to the doc image info}
     Caption:='Page '+IntToStr(im_TiffThisPage+1)+
              ' of '+IntToStr(im_TiffPages)+' Pages '+
              im_Filename+' '+im_Compression+' W:'+IntToStr(im_Width)+
              ' H:'+IntToStr(im_Height)+' Bpp:'+IntToStr(im_Bpp);
    WidthforZoom :=  im_Width ;
    HeightforZoom :=  im_Height ;
end;

{-------------------------------------------------------------------

-------------------------------------------------------------------}
procedure TDocuForm.BestFit1Click(Sender: TObject);
var
   StorageforWidth : Double;
begin
    StorageforWidth := (ILDocumentImage1.Width  * 100) / WidthforZoom ;
    ILDocumentImage1.ScalePercent := (ILDocumentImage1.Height  * 100)/ HeightforZoom ;
    if (StorageforWidth < ILDocumentImage1.ScalePercent) then
        ILDocumentImage1.ScalePercent := StorageforWidth;
    ILDocumentImage1.ZoomArea(Rect(1,1,WidthforZoom ,HeightforZoom ));
end;

{-------------------------------------------------------------------

-------------------------------------------------------------------}
procedure TDocuForm.Mirror(Sender: TObject);
begin
    if TMenuItem(Sender) = Horizontal1 then ILDocumentImage1.Mirror(False, True);
    if TMenuItem(Sender) = Vertical1 then ILDocumentImage1.Mirror(True, False);
    if TMenuItem(Sender) = HorzVert1 then ILDocumentImage1.Mirror(True, True);
end;
{-------------------------------------------------------------------

-------------------------------------------------------------------}

procedure TDocuForm.HowTo1Click(Sender: TObject);
Var
  HDib    : THandle;
  X, iLen : Integer;
  ClrPtr  : PByte;
  Bit0,
  Bit1,
  Bit2,
  Bit3,
  Bit4,
  Bit5,
  Bit6,
  Bit7 : Byte;
  NumberOfBlackPixels : Longint;
begin
  NumberOfBlackPixels:=0;
  HDib:=ILDocumentImage1.GetOurDib;
  if HDib = 0 then raise ErrorInvalid.Create(EmpyInput);

  if Assigned(ILDocumentImage1.ILDibClass.DibBitmap) then begin
     if ILDocumentImage1.ILDibClass.Bits = 1 then begin

       ClrPtr:=ILDocumentImage1.ILDibClass.ptrBits;

       iLen := ((ILDocumentImage1.ILDibClass.Width + 31) div 32) * 4;

       iLen := iLen * ILDocumentImage1.ILDibClass.Height;

       for x:=0 to iLen do begin
          ClrPtr^:= not ClrPtr^;
          // This can be used to access each bit
          //
          //  ClrPtr = Byte containing 8 bits
          //        _______________
          //       |0|1|2|3|4|5|6|7|
          //       ----------------
          //We don't do anything with the bits here but you could
          Bit0 := (ClrPtr^) shr 7 and ($01); //Bit0 0 is black 1 is white
          Bit1 := (ClrPtr^) shr 6 and ($01); //Bit1 0 is black 1 is white
          Bit2 := (ClrPtr^) shr 5 and ($01); //Bit2 0 is black 1 is white
          Bit3 := (ClrPtr^) shr 4 and ($01); //Bit3 0 is black 1 is white
          Bit4 := (ClrPtr^) shr 3 and ($01); //Bit4 0 is black 1 is white
          Bit5 := (ClrPtr^) shr 2 and ($01); //Bit5 0 is black 1 is white
          Bit6 := (ClrPtr^) shr 1 and ($01); //Bit6 0 is black 1 is white
          Bit7 := (ClrPtr^) and ($01);       //Bit7 0 is black 1 is white

          Inc(ClrPtr);
       end;

     end else InvertDib(HDib);

     ILDocumentImage1.ScaleDoc := TScaleToGray(ComboBox1.ItemIndex);
  end;

end;


(*-------------------------------------------------------------------
function CopyCropDib (Handle    : THandle;
                      NWidth,               {New width}
                      NHeight,              {New height}
                      CropX,                {Crop x}
                      CropY,                {Crop y}
                      CropWidth,            {Crop width}
                      CropHeight : Integer; {Crop height}
                      CopyFlags  : BWCopyFlags) : THandle;
-------------------------------------------------------------------*)
procedure TDocuForm.Crop1Click(Sender: TObject);
Var
  NewDib, HDib    : THandle;
begin
  HDib:=ILDocumentImage1.GetOurDib;
  if HDib = 0 then raise ErrorInvalid.Create(EmpyInput);
  NewDib:=0;
  if Assigned(ILDocumentImage1.ILDibClass.DibBitmap) then begin

    NewDib:=CopyCropDib(HDib,
                        ILDocumentImage1.ILDibClass.Width - 20, //Total - 20 pixels
                        ILDocumentImage1.ILDibClass.Height - 20, //Total - 20 pixels
                        10,//Cut of 10 pixels
                        10,//Cut of 10 pixels
                        ILDocumentImage1.ILDibClass.Width-10,//Cut of 10 pixels
                        ILDocumentImage1.ILDibClass.Height-10,//Cut of 10 pixels
                        [C_DEL]);
    if NewDib <> 0 then
      ILDocumentImage1.ILDibClass.DibBitmap:=GlobalLock(NewDib);
  end;
  ILDocumentImage1.ScaleDoc := TScaleToGray(ComboBox1.ItemIndex);
end;

(*-------------------------------------------------------------------
//Print doc with annotations
procedure ILDocumentImage.PrintDOCAnno(X,                   X Position
                                       Y,                   Y Position
                                       pWidth,              Width of the image
                                       pHeight,             Heigth of the image
                                       BitDepth : Integer); BitDepth 1,4,8,24 bits
                                                           (BitDepth = ignored when image is >1 bit)
-------------------------------------------------------------------*)
procedure TDocuForm.PrintwithAnnotations1Click(Sender: TObject);
begin
     ILDocumentImage1.PrintDOCAnno(0,
                                   0,
                                   Printer.PageWidth,
                                   Printer.Pageheight,
                                   4);
end;

(*-------------------------------------------------------------------
//Print doc with annotations
procedure ILDocumentImage.PrintDOC(X,                   X Position
                                   Y,                   Y Position
                                   pWidth,              Width of the image
                                   pHeight: Integer);   Heigth of the image
-------------------------------------------------------------------*)
procedure TDocuForm.Print2Click(Sender: TObject);
begin
     ILDocumentImage1.PrintDOC(0,
                               0,
                               Printer.PageWidth,
                               Printer.Pageheight);
end;

end.




