(*/////////////////////////////////////////////////////////////////////////////
//                                                                           //
//   Part of Imagelib VCL/DLL Library Corporate Suite 4.0                    //
//                                                                           //
//   All rights reserved. (c) Copyright 1995, 1996, 1997, 1998.              //
//   SkyLine Tools a division by Creative Development LTD.                   //
//                                                                           //
//   Created by: Jan Dekkers,                                                //
//               Jillian Pinsker,                                            //
//               Reginald Armond,                                            //
//               Che-Chern Lin,                                              //
//               Alex Zitser,                                                //
//               Charles Ye,                                                 //
//               Song Han,                                                   //
//               Vitaly Bondarenko,                                          //
//               Jane Scarano,                                               //
//               Misha Popov;                                                //
//                                                                           //
//   and many others who provided feedback, gave tips and comments.          //
//                                                                           //
//   Call 1-800 404-3832  or 1-818 346-4200 to order ImageLib Corp. Suite.   //
//                                                                           //
/////////////////////////////////////////////////////////////////////////////*)

unit Mmblob;

{Includes settings to compile in either 16 or 32 bit}
{$I DEFILIB.INC}

interface

uses
   {$IFDEF DEL32}
     Windows,
   {$ELSE}
     WinTypes,
     WinProcs,
   {$ENDIF}
     DLL96V1,    {ImageLib Dll interface and misc. functions}
     Classes,
     Graphics,
     Forms,
     Controls,
     Buttons,
     StdCtrls,
     ExtCtrls,
     MPlayer,
     DB,
     DBTables,
     DBCtrls,
     SysUtils,
     Dialogs,
     Mask,
     TDMULTIM, {PDBMultiMedia1 VCL component}
     MMOpen,
     ildbmmtb,
     ComCtrls;

type
  TMMBlobForm = class(TForm)
    CancelBtn: TBitBtn;
    DataSource1: TDataSource;
    Table1: TTable;
    DBNavigator1: TDBNavigator;
    OpenDialog1: TMMOpenDialog;
    BitBtn1: TBitBtn;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    OpenDialog2: TMMOpenDialog;
    BitBtn2: TBitBtn;
    DBEdit1: TDBEdit;
    DBEdit2: TDBEdit;
    DBMemo1: TDBMemo;
    BitBtn3: TBitBtn;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    BitBtn4: TBitBtn;
    ScrollBar1: TScrollBar;
    Panel1: TPanel;
    BitBtn5: TBitBtn;
    Panel2: TPanel;
    BitBtn6: TBitBtn;
    PrintDialog1: TPrintDialog;
    BitBtn7: TBitBtn;
    BitBtn8: TBitBtn;
    DBMediaPlayer1: TPDBMediaPlayer;
    DBMultiMedia1: TPDBMultiMedia;
    ILDBMultiMediaToolBar1: TILDBMultiMediaToolBar;
    StatusBar1: TStatusBar;
    ProgressBar1: TProgressBar;
    procedure CancelBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure CheckBox4Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure DataSource1DataChange(Sender: TObject; Field: TField);
    procedure ScrollBar1Change(Sender: TObject);
    procedure BitBtn5Click(Sender: TObject);
    procedure BitBtn6Click(Sender: TObject);
    procedure BitBtn7Click(Sender: TObject);
    procedure BitBtn8Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure DBMultiMedia1Progress(Sender        : TObject;
                                    Progress      : Smallint;
                                    PMessage      : String;
                                var CancelProcess : Boolean);
    procedure ILDBMultiMediaToolBar1BeforeAction(Sender: TObject;
      Button: TILDBMultiMediaToolBarBtn; var Process: Boolean);
    procedure DBMultiMedia1Rubberband(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y, XX, YY: Integer);
  private
    Procedure Trigger(Sender : TObject; Var Done : Boolean);
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MMBlobForm: TMMBlobForm;

implementation

{$R *.DFM}
{---------------------------------------------------------------------}

procedure TMMBlobForm.CancelBtnClick(Sender: TObject);
begin
{close the app}
 close;
end;
{---------------------------------------------------------------------}

procedure TMMBlobForm.DBMultiMedia1Progress(Sender        : TObject;
                                            Progress      : Smallint;
                                            PMessage      : String;
                                        var CancelProcess : Boolean);

begin
    CancelProcess := Application.Terminated;

    {Process the First call}
    if Progress = 0  then begin
     ProgressBar1.Position:=0;
     Application.ProcessMessages;
    end;

    {Process the Last call}
    if Progress > 99  then begin
     ProgressBar1.Position:=Progress;
    {Set the message caption}
     StatusBar1.Panels[0].Text := '';
     Application.ProcessMessages;
     exit;
    end;

    {Some speed improvement when only processing each fifth call}
    if Progress > ProgressBar1.Position+5 then begin
     ProgressBar1.Position:=Progress;
     {Set the message caption}
     StatusBar1.Panels[0].Text:='Status '+PMessage;
     Application.ProcessMessages;
    end;
end;

{---------------------------------------------------------------------}

procedure TMMBlobForm.FormCreate(Sender: TObject);
begin
    {init label caption with file type}
    Panel1.Caption:=DBMultiMedia1.BFiletype;

    {init label caption with file size}
    Panel2.Caption:=IntToStr(DBMultiMedia1.Bsize)+ ' bytes';

    {On/Off Play the multimedia automatically}
    DBMultiMedia1.AutoPlayMultiMedia:=CheckBox1.Checked;

    {On/Off Hide the DBMediaPlayer Automatically if MM is present}
    DBMultiMedia1.AutoHideMediaPlayer:=CheckBox2.Checked;

    {On/Off RePlay the multimedia automatically}
    DBMultiMedia1.AutoRePlayMultiMedia:=CheckBox4.Checked;

    {On/Off Display the multimedia automatically}
    DBMultiMedia1.AutoDisplay:=CheckBox3.Checked;

    If FileExists(ExtractFilePath(Application.ExeName)+'mmblob.dbf') then begin
       {if the table exists open it on creation}
       Table1.DataBaseName:=ExtractFilePath(Application.ExeName);
       Table1.TableName:='mmblob.dbf';
       Table1.Active:=True;
       {Show or hide the append/replace button, depending on
       the table active stasus}
       BitBtn7.Enabled:=Table1.Active;
       BitBtn4.Enabled:=Table1.Active;
       BitBtn3.Enabled:=Table1.Active;
       BitBtn1.Enabled:=Table1.Active;
     end;

   {IMPORTANT}
    {This is the moving engine for all the messages. Since an application
    can have only one OnIdle Trigger, this trigger needs to be subdivided
    by all your moving and animated objects. In this particular case the
    function is called TRIGGER but you can name it as you want as long
    you have a procedure named the same.}

    Application.OnIdle:=Trigger;
 end;
{---------------------------------------------------------------------}

Procedure TMMBlobForm.Trigger(Sender : TObject; Var Done : Boolean);
begin
    {IMPORTANT}
   {This function is called when your app is idle. Subdivide the
    trigger event to your TDBMultiMedia objects who may need one.
    If no Message is active it will not take up significant time}
    DBMultiMedia1.Trigger;
end;
{---------------------------------------------------------------------}

procedure TMMBlobForm.BitBtn1Click(Sender: TObject);
begin
  {fill the OpenDialog filter with the MM extensions as found in the win.ini
   (This means that the appropriate drivers are installed)}
  OpenDialog1.filter:=GetMultiMediaExtensions;

  {Execute the open dialog box}
  if OpenDialog1.Execute then begin

    {Place the Database in append mode}
    Table1.Append;

    {Load the Multimedia into the Blob}
    DBMultiMedia1.LoadfromFile(OpenDialog1.FileName);

    {Post that thing}
    Table1.Post;
  end;
end;
{---------------------------------------------------------------------}

procedure TMMBlobForm.BitBtn3Click(Sender: TObject);
begin
  {fill the OpenDialog filter with the MM extensions as found in the win.ini
   (This means that the appropriate drivers are installed)}
  OpenDialog1.filter:=GetMultiMediaExtensions;

  {Execute the open dialog box}
  if OpenDialog1.Execute then begin

    {Place the Database in edit mode}
    Table1.Edit;

    {Load the Multimedia into the Blob}
    DBMultiMedia1.LoadfromFile(OpenDialog1.FileName);

    {Post that thing}
    Table1.Post;
  end;
end;
{---------------------------------------------------------------------}

procedure TMMBlobForm.CheckBox1Click(Sender: TObject);
begin
     {Play the appropriate multimedi when there}
     DBMultiMedia1.AutoPlayMultiMedia:=CheckBox1.Checked;
end;
{---------------------------------------------------------------------}

procedure TMMBlobForm.CheckBox2Click(Sender: TObject);
begin
    {On/Off Hide the DBMediaPlayer Automatically if MM is present}
     DBMultiMedia1.AutoHideMediaPlayer:=CheckBox2.Checked;

    if (Panel1.Caption = 'MID') or (Panel1.Caption = 'RMI') or (Panel1.Caption = 'WAV') then
    {hide blob window if no media needs to be display and auto hide is on}
     DBMultiMedia1.Visible:= not CheckBox2.Checked;
end;
{---------------------------------------------------------------------}

procedure TMMBlobForm.CheckBox3Click(Sender: TObject);
begin
    {On/Off Display the multimedia automatically}
     DBMultiMedia1.AutoDisplay:=CheckBox3.Checked;
end;
{---------------------------------------------------------------------}

procedure TMMBlobForm.CheckBox4Click(Sender: TObject);
begin
    {On/Off RePlay the multimedia automatically}
    DBMultiMedia1.AutoRePlayMultiMedia:=CheckBox4.Checked;
end;
{---------------------------------------------------------------------}

procedure TMMBlobForm.BitBtn2Click(Sender: TObject);
begin
{open the table}
 try
      If OpenDialog2.execute then begin
        Table1.Active:=False;
        Table1.DataBaseName:=ExtractFilePath(OpenDialog2.FileName);
        Table1.TableName:=OpenDialog2.FileName;
        Table1.Active:=True;
      end;
 finally
        {Show or hide the append/replace button, depending on
        the table active status}
        BitBtn7.Enabled:=Table1.Active;
        BitBtn4.Enabled:=Table1.Active;
        BitBtn3.Enabled:=Table1.Active;
        BitBtn1.Enabled:=Table1.Active;
 end;
end;
{---------------------------------------------------------------------}

procedure TMMBlobForm.BitBtn4Click(Sender: TObject);
begin
    {Place the Database in append mode}
    Table1.Append;
    {Create a New Message}
    If DBMultiMedia1.CreateMessage then
    {Post or cancel that thing}
       Table1.Post
    else
       Table1.Cancel;
end;
{---------------------------------------------------------------------}

procedure TMMBlobForm.BitBtn7Click(Sender: TObject);
begin
    {Place the Database in append mode}
    Table1.Append;
    {Create a New Credit Message}
    If DBMultiMedia1.CreateCreditMessage then
    {Post or cancel that thing}
       Table1.Post
    else
       Table1.Cancel;
  end;
{---------------------------------------------------------------------}

procedure TMMBlobForm.DataSource1DataChange(Sender: TObject; Field: TField);
var
   temp : string;
begin
  {Show or hide the scroll bar}
  ScrollBar1.Visible:=(DBMultiMedia1.BFiletype = 'SCM') or (DBMultiMedia1.BFiletype = 'CMS');

  {Syncronize the scrollbar's position}
  ScrollBar1.Position:=DBMultiMedia1.MsgSpeed;

   {Set the blob window to visible}
    DBMultiMedia1.Visible:=true;

    {Set the Video display rectangle to the rectangle of the blob window}
    DBMediaPlayer1.DisplayRect:=Rect(0,0,DBMultiMedia1.Width,DBMultiMedia1.Height);

    {Set the Video display to the the display of the blob window}
    DBMediaPlayer1.Display:=DBMultiMedia1;

    {init label caption with file type}
    Panel1.Caption:=DBMultiMedia1.BFiletype;

    {init label caption with file size}
    Panel2.Caption:=IntToStr(DBMultiMedia1.Bsize)+ ' bytes';

    {Get file type of blob stored}
    temp:=DBMultiMedia1.BFiletype;

    {Show print button only when image is there}
    BitBtn6.Enabled:= (DBMultiMedia1.Picture.Graphic <> nil);

    {Enable the next line. Just to show of (Play message if blob is a RMI file}
    {if temp = 'RMI' then BitBtn5Click(Sender);}

    {Enable the next line. Just to show of (Play message if blob is a MIDI file}
    {if temp = 'MID' then BitBtn8Click(Sender);}


    if (temp = 'MID') or (temp = 'RMI') or (temp = 'WAV') then
    {hide blob window if no media needs to be display and auto hide is on}
    DBMultiMedia1.Visible:=not CheckBox2.Checked;

end;
{---------------------------------------------------------------------}

procedure TMMBlobForm.ScrollBar1Change(Sender: TObject);
begin
  {Set message speed 1(fast) to 10(slow)}
  DBMultiMedia1.MsgSpeed:=ScrollBar1.Position;
end;
{---------------------------------------------------------------------}

procedure TMMBlobForm.BitBtn5Click(Sender: TObject);
begin
begin
   {create a message on the fly without actualy storing the message in the blob
   At any time you can play this message}
   {set Message text}
    DBMultiMedia1.MsgText:='Isn''t super to be a Delphi programmer ?? '+
    'Delphi is too Cool and so is every one who''s using VCL''s !! ';
    {set Message font name;  Note you could do this also with a font dialog}
    DBMultiMedia1.MsgFont.Name:='Arial';
   {set Message font size}
    DBMultiMedia1.MsgFont.Size:=-30;
    {set Message font style}
    DBMultiMedia1.MsgFont.Style:=[fsItalic];
    {set Message font color}
    DBMultiMedia1.MsgFont.Color:=clWhite;
    {set Message background. Note you could do this also with a color dialog}
    DBMultiMedia1.MsgBkGrnd:=clTeal;
    {set Message speed from 0 is fast to 10 is slow}
    DBMultiMedia1.MsgSpeed:=0;
    {show the speed control scroll bar}
    ScrollBar1.Visible:=True;
    {Set position according speed}
    ScrollBar1.Position:=DBMultiMedia1.MsgSpeed;
    {inititiate new message}
    DBMultiMedia1.NewMessage;
  end;
end;
{---------------------------------------------------------------------}

procedure TMMBlobForm.BitBtn6Click(Sender: TObject);
begin
{print image x y width and heigth (if width and heigth are 0 the image
original size is printed)}
 If PrintDialog1.Execute then
  DBMultiMedia1.PrintMultiImage(0,0,0,0);
end;
{---------------------------------------------------------------------}

procedure TMMBlobForm.BitBtn8Click(Sender: TObject);
begin
   {Create A credit message on the fly}
    DBMultiMedia1.FreeMsg(True);
   {Clear Message text if any}
    DBMultiMedia1.CreditBoxList.Clear;
   {Define Message text}
    DBMultiMedia1.CreditBoxList.Add(' ImageLib');
    DBMultiMedia1.CreditBoxList.Add(' Another fine product of');
    DBMultiMedia1.CreditBoxList.Add(' SKYLINE TOOLS');
    DBMultiMedia1.CreditBoxList.Add(' Programming : Jan Dekkers');
    DBMultiMedia1.CreditBoxList.Add(' Artwork & PR: Jillian Pinsker');

    {set Message font name;  Note you could do this also with a font dialog}
    DBMultiMedia1.MsgFont.Name:='Arial';
   {set Message font size}
    DBMultiMedia1.MsgFont.Size:=-14;
    {set Message font style}
    DBMultiMedia1.MsgFont.Style:=[fsbold];
    {set Message font color}
    DBMultiMedia1.MsgFont.Color:=clWhite;
    {set Message background. Note you could do this also with a color dialog}
    DBMultiMedia1.MsgBkGrnd:=clNavy;
    {set Message speed from 1 is fast to 10 is slow}
    DBMultiMedia1.MsgSpeed:=5;
    {Show Speed ScrollBar}
    DBMultiMedia1.Visible:=true;
    {set the speed/position}
    ScrollBar1.Position:=DBMultiMedia1.MsgSpeed;
    {inititiate new message}
    DBMultiMedia1.NewCreditMessage;
end;
{---------------------------------------------------------------------}

{---------------------------------------------------------------------}


procedure TMMBlobForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
    Application.OnIdle:=Nil;
    MMBlobForm:=Nil;
    Action:=caFree;
end;


procedure TMMBlobForm.ILDBMultiMediaToolBar1BeforeAction(Sender: TObject;
  Button: TILDBMultiMediaToolBarBtn; var Process: Boolean);
begin
     if Button = ibdbmOpen then Table1.Append;
end;

procedure TMMBlobForm.DBMultiMedia1Rubberband(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y, XX, YY: Integer);
begin
  DBMultiMedia1.ZoomArea(Rect(X,Y,XX,YY));
end;

end.


 