(*/////////////////////////////////////////////////////////////////////////////
//                                                                           //
//   Part of Imagelib VCL/DLL Library Corporate Suite 4.0                    //
//                                                                           //
//   All rights reserved. (c) Copyright 1995, 1996, 1997, 1998.              //
//   SkyLine Tools a division by Creative Development LTD.                   //
//                                                                           //
//   Created by: Jan Dekkers,                                                //
//               Jillian Pinsker,                                            //
//               Reginald Armond,                                            //
//               Che-Chern Lin,                                              //
//               Alex Zitser,                                                //
//               Charles Ye,                                                 //
//               Song Han,                                                   //
//               Vitaly Bondarenko,                                          //
//               Jane Scarano,                                               //
//               Misha Popov;                                                //
//                                                                           //
//   and many others who provided feedback, gave tips and comments.          //
//                                                                           //
//   Call 1-800 404-3832  or 1-818 346-4200 to order ImageLib Corp. Suite.   //
//                                                                           //
/////////////////////////////////////////////////////////////////////////////*)

unit Qunit1;

interface

{Includes settings to compile in either 16 or 32 bit}
{$I DEFILIB.INC}

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, DLL96V1, TMultiP, StdCtrls, Buttons, Spin, ExtCtrls,
  DllSP96, Specials, MMOpen;

type
  TSpecialAddon = class(TForm)
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    SpinEdit1: TSpinEdit;
    BitBtn3: TBitBtn;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    BitBtn4: TBitBtn;
    BitBtn5: TBitBtn;
    SpinEdit2: TSpinEdit;
    BitBtn6: TBitBtn;
    SpinEdit3: TSpinEdit;
    BitBtn7: TBitBtn;
    BitBtn8: TBitBtn;
    R1: TRadioButton;
    R2: TRadioButton;
    R3: TRadioButton;
    R4: TRadioButton;
    SpinEdit4: TSpinEdit;
    BitBtn16: TBitBtn;
    Timer1: TTimer;
    Label1: TLabel;
    GroupBox1: TGroupBox;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    RadioButton4: TRadioButton;
    RadioButton5: TRadioButton;
    RadioButton6: TRadioButton;
    SpinEdit5: TSpinEdit;
    Label2: TLabel;
    SpinEdit6: TSpinEdit;
    Label3: TLabel;
    Button1: TButton;
    PMultiImage2: TPMultiImage;
    OpenDialog1: TMMOpenDialog;
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure BitBtn5Click(Sender: TObject);
    procedure BitBtn6Click(Sender: TObject);
    procedure BitBtn8Click(Sender: TObject);
    procedure BitBtn7Click(Sender: TObject);
    procedure PMultiimage2Rubberband(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y, XX, YY: Integer);
    procedure BitBtn16Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FXRadioClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  SpecialAddon : TSpecialAddon;




implementation

{$R *.DFM}

{---------------------------------------------------------------------}
procedure TSpecialAddon.BitBtn1Click(Sender: TObject);
begin
  if OpenDialog1.execute then begin
    PMultiImage2.ImageName:=OpenDialog1.Filename;
  end;
end;
{---------------------------------------------------------------------}

procedure TSpecialAddon.BitBtn2Click(Sender: TObject);
begin
     PMultiImage2.RotateImageDegree(0,0,0,0,Spinedit1.Value);
end;
{---------------------------------------------------------------------}
procedure TSpecialAddon.BitBtn3Click(Sender: TObject);
begin
     PMultiImage2.Mirror(CheckBox1.Checked, CheckBox2.Checked);
end;
{---------------------------------------------------------------------}
procedure TSpecialAddon.BitBtn4Click(Sender: TObject);
begin
     PMultiImage2.Invert;
end;
{---------------------------------------------------------------------}
procedure TSpecialAddon.BitBtn5Click(Sender: TObject);
begin
     PMultiImage2.SetBright(SpinEdit2.Value);
end;
{---------------------------------------------------------------------}
procedure TSpecialAddon.BitBtn6Click(Sender: TObject);
begin
     PMultiImage2.SetGamma(SpinEdit3.Value);
end;
{---------------------------------------------------------------------}
procedure TSpecialAddon.BitBtn7Click(Sender: TObject);
begin
     PMultiImage2.InCreaseColors(8);
end;
{---------------------------------------------------------------------}
procedure TSpecialAddon.BitBtn8Click(Sender: TObject);
begin
    if R1.Checked then
     PMultiImage2.ReduceDither:=IL_BAYER else
    if R2.Checked then
     PMultiImage2.ReduceDither:= IL_BURKES else
    if R3.Checked then
     PMultiImage2.ReduceDither:= IL_FLOYD else
    if R4.Checked then
     PMultiImage2.ReduceDither:=IL_GRAYSCALE;

    PMultiImage2.ReduceColors(SpinEdit4.Value);
end;
{---------------------------------------------------------------------}
procedure TSpecialAddon.PMultiimage2Rubberband(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y, XX, YY: Integer);
begin
     if ssShift in Shift then
       PMultiImage2.CropCopy(x,y,xx,yy,0,0);

     if ssCTRL in Shift then
      PMultiImage2.RotateImageDegree(x,y,xx,yy, Spinedit1.Value);

     if ssALT in Shift then
      PMultiImage2.ZoomArea(Rect(x,y,xx,yy));
end;
{---------------------------------------------------------------------}
procedure TSpecialAddon.BitBtn16Click(Sender: TObject);
begin
     PMultiImage2.UndoImage;
end;
{---------------------------------------------------------------------}
procedure TSpecialAddon.Timer1Timer(Sender: TObject);
begin
     BitBtn16.Enabled:=HasUndo;
end;
{---------------------------------------------------------------------}
procedure TSpecialAddon.FXRadioClick(Sender: TObject);
begin
   if RadioButton1.Checked then
     PMultiImage2.FXMethod := FXNone
   else
   if RadioButton2.Checked then
     PMultiImage2.FXMethod := FXHorizontal
   else
   if RadioButton3.Checked then
     PMultiImage2.FXMethod := FXVertical
   else
   if RadioButton4.Checked then
     PMultiImage2.FXMethod := FXDiagonal
   else
   if RadioButton5.Checked then
     PMultiImage2.FXMethod := FXDiagonalSquares
   else
   if RadioButton6.Checked then
     PMultiImage2.FXMethod := FXRectangles;

   PMultiImage2.FXDelay:=SpinEdit5.Value;

   PMultiImage2.FXColRowThick:=SpinEdit6.Value;
end;
{---------------------------------------------------------------------}

procedure TSpecialAddon.Button1Click(Sender: TObject);
begin
    ISpecials:=TISpecials.Create(Self);
    ISpecials.MultiImage1.Picture.Bitmap.Assign(PMultiImage2.Picture.Bitmap);
    ISpecials.ShowModal;
    ISpecials.Free;
end;

{---------------------------------------------------------------------}

end.


