(*/////////////////////////////////////////////////////////////////////////////
//                                                                           //
//   Part of Imagelib VCL/DLL Library Corporate Suite 4.0                    //
//                                                                           //
//   All rights reserved. (c) Copyright 1995, 1996, 1997, 1998.              //
//   SkyLine Tools a division by Creative Development LTD.                   //
//                                                                           //
//   Created by: Jan Dekkers,                                                //
//               Jillian Pinsker,                                            //
//               Reginald Armond,                                            //
//               Che-Chern Lin,                                              //
//               Alex Zitser,                                                //
//               Charles Ye,                                                 //
//               Song Han,                                                   //
//               Vitaly Bondarenko,                                          //
//               Jane Scarano,                                               //
//               Misha Popov;                                                //
//                                                                           //
//   and many others who provided feedback, gave tips and comments.          //
//                                                                           //
//   Call 1-800 404-3832  or 1-818 346-4200 to order ImageLib Corp. Suite.   //
//                                                                           //
/////////////////////////////////////////////////////////////////////////////*)

unit Uabout;

{Includes settings to compile in either 16 or 32 bit}
{$I DEFILIB.INC}

interface

uses
{$IFDEF DEL32}
  Windows,
{$ELSE}
  WinTypes,
  WinProcs,
{$ENDIF}
  Classes,
  Graphics,
  Forms,
  Controls,
  StdCtrls,
  Buttons,
  ExtCtrls,
  sysutils,
  Tmultip;

type
  TAboutBox = class(TForm)
    Panel1: TPanel;
    Image1: TImage;
    Panel2: TPanel;
    Label7: TLabel;
    Label13: TLabel;
    Label10: TLabel;
    PMultiImage1  : TPMultiImage;
    Timer1 : TTimer;
    Label1: TLabel;
    procedure Timer1Timer(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  AboutBox: TAboutBox;

implementation

{$R *.DFM}


procedure TAboutBox.Timer1Timer(Sender: TObject);
begin
	PMultiImage1.Trigger;
end;

procedure TAboutBox.FormHide(Sender: TObject);
begin
	 Timer1.Enabled := False;
end;


procedure TAboutBox.FormShow(Sender: TObject);
begin
	 Timer1.Enabled := True;
end;


procedure TAboutBox.FormActivate(Sender: TObject);
begin
   {Create A credit message on the fly}
    PMultiImage1.FreeMsg(True);
   {Clear Message text if any}
    PMultiImage1.CreditBoxList.Clear;
   {Define Message text}
    PMultiImage1.CreditBoxList.Add(' ImageLib Corporate Suite 3.0');
    PMultiImage1.CreditBoxList.Add(' All rights reserved. (c) Copyright 1995, 1996, 1997.');
    PMultiImage1.CreditBoxList.Add(' SkyLine Tools a division by Creative Development LTD.');
    PMultiImage1.CreditBoxList.Add(' Written by:');
    PMultiImage1.CreditBoxList.Add(' Jan Dekkers,');
    PMultiImage1.CreditBoxList.Add(' Reginald Armond,');
    PMultiImage1.CreditBoxList.Add(' Alex Zitser,');
    PMultiImage1.CreditBoxList.Add(' Misha Popov,');
    PMultiImage1.CreditBoxList.Add(' Charles Ye,');
    PMultiImage1.CreditBoxList.Add(' Song Han,');
    PMultiImage1.CreditBoxList.Add(' Jillian Pinsker,');
    PMultiImage1.CreditBoxList.Add(' Vitaly Bondarenko,');
    PMultiImage1.CreditBoxList.Add(' Jane Scarano,');
    PMultiImage1.CreditBoxList.Add(' Che-Chern Lin.');
    PMultiImage1.CreditBoxList.Add(' and many others who provided feedback, gave tips and comments.');
    PMultiImage1.CreditBoxList.Add(' Call 1-800 404-3832  or 1-818 766-3900 to order ImageLib Corp. Suite.');
    PMultiImage1.CreditBoxList.Add(' Another fine product of');
    PMultiImage1.CreditBoxList.Add(' SKYLINE TOOLS');
    {set Message font name;  Note you could do this also with a font dialog}
    PMultiImage1.MsgFont.Name := 'Arial';
   {set Message font size}
    PMultiImage1.MsgFont.Size := -12;
   {set Message speed from 0 is fast to 10 is slow}
    PMultiImage1.MsgSpeed := 0;
   {set Message background. Note you could do this also with a color dialog}
    PMultiImage1.MsgBkGrnd := clBlack;
    {font color}
    PMultiImage1.MsgFont.Color := clWhite;
   {SUBMIT THE MESSAGE}
    PMultiImage1.NewCreditMessage;
    Label1.Caption:='Version Build: '+FloatToStr(PMultiImage1.Version);
end;

end.







