(*/////////////////////////////////////////////////////////////////////////////
//                                                                           //
//   Part of Imagelib VCL/DLL Library Corporate Suite 4.0                    //
//                                                                           //
//   All rights reserved. (c) Copyright 1995, 1996, 1997, 1998.              //
//   SkyLine Tools a division by Creative Development LTD.                   //
//                                                                           //
//   Created by: Jan Dekkers,                                                //
//               Jillian Pinsker,                                            //
//               Reginald Armond,                                            //
//               Che-Chern Lin,                                              //
//               Alex Zitser,                                                //
//               Charles Ye,                                                 //
//               Song Han,                                                   //
//               Vitaly Bondarenko,                                          //
//               Jane Scarano,                                               //
//               Misha Popov;                                                //
//                                                                           //
//   and many others who provided feedback, gave tips and comments.          //
//                                                                           //
//   Call 1-800 404-3832  or 1-818 346-4200 to order ImageLib Corp. Suite.   //
//                                                                           //
/////////////////////////////////////////////////////////////////////////////*)

unit uannota;

{$X+,I-,R-,F+,T-}   {<<<<  This is a switch. Don't delete it}

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  ComCtrls,
  ILDocImg,
  Buttons,
  ExtCtrls,
  StdCtrls,
  Dllsp96,
  ColorGrd,
  Spin, MMOpen;

type
  TAnno_In_Code = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton5: TSpeedButton;
    SpeedButton6: TSpeedButton;
    SpeedButton7: TSpeedButton;
    SpeedButton8: TSpeedButton;
    SpeedButton9: TSpeedButton;
    SpeedButton10: TSpeedButton;
    SpeedButton11: TSpeedButton;
    SpeedButton12: TSpeedButton;
    SpeedButton13: TSpeedButton;
    SpeedButton14: TSpeedButton;
    ILDocumentImage1: ILDocumentImage;
    StatusBar1: TStatusBar;
    OpenDialog1: TMMOpenDialog;
    ComboBox1: TComboBox;
    ScaleCombo: TComboBox;
    SpeedButton15: TSpeedButton;
    ColorGrid1: TColorGrid;
    SpinEdit1: TSpinEdit;
    CheckBox1: TCheckBox;
    SpeedButton4: TSpeedButton;
    procedure SpeedButton1Click(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure ScaleComboChange(Sender: TObject);
    procedure SpeedButton15Click(Sender: TObject);
    procedure ILDocumentImage1Rubberband(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y, XX, YY: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Anno_In_Code: TAnno_In_Code;

implementation

{$R *.DFM}

procedure TAnno_In_Code.FormResize(Sender: TObject);
begin
     ILDocumentImage1.Refresh;
end;


procedure TAnno_In_Code.SpeedButton1Click(Sender: TObject);
begin
 try
  Screen.Cursor:=crHourGlass;

 {Open a tif file}
  if OpenDialog1.Execute then
    ILDocumentImage1.ReadTifFile(OpenDialog1.FileName,
                                 0, {Page}
                                 1);{resolution 1, 4,8,24}

 finally
  Screen.Cursor:=crDefault;
 end;
end;

{-----------------------------------------------------------------------------
  {Scale the image according scale options
-----------------------------------------------------------------------------}
procedure TAnno_In_Code.ComboBox1Change(Sender: TObject);
begin
try
 Screen.Cursor:=crHourGlass;
 {'S_Gray_None'     No Scale to Gray
  'S_Gray_16_8'     8 neighbor pixels 16 levels of gray (4 bit image)
  'S_Gray_16_12'    12-neighbour pixels 16 levels of gray (4 bit image)
  'S_Gray_16_20'    20-neighbour pixels 16 levels of gray (4 bit image)
  'S_Gray_16_24'    24-neighbour pixels 16 levels of gray (4 bit image)
  'S_Gray_256_24'   24-neighbour pixels 256 levels of gray (8 bit image)
**'S_Gray_Anti_16'  16 gray antiailaising (4 bit image) (BEST CHOICE) **
  'S_Gray_Anti_256' 256 gray antiailaising (8 bit image)}

   ILDocumentImage1.ScaleDoc := TScaleToGray(ComboBox1.ItemIndex);
 finally
  Screen.Cursor:=crDefault;
 end;
end;

{-----------------------------------------------------------------------------
Scale the image according scale options in percent
-----------------------------------------------------------------------------}
procedure TAnno_In_Code.ScaleComboChange(Sender: TObject);
var
 Sc : Double;
begin
try
  Screen.Cursor:=crHourGlass;
  if ScaleCombo.ItemIndex = -1 then begin
    Sc:=StrToFloat(ScaleCombo.Text);
    if Sc < 1 then sc :=ILDocumentImage1.ScalePercent;
    ILDocumentImage1.ScalePercent:=Sc;
   end else
    ILDocumentImage1.ScalePercent:=(ScaleCombo.ItemIndex+1) * 10;
 finally
  Screen.Cursor:=crDefault;
 end;
end;

{-----------------------------------------------------------------------------

-----------------------------------------------------------------------------}
procedure TAnno_In_Code.SpeedButton15Click(Sender: TObject);
begin
     ILDocumentImage1.EditAnnotat := SpeedButton4.Down;
     
     if TSpeedButton(Sender) = SpeedButton15 then begin
      ILDocumentImage1.Cursor := crDefault;
      ILDocumentImage1.AllowRubberBand:=False;
     end else begin
      ILDocumentImage1.Cursor := crIBeam;
      ILDocumentImage1.AllowRubberBand:=True;
     end;
end;

{-----------------------------------------------------------------------------

-----------------------------------------------------------------------------}
procedure TAnno_In_Code.ILDocumentImage1Rubberband(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y, XX, YY: Integer);
var
 aWidth,
 aHeight,
 Scaled_x,
 Scaled_y : Single;
 taWidth,
 taHeight,
 tScaled_x,
 tScaled_y : Single;
 aFillMode,
 aPattern,
 aPenWidth,
 aPenStyle : Integer;
 aImageName : Array[0..255] of Char;
 NumPoints : longint;
 Xs, Ys : array[0..25] of longint;
 i : longint;
 a : real;
 tX, tY : integer;

begin
 a := (ILDocumentImage1.ScalePercent / 100);
 Scaled_x := x / a;
 Scaled_y := y / a;
 aWidth   := (xx - x) / a;
 aHeight  := (yy - y) / a;

 aPenWidth:=5;
 aPenStyle:=PS_SOLID;
 aFillMode:=Transparent; //Opaque; //


 tX := x;
 tY := y;

 if x > xx then begin
   x := xx;
   xx := tX;
 end;

 if y > yy then begin
   y := yy;
   yy := tY;
 end;

 tScaled_x := x / a;
 tScaled_y := y / a;
 taWidth   := (xx - x) / a;
 taHeight  := (yy - y) / a;

 NumPoints := 5 + longint ( random(20) );

 for i := 0 to NumPoints-1 do begin
    Xs[i] := Round(tScaled_x) + Random(Round(taWidth));
    Ys[i] := Round(tScaled_y) + Random(Round(taHeight));
 end;


 if CheckBox1.Checked then
  aPattern :=100
 else
  aPattern :=SpinEdit1.Value;

 StrPCopy(aImageName, ExtractFilePath(Application.ExeName) + '\Sjef.jpg');

 if SpeedButton13.Down then
     ILDocumentImage1.CreateRectangle(Round(Scaled_x),
                                      Round(Scaled_y),
                                      Round(aWidth),
                                      Round(aHeight),
                                      aPenWidth,
                                      aPenStyle,
                                      aFillMode,
                                      aPattern,
                                      ColorToRGB(ColorGrid1.ForegroundColor),
                                      ColorToRGB(ColorGrid1.BackgroundColor));
 if SpeedButton2.Down then
     ILDocumentImage1.CreateEllipse(Round(Scaled_x),
                                    Round(Scaled_y),
                                    Round(aWidth),
                                    Round(aHeight),
                                    aPenWidth,
                                    aPenStyle,
                                    aFillMode,
                                    aPattern,
                                    ColorToRGB(ColorGrid1.ForegroundColor),
                                    ColorToRGB(ColorGrid1.BackgroundColor));

 if SpeedButton3.Down then
     ILDocumentImage1.CreateHilite(Round(Scaled_x),
                                   Round(Scaled_y),
                                   Round(aWidth),
                                   Round(aHeight),
                                   ColorToRGB(ColorGrid1.ForegroundColor));

 if SpeedButton11.Down then
     ILDocumentImage1.CreateLine(Round(Scaled_x),
                                 Round(Scaled_y),
                                 Round(Scaled_x) + Round(aWidth),
                                 Round(Scaled_y) + Round(aHeight),
                                 aPenWidth,
                                 aPenStyle,
                                 ColorToRGB(ColorGrid1.ForegroundColor));

 if SpeedButton10.Down then
     ILDocumentImage1.CreatePointer(Round(Scaled_x),
                                    Round(Scaled_y),
                                    Round(Scaled_x) + Round(aWidth),
                                    Round(Scaled_y) + Round(aHeight),
                                    aPenWidth,
                                    aPenStyle,
                                    ColorToRGB(ColorGrid1.ForegroundColor));

 if SpeedButton12.Down then
     ILDocumentImage1.CreatePolyline(@Xs,
                                     @Ys,
                                     NumPoints,
                                     aPenWidth,
                                     aPenStyle,
                                     ColorToRGB(ColorGrid1.ForegroundColor));

 if SpeedButton14.Down then
     ILDocumentImage1.CreatePolygon(@Xs,
                                    @Ys,
                                    NumPoints,
                                    aPenWidth,
                                    aPenStyle,
                                    aFillMode,
                                    aPattern,
                                    ColorToRGB(ColorGrid1.ForegroundColor),
                                    ColorToRGB(ColorGrid1.BackgroundColor));


 if SpeedButton9.Down then
   ILDocumentImage1.CreateFreehand( @Xs ,
                                    @Ys,
                                    NumPoints, // Number of Points
                                    aPenWidth,
                                    aPenStyle,
                                    ColorToRGB(ColorGrid1.ForegroundColor));

 if SpeedButton8.Down then
     ILDocumentImage1.CreateImage(Round(Scaled_x),
                                  Round(Scaled_y),
                                  Round(aWidth),
                                  Round(aHeight),
                                  ColorToRGB(ColorGrid1.BackgroundColor),
                                  aImageName);

 if SpeedButton7.Down then
    ILDocumentImage1.CreateLabel('Some text here',
                                  Round(Scaled_x),
                                  Round(Scaled_y),
                                  Round(aWidth),
                                  Round(aHeight),
                                  ColorToRGB(ColorGrid1.ForegroundColor),
                                  ColorToRGB(ColorGrid1.BackgroundColor),
                                  ColorToRGB(clNavy),
                                  'Arial',
                                  24);

 if SpeedButton6.Down then
    ILDocumentImage1.CreateNotes('Some text here',
                                  Round(Scaled_x),
                                  Round(Scaled_y),
                                  Round(aWidth),
                                  Round(aHeight),
                                  ColorToRGB(ColorGrid1.ForegroundColor),
                                  ColorToRGB(ColorGrid1.BackgroundColor),
                                  ColorToRGB(clNavy),
                                  'System',
                                  16);



 if SpeedButton5.Down then
     ILDocumentImage1.CreateStamp(Round(Scaled_x),
                                  Round(Scaled_y),
                                  'ACCEPTED');


end;

end.
