(*/////////////////////////////////////////////////////////////////////////////
//                                                                           //
//   Part of Imagelib VCL/DLL Library Corporate Suite 4.0                    //
//                                                                           //
//   All rights reserved. (c) Copyright 1995, 1996, 1997, 1998.              //
//   SkyLine Tools a division by Creative Development LTD.                   //
//                                                                           //
//   Created by: Jan Dekkers,                                                //
//               Jillian Pinsker,                                            //
//               Reginald Armond,                                            //
//               Che-Chern Lin,                                              //
//               Alex Zitser,                                                //
//               Charles Ye,                                                 //
//               Song Han,                                                   //
//               Vitaly Bondarenko,                                          //
//               Jane Scarano,                                               //
//               Misha Popov;                                                //
//                                                                           //
//   and many others who provided feedback, gave tips and comments.          //
//                                                                           //
//   Call 1-800 404-3832  or 1-818 346-4200 to order ImageLib Corp. Suite.   //
//                                                                           //
/////////////////////////////////////////////////////////////////////////////*)

unit Ublob;

{Includes settings to compile in either 16 or 32 bit}
{$I DEFILIB.INC}

interface

uses
{$IFDEF DEL32}
  Windows,
{$ELSE}
  WinTypes,
  WinProcs,
{$ENDIF}
  DLL96V1,    {ImageLib Dll interface and misc. functions}
  SysUtils,
  Messages,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  DB,
  DBTables,
  StdCtrls,
  ExtCtrls,
  DBCtrls,
  Mask, 
  Buttons,
  Clipbrd,
  Spin,
  U_p_size,
  Printers,
  Ufullscr,
  UAbout,
  TDMULTIP,   {PDBMultiMedia1, PDBMultiImage VCL components}
  Preview,    {ThumbNail VCL component}
  Menus,
  MMOpen,
  DMIToolB,
  ComCtrls,
  ildbmitb,
  MMSave;

    
type
  TBlobForm1 = class(TForm)
    Table1              : TTable;
    DataSource1         : TDataSource;
    DBNavigator1        : TDBNavigator;
    DBEdit1             : TDBEdit;
    BitBtn1: TBitBtn;
    OpenDialog1: TMMOpenDialog;
    SaveDialog1: TMMSaveDialog;
    BitBtn2: TBitBtn;
    BitBtn4: TBitBtn;
    BitBtn5: TBitBtn;
    Timer1: TTimer;
    BitBtn6: TBitBtn;
    Edit1: TEdit;
    BitBtn3: TBitBtn;
    OpenDialog2: TOpenDialog;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Edit7: TEdit;
    Label7: TLabel;
    Edit8: TEdit;
    BitBtn7: TBitBtn;
    BitBtn8: TBitBtn;
    SaveDialog2: TMMSaveDialog;
    GroupBox3: TGroupBox;
    SpinEdit1: TSpinEdit;
    SpinEdit2: TSpinEdit;
    Label8: TLabel;
    Label9: TLabel;
    BitBtn9: TBitBtn;
    PrintDialog1: TPrintDialog;
    BitBtn11: TBitBtn;
    BitBtn12: TBitBtn;
    BitBtn13: TBitBtn;
    BitBtn14: TBitBtn;
    BitBtn15: TBitBtn;
    BitBtn16: TBitBtn;
    BitBtn10: TBitBtn;
    DBMultiImage1: TPDBMultiImage;
    BitBtn20: TBitBtn;
    BitBtn21: TBitBtn;
    ThumbPreview1: TThumbPreview;
    PopupMenu1: TPopupMenu;
    R1: TMenuItem;
    R2: TMenuItem;
    R3: TMenuItem;
    R4: TMenuItem;
    Label10: TLabel;
    Edit9: TEdit;
    BitBtn22: TBitBtn;
    Panel2: TPanel;
    Tiffpage: TLabel;
    Label11: TLabel;
    Panel1: TPanel;
    TPageEdit: TSpinEdit;
    TiffCombo: TComboBox;
    CheckBox1: TCheckBox;
    StatusBar1: TStatusBar;
    ProgressBar1: TProgressBar;
    ILDBMultiImageToolBar1: TILDBMultiImageToolBar;
    UpDateCombo: TComboBox;
    Label12: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure DataSource1DataChange(Sender: TObject; Field: TField);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure ResolutionClick(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure BitBtn5Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure BitBtn6Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn7Click(Sender: TObject);
    procedure BitBtn8Click(Sender: TObject);
    procedure SpinEdit2Change(Sender: TObject);
    procedure SpinEdit1Change(Sender: TObject);
    procedure BitBtn9Click(Sender: TObject);
    procedure BitBtn11Click(Sender: TObject);
    procedure BitBtn12Click(Sender: TObject);
    procedure BitBtn13Click(Sender: TObject);
    procedure BitBtn14Click(Sender: TObject);
    procedure BitBtn15Click(Sender: TObject);
    procedure BitBtn16Click(Sender: TObject);
    procedure BitBtn10Click(Sender: TObject);
    procedure BitBtn20Click(Sender: TObject);
    procedure BitBtn21Click(Sender: TObject);
    procedure DBNavigator1Click(Sender: TObject; Button: TNavigateBtn);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BitBtn22Click(Sender: TObject);
    procedure TiffComboChange(Sender: TObject);
    procedure TPageEditChange(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure DBMultiImage1Progress(Sender        : TObject;
                                    Progress      : Smallint;
                                    PMessage      : String;
                                var CancelProcess : Boolean);
    procedure UpDateComboChange(Sender: TObject);
  private
    { Private declarations }
    Procedure Trigger(Sender : TObject; Var Done : Boolean);
  public
    { Public declarations }
  end;

var
  BlobForm1: TBlobForm1;

implementation


procedure TBlobForm1.DBMultiImage1Progress(Sender        : TObject;
                                           Progress      : Smallint;
                                           PMessage      : String;
                                       var CancelProcess : Boolean);
begin
    CancelProcess := Application.Terminated;
    {Process the First call}
    if Progress = 0  then begin
     ProgressBar1.Position:=0;
     Application.ProcessMessages;
    end;

    {Process the Last call}
    if Progress > 99  then begin
     ProgressBar1.Position:=Progress;
    {Set the message caption}
     StatusBar1.Panels[0].Text := '';
     Application.ProcessMessages;
     exit;
    end;

    {Some speed improvement when only processing each fifth call}
    if Progress > ProgressBar1.Position+5 then begin
     ProgressBar1.Position:=Progress;
     {Set the message caption}
     StatusBar1.Panels[0].Text:='Status '+PMessage;
     Application.ProcessMessages;
    end;
end;

{---------------------------------------------------------------------}

{$R *.DFM}
procedure TBlobForm1.FormCreate(Sender: TObject);
begin
 Printersize:=TPrintersize.Create(Application);
 {Is Autodisplay Initial on or off}
 {If the image data is changed save the blob to a jpeg or Bmp blob}
 {DBMultiImage1.UpdateAsJpg:=RadioButton4.Checked;}
 {set the values of teh spin edit controls to the values of the vcl}
 SpinEdit2.Value:=DBMultiImage1.JPegSaveSmooth;
 SpinEdit1.Value:=DBMultiImage1.JPegSaveQuality;

 If FileExists(ExtractFilePath(Application.ExeName)+'JPSTAMP.DBF') then begin
   {if the table exists open it on creation}
   Table1.DataBaseName:=ExtractFilePath(Application.ExeName);
   Table1.TableName:='JPSTAMP.DBF';
   Table1.Active:=True;
   {Table1.Last;}
 end;


 {IMPORTANT
 This is the moving engine for all the messages. Since an applcation
 can have only one OnIdle Trigger, this trigger needs to be subdivided
   by all your moving and animated objects. In this particular case the
 function is called TRIGGER but you can name it as you want as long
 you have a procedure named the same.}

  Application.OnIdle:=Trigger;


  UpDateCombo.ItemIndex:=Ord(TBlobUpDate(DBMultiImage1.BlobUpdate));
end;
{---------------------------------------------------------------------}

Procedure TBlobForm1.Trigger(Sender : TObject; Var Done : Boolean);
begin
 {IMPORTANT}
 {This function is called when your app is idle. Subdivide the
  trigger event to your TDBMultiImage objects who may need one.
  If no Message is active it will not take up significant time}

  DBMultiImage1.Trigger;
end;
{---------------------------------------------------------------------}


procedure TBlobForm1.DataSource1DataChange(Sender: TObject; Field: TField);
begin
 {Reset the Gauge}
 ProgressBar1.Position:=0;

 {If DBMultiImage1.autodisplay = false then get the blob info
  manually else the vcl will do it automatically}
  If not DBMultiImage1.autodisplay then DBMultiImage1.GetInfoAndType;

 {Show the user the blob info}
  Edit1.text:='This blob image is a '+DBMultiImage1.BFiletype;
  Edit2.text:=IntToStr(DBMultiImage1.Bwidth);
  Edit3.text:=IntToStr(DBMultiImage1.BHeight);
  Edit4.text:=IntToStr(DBMultiImage1.Bbitspixel);
  Edit5.text:=IntToStr(DBMultiImage1.Bplanes);
  Edit6.text:=IntToStr(DBMultiImage1.Bnumcolors);
  Edit7.text:=DBMultiImage1.Bcompression;
  Edit8.text:=IntToStr(DBMultiImage1.BSize)+ ' bytes';
  Edit9.Text:=IntToStr(DBMultiImage1.BTiffPages);
end;
{---------------------------------------------------------------------}

procedure TBlobForm1.BitBtn1Click(Sender: TObject);
begin
 {load a image file in the current blob using Thumbnail previews}
 ThumbPreview1.PreviewsDir:=ExtractFilePath(Application.Exename);
 ThumbPreview1.DataFileDir:=ExtractFilePath(Application.Exename);
 If ThumbPreview1.Execute Then begin
   {Place table in edit mode}
   Table1.Edit;
   {Load the image from file into the blob}
   DBMultiImage1.LoadFromFile(ThumbPreview1.FileName);
   {Post the blob}
   Table1.Post;
   {reset the gauge to 0}
   ProgressBar1.Position:=0;
 end;
end;
{---------------------------------------------------------------------}

procedure TBlobForm1.BitBtn2Click(Sender: TObject);
var temp : string;
begin
 {Save the current blob to a jpeg, pcx, gif or Bmp  file.  The SaveToFile
 will save it as stored in the blob. (no conversion is done here)
 Use SaveToFileAsBMP or SaveToFileAsJpeg to Convert to one another}

 {get the extension (filetype) of the stored blob}
 {GetInfoAndType returns the extension of the blob stored}
 if not table1.active then exit;
 temp:=DBMultiImage1.GetInfoAndType;

 if temp = 'GIF' then begin
 {set SaveDialog filter to display gif's only}
  SaveDialog1.filter:='GIF files|*.GIF';
  {set SaveDialog Default extension}
  SaveDialog1.DefaultExt:='GIF';
 end else

 if temp = 'PCX' then begin
 {set SaveDialog filter to display pcx's only}
  SaveDialog1.filter:='PCX files|*.PCX';
  {set SaveDialog Default extension}
  SaveDialog1.DefaultExt:='PCX';
 end else

 if temp = 'JPG' then begin
 {set SaveDialog filter to display jpeg's only}
  SaveDialog1.filter:='Jpeg files|*.JPG';
  {set SaveDialog Default extension}
  SaveDialog1.DefaultExt:='JPG';
 end else

 if temp = 'BMP' then begin
 {set SaveDialog filter to display bmp's only}
  SaveDialog1.filter:='BMP files|*.BMP';
  {set SaveDialog Default extension}
  SaveDialog1.DefaultExt:='BMP';
 end else

 if temp = 'TIF' then begin
 {set SaveDialog filter to display TIF's only}
  SaveDialog1.filter:='TIF files|*.TIF';
  {set SaveDialog Default extension}
  SaveDialog1.DefaultExt:='TIF';
 end else

 if temp = 'PCD' then begin
 {set SaveDialog filter to display PCD's only}
  SaveDialog1.filter:='PCD files|*.PCD';
  {set SaveDialog Default extension}
  SaveDialog1.DefaultExt:='PCD';
 end else

 if temp = 'EPS' then begin
 {set SaveDialog filter to display EPS's only}
  SaveDialog1.filter:='EPS files|*.EPS';
  {set SaveDialog Default extension}
  SaveDialog1.DefaultExt:='EPS';
 end else

 if temp = 'TGA' then begin
 {set SaveDialog filter to display TGA's only}
  SaveDialog1.filter:='TGA files|*.TGA';
  {set SaveDialog Default extension}
  SaveDialog1.DefaultExt:='TGA';
 end else

 if temp = 'DXF' then begin
 {set SaveDialog filter to display DXF's only}
  SaveDialog1.filter:='DXF files|*.DXF';
  {set SaveDialog Default extension}
  SaveDialog1.DefaultExt:='DXF';
 end;

 {save it to file as stored in blob}
 If SaveDialog1.Execute Then
   DBMultiImage1.SaveToFile(SaveDialog1.FileName);
 {reset the gauge to 0}
 ProgressBar1.Position:=0;
end;
{---------------------------------------------------------------------}


procedure TBlobForm1.ResolutionClick(Sender: TObject);
begin
 {Set resolution to dither the image}
 r1.checked:=False;
 r2.checked:=False;
 r3.checked:=False;
 r4.checked:=False;

 If TMenuItem(Sender) = R1 then begin
   {set save resolution to 4 bit 16 color using the system's colors}
    r1.checked:=true;
    DBMultiImage1.ImageReadRes:=lColor16;
    DBMultiImage1.ImageDither:=False;
 end;

 If TMenuItem(Sender) = R2 then begin
    {Set resolution to 256 colors}
    r2.checked:=true;
    DBMultiImage1.ImageReadRes:=lColor256;
    DBMultiImage1.ImageDither:=False;
 end;


 If TMenuItem(Sender) = R3 then begin
   {Set resolution to true color}
    r3.checked:=true;
    DBMultiImage1.ImageReadRes:=lColorTrue;
    DBMultiImage1.ImageDither:=False;
 end;

 If TMenuItem(Sender) = R4 then begin
   {Set resolution to systems resolution}
    r4.checked:=true;
    DBMultiImage1.ImageReadRes:=lAutomatic;
    DBMultiImage1.ImageDither:=False;
 end;

 {Reload the image }
 Table1.Refresh;

 {reset the gauge to 0}
 ProgressBar1.Position:=0;
end;
{---------------------------------------------------------------------}


procedure TBlobForm1.BitBtn4Click(Sender: TObject);
begin
  {Check to see if image is there}
  if DBMultiImage1.Picture.Bitmap <> nil then
   {Copy the image to the clipboard}
    DBMultiImage1.CopyToClipboard;
   {reset the gauge to 0}
   ProgressBar1.Position:=0;
end;
{---------------------------------------------------------------------}

procedure TBlobForm1.BitBtn5Click(Sender: TObject);
{Paste image from clipboard}
begin
   {does the clipboard has the right format?}
   if Clipboard.HasFormat(CF_PICTURE) then
   {Yep it does. Paste image from clipboard}
   DBMultiImage1.PastefromClipboard;

   {reset the gauge to 0}
   ProgressBar1.Position:=0;
end;
{---------------------------------------------------------------------}

procedure TBlobForm1.Timer1Timer(Sender: TObject);
begin
  {En/Disable Paste Button if clipboard has format}
  BitBtn5.Enabled:=Clipboard.HasFormat(CF_PICTURE);
  {Enable/disable certain buttons}
  {Button is only then enabled if table is active}
  BitBtn1.Enabled:=Table1.Active;
  {Button is only then enabled if table is active}
  BitBtn2.Enabled:=Table1.Active;
  {Button is only then enabled if table is active}
  BitBtn4.Enabled:=Table1.Active;
  {Button is only then enabled if table is active}
  BitBtn6.Enabled:=Table1.Active;
  {Button is only then enabled if table is active}
  BitBtn7.Enabled:=Table1.Active;
  {Button is only then enabled if table is active}
  BitBtn8.Enabled:=Table1.Active;
  {Button is only then enabled if table is active}
  BitBtn9.Enabled:=Table1.Active;
  {Button is only then enabled if table is active}
  BitBtn11.Enabled:=Table1.Active;
  {Button is only then enabled if table is active}
  BitBtn13.Enabled:=Table1.Active;
  {Tiff panel is only then visible when update as tiff is checked}
  Panel2.Visible:=(DBMultiImage1.BlobUpdate = bUpdateAsTIF) or (DBMultiImage1.BFileType='TIFF');
  {Box is only then visible if table is active and field is in edit state and update is in jpeg mode}
  GroupBox3.Visible:=Table1.Active and (DataSource1.State in [dsEdit, dsInsert]);
  {Box is only then visible if table is active and field is in edit state}
  CheckBox1.Visible:=True;
end;
{---------------------------------------------------------------------}

procedure TBlobForm1.BitBtn6Click(Sender: TObject);
begin
 {Append a record and store an image file into the blob}
 If OpenDialog1.Execute Then begin
   {Place table in edit mode}
   Table1.Append;
   {Load the image from file into the blob}
   DBMultiImage1.LoadFromFile(OpenDialog1.FileName);
   {Post the blob}
   Table1.Post;
   {reset the gauge to 0}
   ProgressBar1.Position:=0;
 end;
end;
{---------------------------------------------------------------------}

procedure TBlobForm1.BitBtn3Click(Sender: TObject);
begin
{open the table}
      If OpenDialog2.execute then begin
        Table1.Active:=False;
        Table1.DataBaseName:=ExtractFilePath(OpenDialog2.FileName);
        Table1.TableName:=OpenDialog2.FileName;
        Table1.Active:=True;
      end;
end;
{---------------------------------------------------------------------}

procedure TBlobForm1.BitBtn7Click(Sender: TObject);
 {save or convert the blob to a BMP file}
 {make sure that the blob is displayed before saving to file}
begin
  {set SaveDialog filter to display bmp's only}
  SaveDialog2.filter:='BMP files|*.BMP';

  {set SaveDialog Default extension}
  SaveDialog2.DefaultExt:='BMP';

  if SaveDialog2.Execute then
  {Save it}
  DBMultiImage1.SaveToFileAsBMP(SaveDialog2.Filename);

  {reset the gauge to 0}
  ProgressBar1.Position:=0;
end;
{---------------------------------------------------------------------}

procedure TBlobForm1.BitBtn8Click(Sender: TObject);
 {save or convert the blob to a Jpeg file}
 {make sure that the blob is displayed before saving to file}
begin
  {set SaveDialog filter to display jpeg's only}
  SaveDialog2.filter:='Jpeg files|*.JPG';

  {set SaveDialog Default extension}
  SaveDialog2.DefaultExt:='JPG';

  if SaveDialog2.Execute then
  {Save it}
  DBMultiImage1.SaveToFileAsJpg(SaveDialog2.Filename);

  {reset the gauge to 0}
  ProgressBar1.Position:=0;
end;
{---------------------------------------------------------------------}

procedure TBlobForm1.SpinEdit2Change(Sender: TObject);
begin
  {Set the smooth of the jpeg to save or upate a blob}
  DBMultiImage1.JPegSaveSmooth:=SpinEdit2.Value;
end;
{---------------------------------------------------------------------}

procedure TBlobForm1.SpinEdit1Change(Sender: TObject);
begin
  {Set the quality of the jpeg to save or upate a blob}
  DBMultiImage1.JPegSaveQuality:=SpinEdit1.Value;
end;
{---------------------------------------------------------------------}

procedure TBlobForm1.BitBtn9Click(Sender: TObject);
begin
  if PrintDialog1.execute then begin
  {Initialize the height spinedit of the printsize dialog box}
   Printersize.HeigthSpinEdit.Value:=DBMultiImage1.Picture.Height;
   {Initialize the width spinedit of the printsize dialog box}
   Printersize.WidthSpinEdit.Value:=DBMultiImage1.Picture.Width;
   {Show it}
   Printersize.ShowModal;
   if Printersize.Modalresult = mrok then

    {print TMultiImage}
     DBMultiImage1.PrintMultiImage(0,0,Printersize.WidthSpinEdit.Value,Printersize.HeigthSpinEdit.Value);

   {Hide it if done}
   Printersize.hide;
  end;
end;
{---------------------------------------------------------------------}

procedure TBlobForm1.BitBtn11Click(Sender: TObject);
begin
  {copy DB Blob image to fullscreen image}
  FullSlide.MultiImage1.Picture.Graphic:=DBMultiImage1.Picture.Graphic;
  {show the image fulscreen}
  FullSlide.showmodal;
end;
{---------------------------------------------------------------------}

procedure TBlobForm1.BitBtn12Click(Sender: TObject);
{about box}
begin
 AboutBox.showmodal;
end;
{---------------------------------------------------------------------}

procedure TBlobForm1.BitBtn13Click(Sender: TObject);
begin
    {Place the Database in append mode}
    Table1.Append;
    {Create a New Message}
    If DBMultiImage1.CreateMessage then
    {Post or cancel that thing}
      Table1.Post
    else
      Table1.Cancel;
end;
{---------------------------------------------------------------------}


procedure TBlobForm1.BitBtn14Click(Sender: TObject);
 {save or convert the blob to a GIF file}
 {make sure that the blob is displayed before saving to file}
begin
  {set SaveDialog filter to display bmp's only}
  SaveDialog2.filter:='GIF files|*.GIF';

  {set SaveDialog Default extension}
  SaveDialog2.DefaultExt:='GIF';

  if SaveDialog2.Execute then
  {Save it}
  DBMultiImage1.SaveToFileAsGIF(SaveDialog2.Filename);

  {reset the gauge to 0}
  ProgressBar1.Position:=0;
end;
{---------------------------------------------------------------------}

procedure TBlobForm1.BitBtn15Click(Sender: TObject);
 {save or convert the blob to a PCX file}
 {make sure that the blob is displayed before saving to file}
begin
  {set SaveDialog filter to display bmp's only}
  SaveDialog2.filter:='PCX files|*.PCX';

  {set SaveDialog Default extension}
  SaveDialog2.DefaultExt:='PCX';

  if SaveDialog2.Execute then
  {Save it}
  DBMultiImage1.SaveToFileAsBMP(SaveDialog2.Filename);

  {reset the gauge to 0}
  ProgressBar1.Position:=0;
end;
{---------------------------------------------------------------------}

procedure TBlobForm1.BitBtn16Click(Sender: TObject);
 {save or convert the blob to a PNG file}
 {make sure that the blob is displayed before saving to file}
begin
  {set SaveDialog filter to display bmp's only}
  SaveDialog2.filter:='PNG files|*.PNG';

  {set SaveDialog Default extension}
  SaveDialog2.DefaultExt:='PNG';

  if SaveDialog2.Execute then
  {Save it}
  DBMultiImage1.SaveToFileAsBMP(SaveDialog2.Filename);

  {reset the gauge to 0}
  ProgressBar1.Position:=0;
end;
{---------------------------------------------------------------------}

procedure TBlobForm1.BitBtn20Click(Sender: TObject);
 {save or convert the blob to a TIF file}
 {make sure that the blob is displayed before saving to file}
begin
  {set SaveDialog filter to display bmp's only}
  SaveDialog2.filter:='TIF files|*.TIF';

  {set SaveDialog Default extension}
  SaveDialog2.DefaultExt:='TIF';

  if SaveDialog2.Execute then
  {Save it}
  DBMultiImage1.SaveToFileAsTIF(SaveDialog2.Filename);

  {reset the gauge to 0}
  ProgressBar1.Position:=0;
end;
{---------------------------------------------------------------------}

procedure TBlobForm1.BitBtn10Click(Sender: TObject);
begin
    {Place the Database in append mode}
    Table1.Append;
    {Create a New Credit Message}
    If DBMultiImage1.CreateCreditMessage then
    {Post or cancel that thing}
      Table1.Post
    else
      Table1.Cancel;
end;
{---------------------------------------------------------------------}
procedure TBlobForm1.BitBtn21Click(Sender: TObject);
begin
   {Scan an image using a twain scanner}
   DBMultiImage1.ScanImage(Handle);
end;

{---------------------------------------------------------------------}

procedure TBlobForm1.DBNavigator1Click(Sender: TObject;
  Button: TNavigateBtn);
begin
  DBMultiImage1.ResetImage;
end;
{---------------------------------------------------------------------}

procedure TBlobForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 {Turn off the OnIdle}
 Application.OnIdle:=Nil;
 {Free the printer size form}
 Printersize.free;
 BlobForm1 := Nil;
 Action := caFree;
end;

{---------------------------------------------------------------------}

procedure TBlobForm1.BitBtn22Click(Sender: TObject);
begin
  {Popup the resulution menu}
     PopupMenu1.Popup(BitBtn22.Left + 10, BitBtn22.Top + 40);
end;

{---------------------------------------------------------------------}

procedure TBlobForm1.TiffComboChange(Sender: TObject);
begin
   {Set the compression method to save tiffs}
   if TiffCombo.Text ='NONE' then
    DBMultiImage1.TifSaveCompress:=sNONE;

   if TiffCombo.Text ='CCITT' then
    DBMultiImage1.TifSaveCompress:=sCCITT;

   if TiffCombo.Text ='FAXCCITT3' then
    DBMultiImage1.TifSaveCompress:=sFAXCCITT3;

   if TiffCombo.Text ='FAXCCITT4' then
    DBMultiImage1.TifSaveCompress:=sFAXCCITT4;

   if TiffCombo.Text ='LZW' then
    DBMultiImage1.TifSaveCompress:=sLZW;

   if TiffCombo.Text ='PACKBITS' then
    DBMultiImage1.TifSaveCompress:=sPACKBITS;
end;

{---------------------------------------------------------------------}

procedure TBlobForm1.TPageEditChange(Sender: TObject);
begin
     if DBMultiImage1.BTiffPages > 1 then begin
        screen.cursor:=crHourGlass;
        DBMultiImage1.TiffPage:=TPageEdit.Value-1;
        Table1.Refresh;
        {Reset the gauge}
        ProgressBar1.Position:=0;
        {set default cursor}
        screen.cursor:=crDefault;
     end;
end;

{---------------------------------------------------------------------}

procedure TBlobForm1.CheckBox1Click(Sender: TObject);
begin
     {Set the tiff  append mode when writing tiffs}
     DBMultiImage1.TiffAppend:=CheckBox1.Checked;
end;
{---------------------------------------------------------------------}

{Load imagetype  from Stream.} 
procedure TBlobForm1.Button1Click(Sender: TObject);
var
   Stream : TMemoryStream;
begin
     Stream:=TMemoryStream.Create;
     {make sure file exists}
     Stream.LoadFromFile('c:\clown.jpg');
     {First parameter is 3 letter extension}
     DBMultiImage1.LoadFromStream('jpg', Stream);
     Stream.free;
end;



procedure TBlobForm1.UpDateComboChange(Sender: TObject);
begin
     DBMultiImage1.BlobUpdate:=TBlobUpDate(UpDateCombo.ItemIndex);
end;

end.
