unit Ucrop;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, TMultiP, Buttons, DLL96V1, Spin, Gauges,
  MMSave, MMOpen;

type
  TForm1 = class(TForm)
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    Button2: TButton;
    Label2: TLabel;
    Gauge1: TGauge;
    Button3: TButton;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Button4: TButton;
    Button5: TButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    SpeedButton6: TSpeedButton;
    SpinEdit1: TSpinEdit;
    Button1: TButton;
    CheckBox1: TCheckBox;
    ScrollBox1: TScrollBox;
    PMultiImage1: TPMultiImage;
    Memo1: TMemo;
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure SpeedButton6Click(Sender: TObject);
    procedure PMultiImage1Rubberband(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y, XX, YY: Integer);
    procedure Button1Click(Sender: TObject);
    procedure SpeedButton7Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  AppCanScan: boolean;
  MaxPages: Integer;

implementation

{$R *.DFM}



(*---------------------------------------------------------------------------
{This is a twain callback routine used when Low Level scanning multiple pages
 from a scanner with a ADF sheetfeeder or with user interface.}

 Make sure to call DibToBitmap to convert the Dib returned by thre scanner.
---------------------------------------------------------------------------*)
function TwainCall(HDIB : Thandle; d_object : longint): Smallint; CDECL; export;
var
   Bitmap : TBitmap;
begin
    {If HDib is 0 then Scan failed}
    if HDIB = 0 then exit;
    Bitmap := TBitmap.Create;
    {This is a ImageLib routine to convert Dibs to bitmaps}
    if not DibToBitmap(HDIB, BitMap) then begin
       Bitmap.Free;
       exit;
    end;
    Form1.PMultiImage1.Picture.Bitmap.Assign(Bitmap);
    Form1.PMultiImage1.Refresh;
    Bitmap.Free;
    Application.ProcessMessages;
end;



procedure TForm1.SpeedButton2Click(Sender: TObject);
begin
  if PMultiImage1.TiffPage < MaxPages-1 then
  begin
    PMultiImage1.TiffPage  := PMultiImage1.TiffPage + 1;
    PMultiImage1.Imagename := OpenDialog1.FileName;
    Label2.Caption := IntToStr(PMultiImage1.TiffPage + 1) + ' of ' + IntToStr(MaxPages);
  end;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  if PMultiImage1.TiffPage > 0 then
  begin
    PMultiImage1.TiffPage  := PMultiImage1.TiffPage - 1;
    PMultiImage1.Imagename := OpenDialog1.FileName;
    Label2.Caption := IntToStr(PMultiImage1.TiffPage + 1) + ' of ' + IntToStr(MaxPages);
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  Resolution : Integer;
  Bitmap : TBitmap;
  Brightness,
  Contrast,
  Pages  : Integer;
begin
 Resolution:=GetDeviceRes(PMultiImage1.Picture.Bitmap.Canvas.Handle);
 Bitmap := TBitmap.Create;
 Pages:=SpinEdit1.Value;
 Brightness:=0;
 Contrast:=0;

 if not LowLevelDIBScan(Bitmap,    {Return bitmap if scanning 1 page without Twain callback}
                        0,         {Left in Inches or Centimeter depending on country}
                        0,         {Top  in Inches or Centimeter depending on country}
                        8.5,       {Right in Inches or Centimeter depending on country}
                        11.0,      {Bottom in Inches or Centimeter depending on country}
                        100,       {dpi resolution}
                        Resolution,{Resolution  1,0,8,16,24}
                        1,         {Dither 0 or 1}
                        Brightness,{Brightness -1000 to 1000}
                        Contrast,  {Contrast -1000 to 1000}
                        Pages,     {Pages}
                        TW_RGB,    {PixTypes}
                        TW_USEADF, {Flags   TW_SHOWUI to show user interface}
                        TwainCall, {TWAINCallBackFunction for multiple pages  }
                        nil,          {TWainCallBackFunction for progress bar etc}
                        0)            {Pointer of the calling object}   then
                        begin
                          Bitmap.Free;
                          exit;
                        end;

 if not Bitmap.Empty then begin
  PMultiImage1.Picture.Bitmap.Assign(Bitmap);
  PMultiImage1.Refresh;
 end;
  Bitmap.Free
end;




procedure TForm1.Button3Click(Sender: TObject);
begin
  if HasTwain(Handle) then
    ShowMessage('TWAIN OK')
  else
    ShowMessage('No TWAIN installed');
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  if OpenDialog1.Execute then
  begin
    PMultiImage1.Visible := False;
    PMultiImage1.Imagename := OpenDialog1.FileName;
    SaveDialog1.Filename := OpenDialog1.FileName;
    MaxPages := PMultiImage1.BTiffPages;
    Label2.Caption := '1 of ' + IntToStr(MaxPages);
    PMultiImage1.TiffPage:= 0;
    {PMultiImage1.Imagename := OpenDialog1.FileName;}
    PMultiImage1.Visible := True;
  end;
end;


procedure TForm1.Button5Click(Sender: TObject);
begin
  if SaveDialog1.Execute then
  begin
    PMultiImage1.SaveAsTif(SaveDialog1.FileName);
  end;
end;

procedure TForm1.SpeedButton4Click(Sender: TObject);
begin
  PMultiImage1.ZoomIn(0.9);
end;

procedure TForm1.SpeedButton3Click(Sender: TObject);
begin
  PMultiImage1.ZoomOut(1.1);
end;

procedure TForm1.SpeedButton5Click(Sender: TObject);
begin
  PMultiImage1.ResetImage;
end;

procedure TForm1.SpeedButton6Click(Sender: TObject);
var i: integer;
begin
  for i := 1 to MaxPages do
  begin
    Label2.Caption := IntToStr(i) + ' of ' + IntToStr(MaxPages);
    PMultiImage1.TiffPage  := i;
    PMultiImage1.Imagename := OpenDialog1.FileName;
    while Gauge1.Progress <> 100 do
    begin
    end;
    PMultiImage1.PrintMultiImage(0,0,2250,3301);
  end;
 end;

procedure TForm1.PMultiImage1Rubberband(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y, XX, YY: Integer);
var
  bitmap: TBitmap;
  sourcerect, destrect: TRect;
  StretchFactor_X,
  StretchFactor_Y : Integer;
begin
{  ShowMessage(IntToStr(X) + ' ' +
              IntToStr(Y) + ' ' +
              IntToStr(XX) + ' ' +
              IntToStr(YY));}

  if PMultiImage1.stretch then begin
        bitmap := TBitmap.Create;
  	StretchFactor_X   := Round(PMultiImage1.Picture.Bitmap.Width / ScrollBox1.Width);
  	StretchFactor_Y   := Round(PMultiImage1.Picture.Bitmap.Height / ScrollBox1.Height);
        bitmap.width  	  := (XX*StretchFactor_X)-(X*StretchFactor_X);
        bitmap.height     := (YY*StretchFactor_Y)-(Y*StretchFactor_Y);
  	sourcerect.left   := X*StretchFactor_X;
  	sourcerect.top    := Y*StretchFactor_Y;
  	sourcerect.right  := XX*StretchFactor_X;
  	sourcerect.bottom := YY*StretchFactor_Y;
  	destrect.left     := 0;
  	destrect.top      := 0;
  	destrect.right    := (XX*StretchFactor_X)-(X*StretchFactor_X);
  	destrect.bottom   := (YY*StretchFactor_Y)-(Y*StretchFactor_Y);
  end else begin
        bitmap := TBitmap.Create;
        bitmap.width  	  := XX-X;
        bitmap.height 	  := YY-Y;
  	sourcerect.left   := X;
  	sourcerect.top    := Y;
  	sourcerect.right  := XX;
  	sourcerect.bottom := YY;
  	destrect.left     := 0;
  	destrect.top      := 0;
  	destrect.right    := XX-X;
  	destrect.bottom   := YY-Y;
  end;

  setstretchbltmode(bitmap.canvas.handle,
                    stretch_deletescans);

  bitmap.canvas.copyrect(destrect,
                         PMultiImage1.Picture.bitmap.canvas,
                         sourcerect);

  bitmap.palette := PMultiImage1.Picture.bitmap.palette;
  PMultiImage1.picture.bitmap.assign(bitmap);
  bitmap.free;
end;


procedure TForm1.Button1Click(Sender: TObject);
begin
  PMultiImage1.ScanImage(Handle);
end;

procedure TForm1.SpeedButton7Click(Sender: TObject);
begin
  ShowMessage(IntToStr(PMultiImage1.BWidth) + ' ' +
              IntToSTr(PMultiImage1.BHeight));
end;


procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  if CheckBox1.Checked then begin
   PMultiImage1.Stretch:=True;
   PMultiImage1.AutoSize:=False;
   PMultiImage1.Width:=ScrollBox1.Width-1;
   PMultiImage1.Height:=ScrollBox1.Height-1;
  end else begin
   PMultiImage1.Stretch:=False;
   PMultiImage1.AutoSize:=True;
  end;
end;



end.
