(*/////////////////////////////////////////////////////////////////////////////
//                                                                           //
//   Part of Imagelib VCL/DLL Library Corporate Suite 4.0                    //
//                                                                           //
//   All rights reserved. (c) Copyright 1995, 1996, 1997, 1998.              //
//   SkyLine Tools a division by Creative Development LTD.                   //
//                                                                           //
//   Created by: Jan Dekkers,                                                //
//               Jillian Pinsker,                                            //
//               Reginald Armond,                                            //
//               Che-Chern Lin,                                              //
//               Alex Zitser,                                                //
//               Charles Ye,                                                 //
//               Song Han,                                                   //
//               Vitaly Bondarenko,                                          //
//               Jane Scarano,                                               //
//               Misha Popov;                                                //
//                                                                           //
//   and many others who provided feedback, gave tips and comments.          //
//                                                                           //
//   Call 1-800 404-3832  or 1-818 346-4200 to order ImageLib Corp. Suite.   //
//                                                                           //
/////////////////////////////////////////////////////////////////////////////*)

unit udbtoolb;

{Includes settings to compile in either 16 or 32 bit}
{$I DEFILIB.INC}

interface

uses
{$IFDEF DEL32}
  Windows,
{$ELSE}
  WinTypes,
  WinProcs,
{$ENDIF}
  DLL96V1,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  StdCtrls,
  DB,
  DBTables,
  DMIToolB,   {PDBMultiImage Toolbar VCL component}
  TDMULTIP;   {PDBMultiMedia1, PDBMultiImage VCL components}

type
  TDBMultiImageToolbar = class(TForm)
    PDBMultiImage1: TPDBMultiImage;
    Table1: TTable;
    DataSource1: TDataSource;
    CheckBox1: TCheckBox;
    PDBMImageToolBar1: TPDBMImageToolBar;
    procedure CheckBox1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  DBMultiImageToolbar: TDBMultiImageToolbar;

implementation

{$R *.DFM}
{------------------------------------------------------------------------}

procedure TDBMultiImageToolbar.CheckBox1Click(Sender: TObject);
begin
     PDBMImageToolBar1.ShowToolBar:=CheckBox1.Checked;
end;
{------------------------------------------------------------------------}

procedure TDBMultiImageToolbar.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
     DBMultiImageToolbar:=Nil;
     Action:=caFree;
end;
{------------------------------------------------------------------------}

procedure TDBMultiImageToolbar.FormCreate(Sender: TObject);
begin
   If FileExists(ExtractFilePath(Application.ExeName)+'JPSTAMP.DBF') then begin
       {if the table exists open it on creation}
       Table1.DataBaseName:=ExtractFilePath(Application.ExeName);
       Table1.TableName:='JPSTAMP.DBF';
       Table1.Active:=True;
    end;
  {On create show the toolbar}
  PDBMImageToolBar1.ShowToolBar:=true;

  PDBMImageToolBar1.PreviewsDir:=ExtractFilePath(Application.Exename);
end;
{------------------------------------------------------------------------}

end.
