(*/////////////////////////////////////////////////////////////////////////////
//                                                                           //
//   Part of Imagelib VCL/DLL Library Corporate Suite 4.0                    //
//                                                                           //
//   All rights reserved. (c) Copyright 1995, 1996, 1997, 1998.              //
//   SkyLine Tools a division by Creative Development LTD.                   //
//                                                                           //
//   Created by: Jan Dekkers,                                                //
//               Jillian Pinsker,                                            //
//               Reginald Armond,                                            //
//               Che-Chern Lin,                                              //
//               Alex Zitser,                                                //
//               Charles Ye,                                                 //
//               Song Han,                                                   //
//               Vitaly Bondarenko,                                          //
//               Jane Scarano,                                               //
//               Misha Popov;                                                //
//                                                                           //
//   and many others who provided feedback, gave tips and comments.          //
//                                                                           //
//   Call 1-800 404-3832  or 1-818 346-4200 to order ImageLib Corp. Suite.   //
//                                                                           //
/////////////////////////////////////////////////////////////////////////////*)

unit uilzip;

{Includes settings to compile in either 16 or 32 bit}
{$I DEFILIB.INC}

interface

uses
{$IFDEF DEL32}
  Windows,
{$ELSE}
  WinTypes,
  WinProcs,
{$ENDIF}
  DLL96V1,    {ImageLib Dll interface and misc. functions}
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  StdCtrls,
  Buttons,
  FileCtrl,
  Spin, ComCtrls;

type
  TZipForm1 = class(TForm)
    FileListBox1: TFileListBox;
    FileListBox2: TFileListBox;
    ZipIt: TBitBtn;
    UnZip: TBitBtn;
    Edit1: TEdit;
    Edit2: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Memo1: TMemo;
    Compression: TSpinEdit;
    Label5: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    ProgressBar1: TProgressBar;
    procedure ZipItClick(Sender: TObject);
    procedure UnZipClick(Sender: TObject);
    procedure FileListBox1Change(Sender: TObject);
    procedure FileListBox2Change(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure Edit2Change(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    zFromName, zToName : String;
    uzFromName, uzToName : String;
  end;


var
  ZipForm1: TZipForm1;

implementation

{$R *.DFM}



{---------------------------------------------------------------------}
Function ImageLibCallBack(i : smallint; v_object : longint) : smallint; cdecl; export;
{Callback function from the dll, CDECL and EXPORT ARE REQUIRED}
begin
 if Application.Terminated then begin
   {User wants to terminate the program. Pass a 0 to the dll}
   Result:=0;
  end else begin
  {Be nice to others <g>}
   Application.ProcessMessages;
   {process a Gauge}
   if ZipForm1 <> Nil then
    ZipForm1.ProgressBar1.Position:=smallint(i);
   {tell the dll that everything is OK}
   Result:=1;
   end;
end;

{---------------------------------------------------------------------}
{get the size of a file}
Function sizeoffile(theFile : String) : longint;
var
 FileStream : TFileStream;
begin
  if not fileexists(theFile) then begin
   result:=0;
   exit;
  end;
  FileStream := TFileStream.Create(theFile, fmOpenRead or fmShareDenyWrite);
  result:=FileStream.Size;
  FileStream.Free;
end;

{---------------------------------------------------------------------}

procedure TZipForm1.ZipItClick(Sender: TObject);
begin
  {Zip a file using the PNG's ZLIB compression libraries}
  ilzip(zFromName,            {source filename}
        zToName,              {destination filename}
        Compression.Value,    {compression level "less 0 .. 9 most"}
        LongInt(Self),
        ImageLibCallBack);    {callback}
  FileListBox2.Update;
end;

{---------------------------------------------------------------------}

procedure TZipForm1.UnZipClick(Sender: TObject);
begin
  {UnZip a file using the PNG's ZLIB compression libraries}
  ilunzip(uzFromName,         {source filename}
          uzToName,           {destination filename}
          LongInt(Self),
          ImageLibCallBack);  {callback}
  FileListBox1.Update;
end;

{---------------------------------------------------------------------}

procedure TZipForm1.FileListBox1Change(Sender: TObject);
begin
  zFromName:=FileListBox1.FileName;
  {Swap file extension}
  Edit1.Text:=ChangeFileExt(ExtractFilename(FileListBox1.FileName),'.izi');
  {get the size}
  label3.caption:='size: '+inttostr(sizeoffile(zFromName));
end;

{---------------------------------------------------------------------}

procedure TZipForm1.FileListBox2Change(Sender: TObject);
begin
  uzFromName:=FileListBox2.FileName;
  {Get the original uncompressed filename of the compressed file}
  Edit2.Text:=ilziporgfile(uzFromName);
  {get the size}
  label4.caption:='size: '+inttostr(sizeoffile(uzFromName));
end;

{---------------------------------------------------------------------}

procedure TZipForm1.Edit1Change(Sender: TObject);
begin
  zToName:=ExtractFilePath(Application.ExeName)+Edit1.Text;
end;


{---------------------------------------------------------------------}
procedure TZipForm1.Edit2Change(Sender: TObject);
begin
  uzToName:=ExtractFilePath(Application.ExeName)+Edit2.Text;
end;
{---------------------------------------------------------------------}

end.
