(*/////////////////////////////////////////////////////////////////////////////
//                                                                           //
//   Part of Imagelib VCL/DLL Library Corporate Suite 4.0                    //
//                                                                           //
//   All rights reserved. (c) Copyright 1995, 1996, 1997, 1998.              //
//   SkyLine Tools a division by Creative Development LTD.                   //
//                                                                           //
//   Created by: Jan Dekkers,                                                //
//               Jillian Pinsker,                                            //
//               Reginald Armond,                                            //
//               Che-Chern Lin,                                              //
//               Alex Zitser,                                                //
//               Charles Ye,                                                 //
//               Song Han,                                                   //
//               Vitaly Bondarenko,                                          //
//               Jane Scarano,                                               //
//               Misha Popov;                                                //
//                                                                           //
//   and many others who provided feedback, gave tips and comments.          //
//                                                                           //
//   Call 1-800 404-3832  or 1-818 346-4200 to order ImageLib Corp. Suite.   //
//                                                                           //
/////////////////////////////////////////////////////////////////////////////*)

unit Uimage;

{Includes settings to compile in either 16 or 32 bit}
{$I DEFILIB.INC}

interface

uses
{$IFDEF DEL32}
  Windows,
{$ELSE}
  WinTypes,
  WinProcs,
{$ENDIF}
  DLL96V1,    {ImageLib Dll interface and misc. functions}
  SysUtils,
  Messages,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  StdCtrls,
  FileCtrl,
  Spin,
  Buttons,
  ExtCtrls,
  printers,
  Menus,
  Uabout,
  DllSP96,   {Imagalib Special Addon}
  UFullscr,  {Full screen display unit}
  U_p_size,  {Printer size unit}
  TMultiP,   {PMultiImage VCL component}
  Preview,   {Thumbnail preview}
  IToolB,    {Toolbar component}
  ComCtrls,
  MMOpen,
  ilmitb,
  MMSave, ILAnnSet;


type
  TViewImageForm = class(TForm)
    DriveComboBox1     : TDriveComboBox;
    DirectoryListBox1  : TDirectoryListBox;
    FileListBox1       : TFileListBox;
    SaveDialog1        : TMMSaveDialog;
    SaveButton         : TBitBtn;
    MainMenu1          : TMainMenu;
    N1                 : TMenuItem;
    O1                 : TMenuItem;
    N2                 : TMenuItem;
    E1                 : TMenuItem;
    A1                 : TMenuItem;
    N4                 : TMenuItem;
    Print1             : TMenuItem;
    PrintSetup1        : TMenuItem;
    PrinterSetupDialog1: TPrinterSetupDialog;
    PrintDialog1       : TPrintDialog;
    Label9             : TLabel;
    Label10            : TLabel;
    Label11            : TLabel;
    Label12            : TLabel;
    Label13            : TLabel;
    Label14            : TLabel;
    Label15            : TLabel;
    Edit1              : TEdit;
    Edit2              : TEdit;
    Edit3              : TEdit;
    Edit4              : TEdit;
    Edit5              : TEdit;
    Edit6              : TEdit;
    Edit7              : TEdit;
    GetInfoChecked     : TCheckBox;
    Label8             : TLabel;
    Edit8              : TEdit;
    BitBtn1            : TBitBtn;
    Edit9              : TMenuItem;
    Cut1               : TMenuItem;
    Copy1              : TMenuItem;
    Paste1             : TMenuItem;
    ScrollBar1         : TScrollBar;
    N5                 : TMenuItem;
    CreateMessage1     : TMenuItem;
    CheckBox2          : TCheckBox;
    BitBtn2            : TBitBtn;
    BitBtn3            : TBitBtn;
    BitBtn4            : TBitBtn;
    CreateCreditMessage1: TMenuItem;
    BitBtn5            : TBitBtn;
    Scanning           : TBitBtn;
    Edit10             : TEdit;
    Label1             : TLabel;
    BitBtn7            : TBitBtn;
    CheckBox1          : TCheckBox;
    N6                 : TMenuItem;
    N3                 : TMenuItem;
    Scan1              : TMenuItem;
    SelectScanner1     : TMenuItem;
    N7                 : TMenuItem;
    SetAsWallPaper: TMenuItem;
    ThumbPreview1      : TThumbPreview;
    OpenUsingThumbnails1: TMenuItem;
    Undo1              : TMenuItem;
    Effects3           : TMenuItem;
    BitBtn6            : TBitBtn;
    BitBtn8            : TBitBtn;
    Edit11             : TEdit;
    Label2             : TLabel;
    ReadResolution1    : TMenuItem;
    Res1               : TMenuItem;
    Res4System         : TMenuItem;
    Res4               : TMenuItem;
    Res8               : TMenuItem;
    Res24              : TMenuItem;
    ResAuto            : TMenuItem;
    WriteResolution1   : TMenuItem;
    SaveRes4System     : TMenuItem;
    SaveRes4           : TMenuItem;
    SaveRes8           : TMenuItem;
    SaveRes24          : TMenuItem;
    SaveResJpegGray    : TMenuItem;
    SaveResAuto        : TMenuItem;
    Panel2             : TPanel;
    Panel1             : TPanel;
    AppendTiff         : TRadioButton;
    OverwriteTiff      : TRadioButton;
    Tiffpage           : TLabel;
    TPageEdit          : TSpinEdit;
    Label3             : TLabel;
    TiffCombo          : TComboBox;
    Panel3             : TPanel;
    QualityLabel       : TLabel;
    SmoothLabel        : TLabel;
    QualitySpin        : TSpinEdit;
    Smoothspin         : TSpinEdit;
    PCD_ComboBox1      : TComboBox;
    Label4             : TLabel;
    Label5             : TLabel;
    Label6             : TLabel;
    CropIm             : TButton;
    ResizeIm           : TButton;
    Button1            : TButton;
    Button3            : TButton;
    Button2            : TButton;
    Removebtn          : TButton;
    Timer1             : TTimer;
    BitBtn9            : TBitBtn;
    MultiImage1        : TPMultiImage;
    CheckBox4          : TCheckBox;
    SpeedButton1       : TSpeedButton;
    Toolbar1           : TMenuItem;
    SpeedButton2       : TSpeedButton;
    SpeedButton3       : TSpeedButton;
    PixelAccess1       : TMenuItem;
    HowTo1             : TMenuItem;
    Button4            : TButton;
    MMOpenDialog1      : TMMOpenDialog;
    MImageToolBar1: TMImageToolBar;
    StatusBar1: TStatusBar;
    ProgressBar1: TProgressBar;
    ILMultiImageToolBar1: TILMultiImageToolBar;
    AnnoSettings1: TAnnoSettings;
    procedure DriveComboBox1Change(Sender: TObject);
    procedure DirectoryListBox1Change(Sender: TObject);
    procedure FileListBox1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure resClick(Sender: TObject);
    procedure SaveButtonClick(Sender: TObject);
    procedure E1Click(Sender: TObject);
    procedure O1Click(Sender: TObject);
    procedure A1Click(Sender: TObject);
    procedure Print1Click(Sender: TObject);
    procedure PrintSetup1Click(Sender: TObject);
    procedure GetInfoCheckedClick(Sender: TObject);
    procedure BitBtn1e(Sender: TObject);
    procedure Cut1Click(Sender: TObject);
    procedure Copy1Click(Sender: TObject);
    procedure Paste1Click(Sender: TObject);
    procedure ScrollBar1Change(Sender: TObject);
    procedure SmoothspinChange(Sender: TObject);
    procedure QualitySpinChange(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure BitBtn5Click(Sender: TObject);
    procedure BitBtn6Click(Sender: TObject);
    procedure SaveResClick(Sender: TObject);
    procedure BitBtn7Click(Sender: TObject);
    procedure SstretchRatioOnOff(Sender: TObject);
    procedure TiffComboChange(Sender: TObject);
    procedure Scan1Click(Sender: TObject);
    procedure SelectScanner1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure OpenUsingThumbnails1Click(Sender: TObject);
    procedure Effects1Click(Sender: TObject);
    procedure Undo1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure MultiImage1IlibError(Sender: TObject; ErrorCode: Integer;
      ErrorString: String; ErrorPChar: PChar);
    procedure BitBtn8Click(Sender: TObject);
    procedure MultiImage1Rubberband(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y, XX, YY: Integer);
    procedure MultiImage1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure TPageEditChange(Sender: TObject);
    procedure PCD_ComboBox1Change(Sender: TObject);
    procedure CropImClick(Sender: TObject);
    procedure ResizeImClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Removeb(Sender: TObject);
    procedure btow(Sender: TObject);
    procedure BitBtn9Click(Sender: TObject);
    procedure CheckBox4Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure MultiImage1Progress(Sender        : TObject;
                                  Progress      : Smallint;
                                  PMessage      : String;
                              var CancelProcess : Boolean);
    procedure Toolbar1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure HowTo1Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure SetAsWallPaperClick(Sender: TObject);
  private
    { Private declarations }
   procedure DisPlayInfo(dis : boolean);
   Procedure Trigger(Sender : TObject; Var Done : Boolean);
  public
    { Public declarations }
  end;

var
  ViewImageForm: TViewImageForm;

implementation

{$R *.DFM}
{$IFDEF DEL32}
  {$R BLIT32.RES}  {This contains a 256 color bitmap}
{$ELSE}
  {$R BLIT16.RES}  {This contains a 256 color bitmap}
{$ENDIF}

{---------------------------------------------------------------------}

{---------------------------------------------------------------------}
procedure TViewImageForm.MultiImage1Progress(Sender        : TObject;
                                             Progress      : Smallint;
                                             PMessage      : String;
                                         var CancelProcess : Boolean);

begin
    CancelProcess := Application.Terminated;
    {Process the First call}
    if Progress = 0  then begin
     ProgressBar1.Position:=0;
     Application.ProcessMessages;
    end;

    {Process the Last call}
    if Progress > 99  then begin
     ProgressBar1.Position:=Progress;
    {Set the message caption}
     StatusBar1.Panels[0].Text := '';
     Application.ProcessMessages;
     exit;
    end;

    {Some speed improvement when only processing each fifth call}
    if Progress > ProgressBar1.Position+5 then begin
     ProgressBar1.Position:=Progress;
     {Set the message caption}
     StatusBar1.Panels[0].Text:='Status '+PMessage;
     Application.ProcessMessages;
    end;
end;

{---------------------------------------------------------------------}

procedure TViewImageForm.DriveComboBox1Change(Sender: TObject);
{update the drive of DirectoryListBox1 with the drive of DriveComboBox1}
begin
  DirectoryListBox1.Drive := DriveComboBox1.Drive;
end;
{---------------------------------------------------------------------}

procedure TViewImageForm.DisPlayInfo(dis : boolean);
begin
    {If scrolling message then show the speed scroll bar}
    if (MultiImage1.BFileType = 'SCM') or (MultiImage1.BFileType = 'CMS') then begin
    {Show it}
     ScrollBar1.Visible:=true;
     {set the speed/position}
     ScrollBar1.Position:=MultiImage1.MsgSpeed;
    end else
     ScrollBar1.Visible:=False;

    if dis then begin
       {display the image info}
       Edit1.Text:=IntToStr(MultiImage1.Bwidth);
       Edit2.Text:=IntToStr(MultiImage1.BHeight);
       Edit3.Text:=IntToStr(MultiImage1.Bbitspixel);
       Edit4.Text:=IntToStr(MultiImage1.Bplanes);
       Edit5.Text:=IntToStr(MultiImage1.Bnumcolors);
       Edit6.Text:=MultiImage1.BFileType;
       Edit7.Text:=MultiImage1.Bcompression;
       Edit8.Text:=IntToStr(MultiImage1.BSize);
       Edit11.Text:=IntToStr(MultiImage1.BTiffPages);
       Label5.Caption:=IntToStr(MultiImage1.Picture.Bitmap.Width);
       Label6.Caption:=IntToStr(MultiImage1.Picture.Bitmap.Height);
     end else begin
      {set the image info to ''}
       Edit1.Text:='';
       Edit2.Text:='';
       Edit3.Text:='';
       Edit4.Text:='';
       Edit5.Text:='';
       Edit6.Text:='';
       Edit7.Text:='';
       Edit8.Text:='';
       Edit11.Text:='';
     end;
end;

{---------------------------------------------------------------------

---------------------------------------------------------------------}

procedure TViewImageForm.DirectoryListBox1Change(Sender: TObject);
{update the directory of FileListBox1 with the directory of FileListBox1}
begin
  FileListBox1.Directory := DirectoryListBox1.Directory;
end;


{
ChangePathAndExtension Returns new filename
FileName : Input full filename including path and extension
NewPath  : New path name
NewExt   : New extension including the period (eg: '.gif')
}

{---------------------------------------------------------------------

---------------------------------------------------------------------}

Function ChangePathAndExtension(FileName :  String;
                                NewPath  :  String;
                                NewExt   :  String) : String;
begin
    Delete(FileName,1, Length(ExtractFilePath(FileName)));
    If NewPath[Length(NewPath)-1] <> '\' then NewPath:=NewPath+'\';
    Result:=LowerCase(NewPath+ChangeFileExt(FileName,NewExt));
end;


{---------------------------------------------------------------------

---------------------------------------------------------------------}
procedure TViewImageForm.FileListBox1Change(Sender: TObject);
{Display the image of the FileListBox1.filename}
begin
 {set hourglass cursor}
  screen.cursor:=crHourGlass;

 {display an image using the vcl}
  MultiImage1.imagename:=FileListBox1.filename;

  {reset the tiffpage value to the actual tiffpage if any}
  TPageEdit.Value:=MultiImage1.TiffPage;

  {Request fileinfo from the DLL}
  if GetInfoChecked.Checked then
   DisplayInfo(true) else DisplayInfo(false);

  {Reset the gauge}
  ProgressBar1.Position:=0;

  {set default cursor}
  screen.cursor:=crDefault;
end;
{---------------------------------------------------------------------}

procedure TViewImageForm.SstretchRatioOnOff(Sender: TObject);
{set stretch Ratio mode}
begin
  MultiImage1.Stretchratio:=CheckBox1.Checked;
end;
{---------------------------------------------------------------------}

procedure TViewImageForm.FormCreate(Sender: TObject);
{what we do on create}
begin
    Printersize:=TPrintersize.Create(Application);
    {set the value of the QualitySpin to the value of JPegSaveQuality}
    QualitySpin.value:=MultiImage1.JPegSaveQuality;

    {set the value of the Smoothspin to the value of JPegSaveSmooth}
    Smoothspin.value:=MultiImage1.JPegSaveSmooth;

    {IMPORTANT}
    {This is the moving engine for all the messages. Since an application
    can have only one OnIdle Trigger, this trigger needs to be subdivided
    by all your moving and animated objects. In this particular case the
    function is called TRIGGER but you can name it as you want as long
    you have a procedure named the same.}
    Application.OnIdle:=Trigger;

{$IFNDEF DEL32}
    LoadresourcefromDelphiExe1.Enabled:=(GetModuleHandle('DELPHI.EXE') <> 0);
    Removebtn.Enabled:=False;
{$ENDIF}
    MultiImage1.Color:=clBtnFace;
end;

{---------------------------------------------------------------------}

Procedure TViewImageForm.Trigger(Sender : TObject; Var Done : Boolean);
begin
   {This function is called when your app is idle. Subdivide the
    trigger event to your TMultiImage objects who may need one.
    If no Message is active it will not take up significant time}
    MultiImage1.Trigger;
end;
{---------------------------------------------------------------------}

procedure TViewImageForm.resClick(Sender: TObject);
{Set the read resolution to either 1,4, 16, 256 or true color in the vcl}
begin
 Res1.checked:=False;
 Res4.checked:=False;
 Res4System.checked:=False;
 Res8.checked:=False;
 Res24.checked:=False;
 ResAuto.checked:=False;

 If TMenuItem(Sender) = Res1 then begin
    {set show resolution to 1 bit monochrome black and white}
    Res1.checked:=true;
    MultiImage1.ImageReadRes:=lMonoChrome;
 end;

 If TMenuItem(Sender) = Res4System then begin
    {set show resolution to 4 bit 16 color using the system's colors}
    Res4System.checked:=true;
    MultiImage1.ImageReadRes:=lColorVGA;
 end;

 If TMenuItem(Sender) = Res4 then begin
     {set show resolution to 4 bit 16 color}
    Res4.checked:=true;
    MultiImage1.ImageReadRes:=lColor16;
 end;

  If TMenuItem(Sender) = Res8 then begin
    {set show resolution to 8 bit 256 color}
    Res8.checked:=true;
    MultiImage1.ImageReadRes:=lColor256;
 end;

 If TMenuItem(Sender) = Res24 then begin
    {set show resolution to 24 bit true color}
    Res24.checked:=true;
    MultiImage1.ImageReadRes:=lColorTrue;
 end;

 If TMenuItem(Sender) = resAuto then begin
    {Let ImageLib determine the best resolution}
    resAuto.checked:=true;
    MultiImage1.ImageReadRes:=lAutoMatic;
 end;

end;
{---------------------------------------------------------------------}

procedure TViewImageForm.SaveResClick(Sender: TObject);
{Set the save  resolution to either 16, 256 or true color in the vcl}
begin

 SaveResJpegGray.checked:=False;
 SaveRes4.checked:=False;
 SaveRes4System.checked:=False;
 SaveRes8.checked:=False;
 SaveRes24.checked:=False;
 SaveResAuto.checked:=False;

 If TMenuItem(Sender) = SaveRes4System then begin
   {set save resolution to 4 bit 16 color using the system's colors}
    SaveRes4System.checked:=true;
    MultiImage1.ImageWriteRes:=sColorVGA;
 end;

 If TMenuItem(Sender) = SaveRes4 then begin
   {set save resolution to 4 bit 16 color}
    SaveRes4.checked:=true;
    MultiImage1.ImageWriteRes:=sColor16;
 end;

 If TMenuItem(Sender) = SaveRes8 then begin
   {set save resolution to 8 bit 256 color}
    SaveRes8.checked:=true;
    MultiImage1.ImageWriteRes:=sColor256;
 end;

 If TMenuItem(Sender) = SaveRes24 then begin
   {set save resolution to 24 bit true color}
    SaveRes24.checked:=true;
    MultiImage1.ImageWriteRes:=sColorTrue;
 end;

 If TMenuItem(Sender) = SaveResJpegGray then begin
    {set Jpeg save resolution to GrayScale (Other formats will neglect
    this parameter and set it to 8 bit}
    SaveResJpegGray.checked:=true;
    MultiImage1.ImageWriteRes:=sJpegGray;
 end;

 If TMenuItem(Sender) = SaveResAuto then begin
    {Let ImageLib determine the best resolution}
    SaveResAuto.checked:=true;
    MultiImage1.ImageWriteRes:=sAutoMatic;
 end;

end;

{---------------------------------------------------------------------}

procedure TViewImageForm.SaveButtonClick(Sender: TObject);
{save a jpeg or bmp}
begin
 {Set various filters}
 if MultiImage1.BFileType = 'SCM' then begin
  SaveDialog1.Filename:='*.SCM';
  SaveDialog1.Filter:='Scroll message|*.scm';
 end else
 if MultiImage1.BFileType = 'CMS' then begin
  SaveDialog1.Filename:='*.CMS';
  SaveDialog1.Filter:='Credit message|*.cms';
 end else begin
  SaveDialog1.Filename:='*.jpg';
  SaveDialog1.Filter:='jpeg|*.jpg|bmp|*.bmp|gif|*.gif|pcx|*.pcx|png|*.png|tif|*.tif|tga|*.tga|eps|*.eps';
 end;

 {open save dialog}
 if SaveDialog1.execute then begin

 {set hourglass cursor}
  screen.cursor:=crHourGlass;

  {save it if the extension is png}
  if UpperCase(ExtractFileExt(SaveDialog1.Filename)) =  '.PNG' then
    MultiImage1.SaveAsPNG(SaveDialog1.FileName);

  {save it if the extension is pcx}
  if UpperCase(ExtractFileExt(SaveDialog1.Filename)) =  '.PCX' then
    MultiImage1.SaveAsPCX(SaveDialog1.FileName);

  {save it if the extension is pcx}
  if UpperCase(ExtractFileExt(SaveDialog1.Filename)) =  '.GIF' then
    MultiImage1.SaveAsGIF(SaveDialog1.FileName);

  {save it if the extension is jpg}
  if UpperCase(ExtractFileExt(SaveDialog1.Filename)) =  '.JPG' then
    MultiImage1.SaveAsJpg(SaveDialog1.FileName);

  {save it if the extension is bmp}
  if UpperCase(ExtractFileExt(SaveDialog1.Filename)) =  '.BMP' then
    MultiImage1.SaveAsBMP(SaveDialog1.FileName);

  {save it if the extension is tga}
  if UpperCase(ExtractFileExt(SaveDialog1.Filename)) =  '.TGA' then
    MultiImage1.SaveAsTGA(SaveDialog1.FileName);

  {save it if the extension is eps}
  if UpperCase(ExtractFileExt(SaveDialog1.Filename)) =  '.EPS' then
    MultiImage1.SaveAsEPS(SaveDialog1.FileName);

 {save it if the extension is SCM}
  if UpperCase(ExtractFileExt(SaveDialog1.Filename)) =  '.SCM' then
    MultiImage1.SaveCurrentMessage(SaveDialog1.FileName);

 {save it if the extension is CMS}
  if UpperCase(ExtractFileExt(SaveDialog1.Filename)) =  '.CMS' then
    MultiImage1.SaveCurrentCreditMessage(SaveDialog1.FileName);

 {save it if the extension is TIF}
  if UpperCase(ExtractFileExt(SaveDialog1.Filename)) =  '.TIF' then begin
    MultiImage1.TiffAppend:=AppendTiff.Checked;
    MultiImage1.SaveAsTIF(SaveDialog1.FileName);
  end;

 {set default cursor}
  screen.cursor:=crDefault;

  {update the filelist box sothat the file saved shows up}
  FileListBox1.Update;
 end;
end;
{---------------------------------------------------------------------}

{---------------------------------------------------------------------}

procedure TViewImageForm.E1Click(Sender: TObject);
{exit the program}
begin
 close;
end;
{---------------------------------------------------------------------}

procedure TViewImageForm.O1Click(Sender: TObject);
{open a image using the open dialog}
begin
  if MMOpenDialog1.execute then begin

   {set hourglass cursor}
    screen.cursor:=crHourGlass;

   {delete the old image}
    {MultiImage1.imagename:='';}

    {display an image using the vcl}

    MultiImage1.imagename:='';
    MultiImage1.TiffPage:=MMOpenDialog1.TiffSelectedPage;
    {reset the tiffpage value to the actual tiffpage if any}
    TPageEdit.Value:=MultiImage1.TiffPage;
    
    MultiImage1.imagename:=MMOpenDialog1.filename;

   {Request fileinfo from the DLL}
   {Note, fileinfo will not work on WMF and ICO}
    if GetInfoChecked.Checked then
      DisplayInfo(true) else DisplayInfo(false);

    {reset the gauge}
    ProgressBar1.Position:=0;

   {set default cursor}
    screen.cursor:=crDefault;
  end;
end;
{---------------------------------------------------------------------}

procedure TViewImageForm.A1Click(Sender: TObject);
{about box}
begin
{show the about box}
 AboutBox.showmodal;
end;
{---------------------------------------------------------------------}

procedure TViewImageForm.Print1Click(Sender: TObject);
{Print image}
begin
  if PrintDialog1.execute then begin
  {Initialize the height spinedit of the printsize dialog box}
   Printersize.HeigthSpinEdit.Value:=MultiImage1.Picture.Height;
   {Initialize the width spinedit of the printsize dialog box}
   Printersize.WidthSpinEdit.Value:=MultiImage1.Picture.Width;
   {Show it}
   Printersize.ShowModal;
   if Printersize.Modalresult = mrok then
    {print TMultiImage}
     MultiImage1.PrintMultiImage(0,0,Printersize.WidthSpinEdit.Value,Printersize.HeigthSpinEdit.Value);
   {Hide it if done}
   Printersize.hide;
  end;
end;
{---------------------------------------------------------------------}

procedure TViewImageForm.PrintSetup1Click(Sender: TObject);
{Set up printer}
begin
  PrinterSetupDialog1.Execute;
end;
{---------------------------------------------------------------------}

procedure TViewImageForm.GetInfoCheckedClick(Sender: TObject);
{depending on the state of the checkbox,  display or not display info}
begin
 DisPlayInfo(GetInfoChecked.Checked);
end;
{---------------------------------------------------------------------}
{---------------------------------------------------------------------}

procedure TViewImageForm.BitBtn1e(Sender: TObject);
var
  RunAfterCreate : Boolean;
begin
    {Create a new message using the message editor}
    {boolean indicating to run the message after creation}
    RunAfterCreate:=True;

    {CreateMessage takes a pathname as the initial path to save the
     message and a boolean to run it. For Instance:
    {MultiImage1.CreateMessage('c:\',true);}
    MultiImage1.CreateMessage(ExtractFilePath(Application.Exename),RunAfterCreate);

    {Show new message in listbox}
    FileListBox1.Update;
end;
{---------------------------------------------------------------------}

{---------------------------------------------------------------------}

procedure TViewImageForm.Cut1Click(Sender: TObject);
begin
{Cut Image and Copy it to the clipboard}
  MultiImage1.CutToClipboard
end;
{---------------------------------------------------------------------}

procedure TViewImageForm.Copy1Click(Sender: TObject);
begin
{Copy Image to the clipboard}
  MultiImage1.CopyToClipboard;
end;
{---------------------------------------------------------------------}

procedure TViewImageForm.Paste1Click(Sender: TObject);
begin
{Paste Image from the clipboard}
  MultiImage1.PasteFromClipboard;
end;
{---------------------------------------------------------------------}

procedure TViewImageForm.ScrollBar1Change(Sender: TObject);
begin
 {Change the speed of a srolling message}
  MultiImage1.MsgSpeed:=ScrollBar1.Position;
end;
{---------------------------------------------------------------------}


procedure TViewImageForm.SmoothspinChange(Sender: TObject);
begin
    {set the value of the JPegSaveSmooth}
    MultiImage1.JPegSaveSmooth:=Smoothspin.value;
end;
{---------------------------------------------------------------------}

procedure TViewImageForm.QualitySpinChange(Sender: TObject);
begin
    {set the value of the JPegSaveQuality}
    MultiImage1.JPegSaveQuality:=QualitySpin.value;
end;
{---------------------------------------------------------------------}

procedure TViewImageForm.CheckBox2Click(Sender: TObject);
begin
{Set read image dither }
    MultiImage1.ImageDither:=CheckBox2.Checked;
end;
{---------------------------------------------------------------------}

procedure TViewImageForm.BitBtn2Click(Sender: TObject);
var
  RunAfterCreate : Boolean;
begin
    {Create a new message using the message editor}
    {boolean indicating to run the message after creation}
    RunAfterCreate:=True;

    {CreateCreditMessage takes a pathname as the initial path to save the
     message and a boolean to run it. For Instance:
    {MultiImage1.CreateCreditMessage('c:\',true);}
    MultiImage1.CreateCreditMessage(ExtractFilePath(Application.Exename),RunAfterCreate);

    {Show new message in listbox}
    FileListBox1.Update;
end;
{---------------------------------------------------------------------}

procedure TViewImageForm.BitBtn5Click(Sender: TObject);
 {Load a BMP image from any executable or dll.
  Note that the dll or exe needs to be loaded in order
  to find its module handle}
begin
  {Indicate in which program the BMP Lives. For instance:
  MultiImage1.ResProgName:='';
  means in this executable (RES (Resource file))}
  {Dont enter a path name};
  MultiImage1.ResProgName:=''; {this executable linked in BLIT8.RES}

  {Name of the resource. Note that the .res indicate to the vcl
  that it is a resource BMP but your resource BMP is called FRIDGE.
  Incase the resource is a number put e.g: MultiImage1.ImageName:='98255.RES';}
  MultiImage1.ImageName:='FRIDGE.RES';
  if GetInfoChecked.Checked then
   DisplayInfo(true) else DisplayInfo(false);
  {reset the tiffpage value to the actual tiffpage if any}
  TPageEdit.Value:=MultiImage1.TiffPage;
end;
{---------------------------------------------------------------------}

procedure TViewImageForm.BitBtn6Click(Sender: TObject);
begin
  MultiImage1.ResetImage;
  MultiImage1.repaint;
end;
{---------------------------------------------------------------------}

procedure TViewImageForm.BitBtn3Click(Sender: TObject);
begin
   {Create A credit message on the fly}
    MultiImage1.FreeMsg(True);
   {Clear Message text if any}
    MultiImage1.CreditBoxList.Clear;
   {Define Message text}
    MultiImage1.CreditBoxList.Add(' ImageLib');
    MultiImage1.CreditBoxList.Add(' Another fine product of');
    MultiImage1.CreditBoxList.Add(' SKYLINE TOOLS');
    {set Message font name;  Note you could do this also with a font dialog}
    MultiImage1.MsgFont.Name:='Arial';
   {set Message font size}
    MultiImage1.MsgFont.Size:=-18;
    {set Message font style}
    MultiImage1.MsgFont.Style:=[fsitalic, fsbold];
    {set Message font color}
    MultiImage1.MsgFont.Color:=clWhite;
    {set Message background. Note you could do this also with a color dialog}
    MultiImage1.MsgBkGrnd:=clNavy;
    {set Message speed from 1 is fast to 10 is slow}
    MultiImage1.MsgSpeed:=5;
    {Show Speed ScrollBar}
    ScrollBar1.Visible:=true;
    {set the speed/position}
    ScrollBar1.Position:=MultiImage1.MsgSpeed;
    {inititiate new message}
    MultiImage1.NewCreditMessage;
end;
{---------------------------------------------------------------------}

procedure TViewImageForm.BitBtn4Click(Sender: TObject);
begin
   {create a message on the fly at MultiImage1 (Top one)}
   {set Message text}
    MultiImage1.MsgText:='ImageLib Corp. Suite. A great tool to create a superb application in no time.';
    {set Message font name;  Note you could do this also with a font dialog}
    MultiImage1.MsgFont.Name:='Arial';
   {set Message font size}
    MultiImage1.MsgFont.Size:=-40;
    {set Message font style}
    MultiImage1.MsgFont.Style:=[fsitalic, fsbold];
    {set Message font color}
    MultiImage1.MsgFont.Color:=clYellow;
    {set Message background. Note you could do this also with a color dialog}
    MultiImage1.MsgBkGrnd:=clPurple;
    {set Message speed from 1 is fast to 10 is slow}
    MultiImage1.MsgSpeed:=3;
    {Show Speed ScrollBar}
    ScrollBar1.Visible:=true;
    {set the speed/position}
    ScrollBar1.Position:=MultiImage1.MsgSpeed;
    {inititiate new message}
    MultiImage1.NewMessage;
end;
{---------------------------------------------------------------------}

{---------------------------------------------------------------------}

procedure TViewImageForm.BitBtn7Click(Sender: TObject);
begin
  {Text on an Image}
  MultiImage1.Text:=(Edit10.Text);
  {Text can be shadowed}
  MultiImage1.TextShadow:=True;
  {Text position}
  MultiImage1.TextLeft:=1;
  {Text position}
  MultiImage1.TextTop:=MultiImage1.ClientRect.Top;
  {Text angle in degrees}
  MultiImage1.TextRotate:=0;
  {Text background color}
  MultiImage1.TextTransParent:=True;
end;
{---------------------------------------------------------------------}

procedure TViewImageForm.TiffComboChange(Sender: TObject);
begin
   {Set the compression method to save tiffs}
   if TiffCombo.Text ='NONE' then
    MultiImage1.TifSaveCompress:=sNONE;

   if TiffCombo.Text ='CCITT' then
    MultiImage1.TifSaveCompress:=sCCITT;

   if TiffCombo.Text ='FAXCCITT3' then
    MultiImage1.TifSaveCompress:=sFAXCCITT3;

   if TiffCombo.Text ='FAXCCITT4' then
    MultiImage1.TifSaveCompress:=sFAXCCITT4;

   if TiffCombo.Text ='LZW' then
    MultiImage1.TifSaveCompress:=sLZW;

   if TiffCombo.Text ='PACKBITS' then
    MultiImage1.TifSaveCompress:=sPACKBITS;
end;

{---------------------------------------------------------------------}
procedure TViewImageForm.PCD_ComboBox1Change(Sender: TObject);
begin
  MultiImage1.PCDMode:=TPCDMode(PCD_ComboBox1.ItemIndex);
end;
{---------------------------------------------------------------------}

procedure TViewImageForm.Scan1Click(Sender: TObject);
begin
    {Scan an image using a twain scanner}
    MultiImage1.ScanImage(Handle);
    MultiImage1.ResetImage;
end;
{---------------------------------------------------------------------}

procedure TViewImageForm.SelectScanner1Click(Sender: TObject);
begin
    {Select a twain scanner source}
    MultiImage1.SelectScanner(Handle);
end;
{---------------------------------------------------------------------}

procedure TViewImageForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
    Printersize.Free;
    Application.OnIdle:=Nil;
   {release memory of the stringlist boxes}
    ViewImageForm:=Nil;
    Action:=caFree;
end;

{---------------------------------------------------------------------}

procedure TViewImageForm.OpenUsingThumbnails1Click(Sender: TObject);
begin

 ThumbPreview1.PreviewsDir:=ExtractFilePath(Application.Exename);
 ThumbPreview1.DataFileDir:=ExtractFilePath(Application.Exename);

 If ThumbPreview1.Execute then  begin

    {set hourglass cursor}
    screen.cursor:=crHourGlass;

   {delete the old image}
    {MultiImage1.imagename:='';}

    {display an image using the vcl}
    MultiImage1.imagename:=ThumbPreview1.filename;

   {reset the tiffpage value to the actual tiffpage if any}
    TPageEdit.Value:=MultiImage1.TiffPage;

   {Request fileinfo from the DLL}
   {Note, fileinfo will not work on WMF and ICO}
    if GetInfoChecked.Checked then
      DisplayInfo(true) else DisplayInfo(false);

    {reset the gauge}
    ProgressBar1.Position:=0;

   {set default cursor}
    screen.cursor:=crDefault;
  end;
end;

{---------------------------------------------------------------------}
{Show effects dialog}
procedure TViewImageForm.Effects1Click(Sender: TObject);
begin
     MultiImage1.ILSEffects;
     MultiImage1.ResetImage;
end;

{---------------------------------------------------------------------}
{Undo last action}
procedure TViewImageForm.Undo1Click(Sender: TObject);
begin
     MultiImage1.UndoImage;
     MultiImage1.ResetImage;
end;

{---------------------------------------------------------------------}

{Is Undo available}
procedure TViewImageForm.Timer1Timer(Sender: TObject);
begin
     Undo1.enabled:=HasUndo;
end;

{---------------------------------------------------------------------}

{On error event to examine the error code, string or pchar}
procedure TViewImageForm.MultiImage1IlibError(Sender: TObject;
  ErrorCode: Integer; ErrorString: String; ErrorPChar: PChar);
begin
   MessageBox(Handle, ErrorPChar, 'Customized error message box', mb_OK + mb_IconStop);
end;

{---------------------------------------------------------------------}
{Show effects dialog}
procedure TViewImageForm.BitBtn8Click(Sender: TObject);
begin
     Effects1Click(Sender);
end;

{---------------------------------------------------------------------}

{zoom the image}
procedure TViewImageForm.MultiImage1Rubberband(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y, XX, YY: Integer);
begin
  MultiImage1.ZoomArea(Rect(X,Y,XX,YY));
end;

{---------------------------------------------------------------------}


procedure TViewImageForm.MultiImage1MouseDown(Sender: TObject;
  Button : TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
     if SpeedButton1.Down then exit;
     {Reset the image zoom}
     if Button = mbRight then
        BitBtn6Click(Sender);
 end;

{---------------------------------------------------------------------}
{Which tiffpage to view}
procedure TViewImageForm.TPageEditChange(Sender: TObject);
var
 TempName : TFilename;
begin
     {Save the current filename};
     TempName:=MultiImage1.ImageName;
     if not FileExists(TempName) then exit;
     {To make sure the current loaded image has multiple pages
      we get the information}
     MultiImage1.GetInfoAndType(TempName);

     if MultiImage1.BTiffPages > 1 then begin
        {set hourglass cursor}
        screen.cursor:=crHourGlass;
        MultiImage1.TiffPage:=TPageEdit.Value-1;
        MultiImage1.ImageName:=TempName;
        {Request fileinfo from the DLL}
        if GetInfoChecked.Checked then
          DisplayInfo(true) else DisplayInfo(false);
        {Reset the gauge}
        ProgressBar1.Position:=0;
        {set default cursor}
        screen.cursor:=crDefault;
     end;
end;

{---------------------------------------------------------------------}

procedure TViewImageForm.ResizeImClick(Sender: TObject);
{Sample of how to resize an Image using delphi calls}
var
 Bitmap : TBitmap;
begin
 {Set Stretch Off}
 CheckBox1.Checked:=False;
 {Create a new bitmap and set its size}
 Bitmap := TBitmap.Create;
 Bitmap.Width:=80;
 Bitmap.Height:=80;
 {Copy the palette}
 Bitmap.Palette:=MultiImage1.Picture.Bitmap.Palette;
 {Delete the lines needed to shrink}
 SetStretchBltMode(Bitmap.Canvas.Handle,STRETCH_DELETESCANS);
 {Resize it}
 Bitmap.Canvas.Copyrect(Rect(0,
                             0,
                             80,
                             80),
                        MultiImage1.Picture.Bitmap.Canvas,
                        Rect(0,
                             0,
                             MultiImage1.Picture.Bitmap.Width,
                             MultiImage1.Picture.Bitmap.Height));
 {Copy the palette}
 Bitmap.Palette:=MultiImage1.Picture.Bitmap.Palette;
 {Assign the new smaller bitmap}
 MultiImage1.Picture.Bitmap.Assign(Bitmap);
 {Free the bitmap}
 Bitmap.Free;

 {Request fileinfo from the DLL}
 if GetInfoChecked.Checked then
   DisplayInfo(true) else DisplayInfo(false);

end;

{---------------------------------------------------------------------}

procedure TViewImageForm.CropImClick(Sender: TObject);
{Sample of how to crop an Image using delphi calls}
var
 Bitmap : TBitmap;
begin
 {Set Stretch Off}
 CheckBox1.Checked:=False;
 {Create a new bitmap and set its size}
 Bitmap := TBitmap.Create;
 Bitmap.Width:=80;
 Bitmap.Height:=80;
 {Copy the palette}
 Bitmap.Palette:=MultiImage1.Picture.Bitmap.Palette;
 {Delete the lines needed to shrink}
 SetStretchBltMode(Bitmap.Canvas.Handle,STRETCH_DELETESCANS);
 {Crop it}
 Bitmap.Canvas.Copyrect(Rect(0,
                             0,
                             80,  {new size}
                             80), {new size}
                        MultiImage1.Picture.Bitmap.Canvas,
                        Rect(0,
                             0,
                             80, {crop area}
                             80));{crop area}
 {Copy the palette}
 Bitmap.Palette:=MultiImage1.Picture.Bitmap.Palette;
 {Assign the new cropped bitmap}
 MultiImage1.Picture.Bitmap.Assign(Bitmap);
 {Free the bitmap}
 Bitmap.Free;

 {Request fileinfo from the DLL}
 if GetInfoChecked.Checked then
   DisplayInfo(true) else DisplayInfo(false);

end;

{---------------------------------------------------------------------}
procedure TViewImageForm.Button1Click(Sender: TObject);
{show fullscreen}
begin
  {copy image to fullscreen image}
  FullSlide.MultiImage1.Picture.Bitmap.Assign(MultiImage1.Picture.Bitmap);
  FullSlide.MultiImage1.TileWindow:=MultiImage1.TileWindow;
  {show the image fulscreen}
  FullSlide.showmodal;

  FullSlide.MultiImage1.TileWindow:=False;
end;

{---------------------------------------------------------------------}
{Demonstrates how to apply an effect on an Image codewise
{---------------------------------------------------------------------}
procedure TViewImageForm.Button3Click(Sender: TObject);
var
 Bitmap : TBitmap;
begin

 Bitmap := TBitmap.Create;
 Bitmap.Assign(MultiImage1.Picture.Bitmap);
 FadeImage (BitMap,
            0,0,0,0,
            60,
            255,
            200,
            255,
            0,
            LongInt(Self),
            nil,
            true);
 MultiImage1.Picture.Bitmap.Assign(Bitmap);
 Bitmap.Free;
 MultiImage1.ResetImage;
end;

{---------------------------------------------------------------------}

procedure TViewImageForm.Button2Click(Sender: TObject);
var
 Bitmap : TBitmap;
begin
   Bitmap := TBitmap.Create;
   Bitmap.Width:=MultiImage1.Width;
   Bitmap.Height:=MultiImage1.Height;

   CheckerBoardImage (Bitmap,
                      0,
                      0,
                      Bitmap.Width,
                      Bitmap.Height,
                      False,  {Normal checkboard}
                      12,     {Block Size}
                      0,      {Dither 256 color only}
                      False); {Add to undo's}

   MultiImage1.Picture.Bitmap.Assign(Bitmap);
   Bitmap.Free;
   MultiImage1.ResetImage;
end;

{---------------------------------------------------------------------}
   {will automatically remove unwanted borders from an images
    like the ones returned by scanners.
{---------------------------------------------------------------------}
procedure TViewImageForm.Removeb(Sender: TObject);
var
 Bitmap : TBitmap;
begin
   Bitmap := TBitmap.Create;
   Bitmap.Assign(MultiImage1.Picture.Bitmap);
   RemoveBorder (Bitmap,
                 10, {Sensitivity 1 to 255}
                 0,
                 nil,
                 False); {Add to undo's}
   MultiImage1.Picture.Bitmap.Assign(Bitmap);
   Bitmap.Free;
   MultiImage1.ResetImage;
end;

{---------------------------------------------------------------------}
{Load from stream example}
{---------------------------------------------------------------------}
procedure TViewImageForm.btow(Sender: TObject);
var
   Stream : TMemoryStream;
begin
     Stream:=TMemoryStream.Create;
     {make sure file exists}
     Stream.LoadFromFile('c:\clown.jpg');
     {First parameter is 3 letter extension}
     MultiImage1.LoadFromStream('jpg', Stream);
     Stream.free;
end;

{---------------------------------------------------------------------}
{MultiImage1.TileWindow.
{---------------------------------------------------------------------}
procedure TViewImageForm.BitBtn9Click(Sender: TObject);
begin
  {First we resize the image. Make it smaller}
   ResizeImClick(Sender);
  {Now we generate a tile image}
  MultiImage1.TileEffect;
  {copy image to fullscreen image}
  FullSlide.MultiImage1.Picture.Bitmap.Assign(MultiImage1.Picture.Bitmap);
  {We set the property tile window to true}
  FullSlide.MultiImage1.TileWindow:=True;
  {show the image fulscreen}
  FullSlide.showmodal;
  {We reset the property tile window to false}
  FullSlide.MultiImage1.TileWindow:=False;
  {We undo last action}
  Undo1Click(Sender);
  {Reset image}
  MultiImage1.ResetImage;
end;

{---------------------------------------------------------------------}
{Toggle the mouse between tiling and panning when clicked in the image window}
{---------------------------------------------------------------------}
procedure TViewImageForm.CheckBox4Click(Sender: TObject);
begin
     if CheckBox4.Checked then
       CheckBox4.Caption:='Panning'
     else
       CheckBox4.Caption:='Zooming';

     MultiImage1.AllowRubberBand := not CheckBox4.Checked;
end;

{---------------------------------------------------------------------}

procedure TViewImageForm.SpeedButton1Click(Sender: TObject);
begin
    MultiImage1.EditAnnotat:= SpeedButton1.Down;
end;
{---------------------------------------------------------------------}

procedure TViewImageForm.Toolbar1Click(Sender: TObject);
begin
   MImageToolBar1.ShowToolbar:= not MImageToolBar1.ShowToolbar;
   //MImageToolBar1.Flat:=True;
end;

{---------------------------------------------------------------------}
{This actually burns the annotations into the image.
 Note that this can't be reversed}
{---------------------------------------------------------------------}

procedure TViewImageForm.SpeedButton2Click(Sender: TObject);
begin
     MultiImage1.HardDrawAnnotation;
     MultiImage1.ClearAnnotation;
end;


{---------------------------------------------------------------------}
{Toggle scrolbars off and on
{---------------------------------------------------------------------}
procedure TViewImageForm.SpeedButton3Click(Sender: TObject);
begin
   MultiImage1.Scrolling := not MultiImage1.Scrolling;
   if MultiImage1.Scrolling then
      SpeedButton3.Caption := 'Scroll is On'
   else
      SpeedButton3.Caption := 'Scroll is Off';
end;

{---------------------------------------------------------------------}
//This will show you how to access the pixels of a bitmap and will invert them
{---------------------------------------------------------------------}
procedure TViewImageForm.HowTo1Click(Sender: TObject);
var
  Info     : PBitmapInfo;
  I  : Integer;
  Image    : PByte;
  InfoSize, ImageSize: DWord;
  BitMap : TBitmap;
  ClrPtr  : PByte;
begin
   if MultiImage1.Picture.Bitmap = nil then exit;
   BitMap:=TBitmap.Create;
   BitMap.Assign(MultiImage1.Picture.Bitmap);
   GetDIBSizes(Bitmap.Handle, InfoSize, ImageSize);
   Info := MemAlloc(InfoSize);
   try
     Image := GlobalAllocPtr(HeapAllocFlags, ImageSize);
     try
        GetDIB(Bitmap.Handle, Bitmap.Palette, Info^, Image^);
        ClrPtr:=Image;
        for I:=0 to ImageSize-1 do begin
          case Info^.bmiHeader.biBitCount of
               4:; //This should be done on the palette level
               8:; //This should be done on the palette level
               1,
               16, //Did not tested 16 bit color dept (Jan)
               24: begin
                       ClrPtr^:= not ClrPtr^; //Invert the pixel (With monochrome, 8 bits at a time will be inverted)
                       Inc(ClrPtr);
                   end;
           end;
        end;
        SetDIBits(MultiImage1.Canvas.Handle, Bitmap.Handle,0,
                  Info^.bmiHeader.biHeight, Image, Info^, DIB_RGB_COLORS);
        MultiImage1.Picture.BitMap.Assign(Bitmap);
     finally
       GlobalFreePtr(Image);
     end;
   finally
     FreeMem(Info, InfoSize);
     Bitmap.Free;
   end;
end;

procedure TViewImageForm.Button4Click(Sender: TObject);
var
  Bitmap      : TBitmap;
  aBorderSize : integer;
  MaskBitmap  : TBitmap;  // bitmap
  HmaskBmp    : HBitmap;  // Handle to a Bitmap containing mask
  HmaskPal    : HPalette; // Handle to a Palette from the mask
begin
  if MMOpenDialog1.Execute then begin
    MultiImage1.ImageName := MMOpenDialog1.FileName;

    MaskBitmap := TBitmap.Create;           // create two empty bitmap objects
    Bitmap := TBitmap.Create;

    MaskBitmap.Width := MultiImage1.BWidth;
    MaskBitMap.Height := MultiImage1.BHeight;

    Caption := (inttostr(MaskBitmap.Width) + ' X ' + inttostr(MaskBitmap.height));

    With MaskBitMap.Canvas do begin
      Brush.Color := $00000000;
      Brush.Style := bsSolid;
      Pen.Color := $00000000; // set pen color to black
      Pen.Style := psSolid;   // set pen style to solid
      FillRect(MultiImage1.ClientRect);

      Brush.Color := $00FFFFFF;   // set pen and brush to white
      Pen.Color := $00FFFFFF;

      aBorderSize := 3;
      Ellipse(aBorderSize,
              aBorderSize,
              ( MultiImage1.ClientWidth - aBorderSize ) - 1,
              ( MultiImage1.ClientHeight - aBorderSize ) - 1);
    end;

    Bitmap.Assign(MultiImage1.Picture.Bitmap); // assign bitmap from image control
    HmaskBmp := MaskBitmap.Handle;        // get handle
    HmaskPal := MaskBitmap.Palette;       // get palette
    MergeImage (Bitmap,                   // call MergeImage routine
                HmaskBmp ,                // handle to bitmap
                HmaskPal,                 // handle to palette
                0,                        // dither
                0,                        // red
                0,                        // green
                0,                        // blue
                0,                        // top
                0,                        // left
                false);                   // add undo
    MultiImage1.Picture.BitMap.Assign(Bitmap); // reassign masked bitmap to image control
    Bitmap.Free;                          // free bitmaps
    MaskBitmap.SaveToFile('Mask.bmp');
    MaskBitmap.Free;
  end;
end;

procedure TViewImageForm.SetAsWallPaperClick(Sender: TObject);
var
  sFile: array[ 0..256 ] of char;
begin
  if fileexists(MultiImage1.ImageName) then begin
   StrPCopy(sFile, ExtractFilePath(Application.Exename)+'\desktop wallpaper.bmp');
   MultiImage1.SaveAsBmp(StrPas(sFile));
   if not SystemParametersInfo( SPI_SETDESKWALLPAPER,
                                0,
                                @sFile,
                                ( SPIF_UPDATEINIFILE or SPIF_SENDWININICHANGE )) then ShowMessage('Error setting wallpaper');
  end;

end;

end.


