(*/////////////////////////////////////////////////////////////////////////////
//                                                                           //
//   Part of Imagelib VCL/DLL Library Corporate Suite 4.0                    //
//                                                                           //
//   All rights reserved. (c) Copyright 1995, 1996, 1997, 1998.              //
//   SkyLine Tools a division by Creative Development LTD.                   //
//                                                                           //
//   Created by: Jan Dekkers,                                                //
//               Jillian Pinsker,                                            //
//               Reginald Armond,                                            //
//               Che-Chern Lin,                                              //
//               Alex Zitser,                                                //
//               Charles Ye,                                                 //
//               Song Han,                                                   //
//               Vitaly Bondarenko,                                          //
//               Jane Scarano,                                               //
//               Misha Popov;                                                //
//                                                                           //
//   and many others who provided feedback, gave tips and comments.          //
//                                                                           //
//   Call 1-800 404-3832  or 1-818 346-4200 to order ImageLib Corp. Suite.   //
//                                                                           //
/////////////////////////////////////////////////////////////////////////////*)

unit Umail;

{Includes settings to compile in either 16 or 32 bit}
{$I DEFILIB.INC}

interface

uses
{$IFDEF DEL32}
  Windows,
{$ELSE}
  WinTypes,
  WinProcs,
{$ENDIF}
  DLL96V1,    {ImageLib Dll interface and misc. functions}
  SysUtils,
  Messages,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  ExtCtrls,
  DBCtrls,
  MPlayer,
  StdCtrls,
  DB,
  DBTables,
  Mask,
  Buttons,
  Spin,
  Tdmultim,   {PDBMultiMedia1, VCL component}
  Tdmultip,   {PDBMultiImage VCL component}
  MMOpen,
  ComCtrls;

type
  TMailOrderForm = class(TForm)
    DataSource1: TDataSource;
    Table1: TTable;
    DBMultiImage1: TPDBMultiImage;
    DBMultiMedia1: TPDBMultiMedia;
    DBMemo1: TDBMemo;
    DBMultiImage2: TPDBMultiImage;
    AddMM: TBitBtn;
    AddImage: TBitBtn;
    AddMsg: TBitBtn;
    BitBtn6: TBitBtn;
    DBEdit1: TDBEdit;
    DBEdit2: TDBEdit;
    OpenDialog1: TMMOpenDialog;
    DBMediaPlayer1: TPDBMediaPlayer;
    SpinButton1: TSpinButton;
    DBNavigator1: TDBNavigator;
    BitBtn1: TBitBtn;
    CheckBox1: TCheckBox;
    ProgressBar1: TProgressBar;
    ProgressBar2: TProgressBar;
    procedure FormCreate(Sender: TObject);
    procedure AddImageClick(Sender: TObject);
    procedure AddMMClick(Sender: TObject);
    procedure DataSource1DataChange(Sender: TObject; Field: TField);
    procedure AddMsgClick(Sender: TObject);
    procedure SpinButton1DownClick(Sender: TObject);
    procedure SpinButton1UpClick(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure CheckBox1Click(Sender: TObject);
    procedure DBMultiMedia1Progress(Sender        : TObject;
                                    Progress      : Smallint;
                                    PMessage      : String;
                                var CancelProcess : Boolean);
    procedure DBMultiImage2Progress(Sender        : TObject;
                                    Progress      : Smallint;
                                    PMessage      : String;
                                var CancelProcess : Boolean);
  private
    { Private declarations }
    Procedure Trigger(Sender : TObject; Var Done : Boolean);
  public
    { Public declarations }
  end;

var
  MailOrderForm: TMailOrderForm;

implementation

{$R *.DFM}


procedure TMailOrderForm.DBMultiMedia1Progress(Sender        : TObject;
                                               Progress      : Smallint;
                                               PMessage      : String;
                                           var CancelProcess : Boolean);

begin
    CancelProcess := Application.Terminated;
    {Process the First call}
    if Progress = 0  then begin
     ProgressBar1.Position:=0;
     Application.ProcessMessages;
    end;

    {Process the Last call}
    if Progress > 99  then begin
     ProgressBar1.Position:=Progress;
     Application.ProcessMessages;
    end;

    {Some speed improvement when only processing each fifth call}
    if Progress > ProgressBar1.Position+5 then begin
     ProgressBar1.Position:=Progress;
     Application.ProcessMessages;
    end;
end;

procedure TMailOrderForm.DBMultiImage2Progress(Sender        : TObject;
                                               Progress      : Smallint;
                                               PMessage      : String;
                                           var CancelProcess : Boolean);
begin
    CancelProcess := Application.Terminated;
    {Process the First call}
    if Progress = 0  then begin
     ProgressBar2.Position:=0;
     Application.ProcessMessages;
    end;

    {Process the Last call}
    if Progress > 99  then begin
     ProgressBar2.Position:=Progress;
     Application.ProcessMessages;
    end;

    {Some speed improvement when only processing each fifth call}
    if Progress > ProgressBar2.Position + 5 then begin
     ProgressBar2.Position:=Progress;
     Application.ProcessMessages;
    end;
end;

{---------------------------------------------------------------------}

Procedure TMailOrderForm.Trigger(Sender : TObject; Var Done : Boolean);
begin
    {IMPORTANT}
   {This function is called when your app is idle. Subdivide the
    trigger event to your TDBMultiMedia objects who may need one.
    If no Message is active it will not take up significant time}
    DBMultiMedia1.Trigger;
    DBMultiImage1.Trigger;
    DBMultiImage2.Trigger;
end;
{---------------------------------------------------------------------}


procedure TMailOrderForm.FormCreate(Sender: TObject);
begin
    If FileExists(ExtractFilePath(Application.ExeName)+'MAIL_ORD.DB') then begin
       {if the table exists open it on creation}
       Table1.DataBaseName:=ExtractFilePath(Application.ExeName);
       Table1.TableName:='MAIL_ORD.DB';
       Table1.Active:=True;
     end;

   {IMPORTANT}
    {This is the moving engine for all the messages. Since an applcation
    can have only one OnIdle Trigger, this trigger needs to be subdivided
    by all your moving and animated objects. In this particular case the
    function is called TRIGGER but you can name it as you want as long
    you have a procedure named the same.}
    Application.OnIdle:=Trigger;
 end;
{---------------------------------------------------------------------}

procedure TMailOrderForm.AddImageClick(Sender: TObject);
begin
   OpenDialog1.filter:='All|*.BMP;*.GIF;*.PCX;*.JPG;*.SCM;*.PNG;*.CMS;*.RTF;*.PCD;*.TGA;*.EPS|'+
   'BMP |*.BMP|GIF |*.GIF|JPG |*.JPG|PCX |*.PCX|SCM |*.SCM|PNG |*.PNG|'+
   'CMS |*.CMS|PCD |*.PCD|TGA |*.TGA|EPS |*.EPS|';
  {Execute the open dialog box}
  if OpenDialog1.Execute then begin

    Table1.Edit;

    {Load the Multimedia into the Blob}
    DBMultiImage2.LoadfromFile(OpenDialog1.FileName);

    {Post that thing}
    Table1.Post;
  end;
end;
{---------------------------------------------------------------------}

procedure TMailOrderForm.AddMMClick(Sender: TObject);
begin
  {fill the OpenDialog filter with the MM extensions as found in the win.ini
   (This means that the appropriate drivers are installed)}
  OpenDialog1.filter:=GetMultiMediaExtensions;

  {Execute the open dialog box}
  if OpenDialog1.Execute then begin

    Table1.Edit;

    {Load the Multimedia into the Blob}
    DBMultiMedia1.LoadfromFile(OpenDialog1.FileName);

    {Post that thing}
    Table1.Post;
  end;
end;
{---------------------------------------------------------------------}

procedure TMailOrderForm.DataSource1DataChange(Sender: TObject; Field: TField);
begin
    {Set the Video display rectangle to the rectangle of the blob window}
    DBMediaPlayer1.DisplayRect:=Rect(0,0,DBMultiMedia1.Width,DBMultiMedia1.Height);

    {Set the Video display to the the display of the blob window}
    DBMediaPlayer1.Display:=DBMultiMedia1;

end;
{---------------------------------------------------------------------}

procedure TMailOrderForm.AddMsgClick(Sender: TObject);
begin
    Table1.Edit;
    {Create a New Message}
    If DBMultiImage1.CreateMessage then
    {Post or cancel that thing}
       Table1.Post
    else
       Table1.Cancel;
end;
{---------------------------------------------------------------------}

procedure TMailOrderForm.SpinButton1DownClick(Sender: TObject);
begin
  if DBMultiImage1.MsgSpeed <10 then Inc(DBMultiImage1.MsgSpeed)
end;
{---------------------------------------------------------------------}

procedure TMailOrderForm.SpinButton1UpClick(Sender: TObject);
begin
  if DBMultiImage1.MsgSpeed >0 then Dec(DBMultiImage1.MsgSpeed)
end;
{---------------------------------------------------------------------}

procedure TMailOrderForm.BitBtn1Click(Sender: TObject);
begin
    {Place the Database in Edit mode}
    Table1.Edit;
    {Create a New Credit Message}
    If DBMultiMedia1.CreateCreditMessage then
    {Post or cancel that thing}
      Table1.Post
    else
      Table1.Cancel;
end;
{---------------------------------------------------------------------}

procedure TMailOrderForm.CheckBox1Click(Sender: TObject);
begin
     DBMultiImage2.Stretch:=CheckBox1.Checked;
end;
{---------------------------------------------------------------------}

procedure TMailOrderForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
    Application.OnIdle:=Nil;
    {UNRegister the callback Fuctions to the VCL}
    MailOrderForm:=Nil;
    Action:=caFree;
end;


end.
