(*/////////////////////////////////////////////////////////////////////////////
//                                                                           //
//   Part of Imagelib VCL/DLL Library Corporate Suite 4.0                    //
//                                                                           //
//   All rights reserved. (c) Copyright 1995, 1996, 1997, 1998.              //
//   SkyLine Tools a division by Creative Development LTD.                   //
//                                                                           //
//   Created by: Jan Dekkers,                                                //
//               Jillian Pinsker,                                            //
//               Reginald Armond,                                            //
//               Che-Chern Lin,                                              //
//               Alex Zitser,                                                //
//               Charles Ye,                                                 //
//               Song Han,                                                   //
//               Vitaly Bondarenko,                                          //
//               Jane Scarano,                                               //
//               Misha Popov;                                                //
//                                                                           //
//   and many others who provided feedback, gave tips and comments.          //
//                                                                           //
//   Call 1-800 404-3832  or 1-818 346-4200 to order ImageLib Corp. Suite.   //
//                                                                           //
/////////////////////////////////////////////////////////////////////////////*)

unit umdbtb;

{Includes settings to compile in either 16 or 32 bit}
{$I DEFILIB.INC}

interface

uses
{$IFDEF DEL32}
  Windows,
{$ELSE}
  WinTypes,
  WinProcs,
{$ENDIF}
  DLL96V1,    {ImageLib Dll interface and misc. functions}
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  DB,
  DBTables,
  StdCtrls,
  ExtCtrls,
  DBCtrls,
  DMMToolB,   {PDBMultiMedia Toolbar VCL component}
  TDMULTIM;   {PDBMultiMedia1 VCL components}


type
  TMMForm1 = class(TForm)
    DataSource1: TDataSource;
    Table1: TTable;
    CheckBox1: TCheckBox;
    PDBMultiMedia1: TPDBMultiMedia;
    PDBMMediaToolBar1: TPDBMMediaToolBar;
    DBNavigator1: TDBNavigator;
    procedure CheckBox1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MMForm1 : TMMForm1;

implementation

{$R *.DFM}
{------------------------------------------------------------------------}

procedure TMMForm1.CheckBox1Click(Sender: TObject);
begin
     PDBMMediaToolBar1.ShowToolBar:=CheckBox1.Checked;
end;
{------------------------------------------------------------------------}

procedure TMMForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
     MMForm1:=Nil;
     Action:=caFree;
end;
{------------------------------------------------------------------------}

procedure TMMForm1.FormCreate(Sender: TObject);
begin
    If FileExists(ExtractFilePath(Application.ExeName)+'mmblob.dbf') then begin
       {if the table exists open it on creation}
       Table1.DataBaseName:=ExtractFilePath(Application.ExeName);
       Table1.TableName:='mmblob.dbf';
       Table1.Active:=True;
    end;
  {On create show the toolbar}
  PDBMMediaToolBar1.PreviewsDir:=ExtractFilePath(Application.Exename);
  PDBMMediaToolBar1.ShowToolBar:=true;
end;
{------------------------------------------------------------------------}

end.
