(*/////////////////////////////////////////////////////////////////////////////
//                                                                           //
//   Part of Imagelib VCL/DLL Library Corporate Suite 4.0                    //
//                                                                           //
//   All rights reserved. (c) Copyright 1995, 1996, 1997, 1998.              //
//   SkyLine Tools a division by Creative Development LTD.                   //
//                                                                           //
//   Created by: Jan Dekkers,                                                //
//               Jillian Pinsker,                                            //
//               Reginald Armond,                                            //
//               Che-Chern Lin,                                              //
//               Alex Zitser,                                                //
//               Charles Ye,                                                 //
//               Song Han,                                                   //
//               Vitaly Bondarenko,                                          //
//               Jane Scarano,                                               //
//               Misha Popov;                                                //
//                                                                           //
//   and many others who provided feedback, gave tips and comments.          //
//                                                                           //
//   Call 1-800 404-3832  or 1-818 346-4200 to order ImageLib Corp. Suite.   //
//                                                                           //
/////////////////////////////////////////////////////////////////////////////*)

unit Urubberb;

{Includes settings to compile in either 16 or 32 bit}
{$I DEFILIB.INC}

interface

uses
{$IFDEF DEL32}
  Windows,
{$ELSE}
  WinTypes,
  WinProcs,
{$ENDIF}
  DLL96V1,  {ImageLib Dll interface and misc. functions}
  DLLSP96,
  SysUtils,
  Messages,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  TMultiP,  {PMultiImage VCL component}
  StdCtrls,
  IToolB,   {PMultiImage Toolbar VCL component}
  Preview;


type
  TRubberbandForm = class(TForm)
    PMultiImage1: TPMultiImage;
    Label1: TLabel;
    MImageToolBar1: TMImageToolBar;
    Button1: TButton;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    RadioButton4: TRadioButton;
    RadioButton5: TRadioButton;
    RadioButton6: TRadioButton;
    RadioButton7: TRadioButton;
    RadioButton9: TRadioButton;
    RadioButton10: TRadioButton;
    RadioButton12: TRadioButton;
    RadioButton13: TRadioButton;
    RadioButton14: TRadioButton;
    RadioButton15: TRadioButton;
    Label2: TLabel;
    RadioButton8: TRadioButton;
    RadioButton11: TRadioButton;
    ThumbPreview1: TThumbPreview;
    Button2: TButton;
    Label3: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure CopyModeClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure PMultiImage1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PMultiImage1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure PMultiImage1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PMultiImage1Paint(Sender: TObject);
  private
    { Private declarations }
  public
    MyRubberBand : TILRubberBand;
    procedure OnRubberband(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y, XX, YY: Integer);
  end;

var
  RubberbandForm: TRubberbandForm;

implementation

{$R *.DFM}
{------------------------------------------------------------------------}

procedure TRubberbandForm.Button1Click(Sender: TObject);
begin
    {Show or hide the toolbar}
    MImageToolBar1.ShowToolbar:= not MImageToolBar1.ShowToolbar;
end;
{------------------------------------------------------------------------}

procedure TRubberbandForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
   MyRubberBand.Free;
   RubberbandForm:=Nil;
   Action:=caFree;
end;
{------------------------------------------------------------------------}

procedure TRubberbandForm.CopyModeClick(Sender: TObject);
begin
 If radiobutton1.checked then
   PMultiImage1.Canvas.CopyMode:=cmBlackness;
 If radiobutton2.checked then
   PMultiImage1.Canvas.CopyMode:=cmDstInvert;
 If radiobutton3.checked then
   PMultiImage1.Canvas.CopyMode:=cmMergeCopy;
 If radiobutton4.checked then
   PMultiImage1.Canvas.CopyMode:=cmMergePaint;
 If radiobutton5.checked then
   PMultiImage1.Canvas.CopyMode:=cmNotSrcCopy;
 If radiobutton6.checked then
   PMultiImage1.Canvas.CopyMode:=cmNotSrcErase;
 If radiobutton7.checked then
   PMultiImage1.Canvas.CopyMode:=cmPatCopy;
 If radiobutton11.checked then
   PMultiImage1.Canvas.CopyMode:=cmPatInvert;
 If radiobutton8.checked then
   PMultiImage1.Canvas.CopyMode:=cmPatPaint;
 If radiobutton12.checked then
   PMultiImage1.Canvas.CopyMode:=cmSrcAnd;
 If radiobutton9.checked then
   PMultiImage1.Canvas.CopyMode:=cmSrcCopy;
 If radiobutton13.checked then
   PMultiImage1.Canvas.CopyMode:=cmSrcErase;
 If radiobutton10.checked then
   PMultiImage1.Canvas.CopyMode:=cmSrcInvert;
 If radiobutton14.checked then
   PMultiImage1.Canvas.CopyMode:=cmSrcPaint;
 If radiobutton15.checked then
   PMultiImage1.Canvas.CopyMode:=cmWhiteness;

 PMultiImage1.Invalidate;
end;

{------------------------------------------------------------------------}

procedure TRubberbandForm.Button2Click(Sender: TObject);
begin
 ThumbPreview1.PreviewsDir:=ExtractFilePath(Application.Exename);
 ThumbPreview1.DataFileDir:=ExtractFilePath(Application.Exename);
 If ThumbPreview1.Execute then
   PMultiImage1.Imagename:=ThumbPreview1.filename;
end;
{------------------------------------------------------------------------}

procedure TRubberbandForm.FormCreate(Sender: TObject);
begin
 MImageToolBar1.PreviewsDir:=ExtractFilePath(Application.Exename);

 MyRubberBand:=TILRubberBand.Create(Self);
 MyRubberBand.DropRect(1, 1, 100, 100);
 MyRubberBand.iParent:=PMultiImage1;
 MyRubberBand.OnRubberBand:=OnRubberband;
end;

{------------------------------------------------------------------------}

procedure TRubberbandForm.PMultiImage1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
     if Assigned(MyRubberBand) then
      MyRubberBand.MouseDown(Button, Shift, X, Y);
end;

{------------------------------------------------------------------------}

procedure TRubberbandForm.PMultiImage1MouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
     if Assigned(MyRubberBand) then
      MyRubberBand.MouseMove(Shift, X, Y);
end;

{------------------------------------------------------------------------}

procedure TRubberbandForm.PMultiImage1MouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
     if Assigned(MyRubberBand) then
      MyRubberBand.MouseUp(Button, Shift, X, Y);
end;

{------------------------------------------------------------------------}

procedure TRubberbandForm.PMultiImage1Paint(Sender: TObject);
begin
  if Assigned(MyRubberBand) then
    MyRubberBand.PaintRect;
end;

{------------------------------------------------------------------------}

procedure TRubberbandForm.OnRubberband(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y, XX, YY: Integer);
begin
 //The x, y, xx, yy are based on the with and height of the image control. To make this
 //rubberband control usefull you need to calculate this with the width and and heigth of the image
 //and keep track if the image is stretched.

 //Please remind that this rubberband was not intended to be published and we just provided this
 //example at request of a few clients who loved this feature

 //Uses DLLSP96

  Label3.Caption:='  x: ' + IntToStr(x)+
                  '  y: ' + IntToStr(y)+
                  '  xx: '+ IntToStr(xx)+
                  '  yx: '+ IntToStr(yy);

end;

{cmBlackness	Turns all output black.
cmDstInvert	Inverts the destination bitmap.
cmMergeCopy	Combines the pattern and the source bitmap by using the Boolean AND operator.
cmMergePaint	Combines the inverted source bitmap with the destination bitmap by using the Boolean OR operator.
cmNotSrcCopy	Copies the inverted source bitmap to the destination.
cmNotSrcErase	Inverts the result of combining the destination and source bitmaps by using the Boolean OR operator.
cmPatCopy	Copies the pattern to the destination bitmap with the pattern by using the Boolean XOR operator.
cmPatInvert	Combines the destination bitmap with the pattern by using the Boolean XOR operator
cmPatPaint	Combines the inverted source bitmap with the pattern by using the Boolean OR operator. Combines the result of this operation with the destination bitmap by using the Boolean OR operator.
cmSrcAnd	Combines pixels from the destination and source bitmaps by using the Boolean AND operator.
cmSrcCopy	Copies the source bitmap to the destination bitmap.
cmSrcErase	Inverts the destination bitmap and combines the result with the source bitmap by using the Boolean AND operator.
cmSrcInvert	Combines pixels from the destination and source bitmaps by using the Boolean XOR operator.
cmSrcPaint	Combines pixels from the destination and source bitmaps by using the Boolean OR operator.
cmWhiteness	Turns all output white.}

end.
