(*/////////////////////////////////////////////////////////////////////////////
//                                                                           //
//   Part of Imagelib VCL/DLL Library Corporate Suite 4.0                    //
//                                                                           //
//   All rights reserved. (c) Copyright 1995, 1996, 1997, 1998.              //
//   SkyLine Tools a division by Creative Development LTD.                   //
//                                                                           //
//   Created by: Jan Dekkers,                                                //
//               Jillian Pinsker,                                            //
//               Reginald Armond,                                            //
//               Che-Chern Lin,                                              //
//               Alex Zitser,                                                //
//               Charles Ye,                                                 //
//               Song Han,                                                   //
//               Vitaly Bondarenko,                                          //
//               Jane Scarano,                                               //
//               Misha Popov;                                                //
//                                                                           //
//   and many others who provided feedback, gave tips and comments.          //
//                                                                           //
//   Call 1-800 404-3832  or 1-818 346-4200 to order ImageLib Corp. Suite.   //
//                                                                           //
/////////////////////////////////////////////////////////////////////////////*)

unit utext2im;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  PrinterS, StdCtrls, Buttons, ComCtrls, Dll96V1, TMultiP, RichEdit,
  MMOpen, MMSave;

type
  TFTextToImage = class(TForm)
    RichEdit1: TRichEdit;
    BitBtn1: TBitBtn;
    OpenDialog1: TOpenDialog;
    BitBtn2: TBitBtn;
    PMultiImage1: TPMultiImage;
    BitBtn3: TBitBtn;
    Label1: TLabel;
    SaveDialog1: TMMSaveDialog;
    BitBtn4: TBitBtn;
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure RichEdit1ResizeRequest(Sender: TObject; Rect: TRect);
  private
    { Private declarations }
  public
    { Public declarations }
    W,
    H : Integer;
    Bitmap : TBitmap;
    procedure CreateBitmap;
  end;

var
  FTextToImage: TFTextToImage;


implementation

{$R *.DFM}


procedure TFTextToImage.CreateBitmap;
begin
 if Bitmap <> nil then Bitmap.Free;
 Bitmap := TBitmap.Create;
 Bitmap.Monochrome:=True;
 Bitmap.Width:=W;
 Bitmap.Height:=H;
end;


procedure TFTextToImage.BitBtn1Click(Sender: TObject);
begin
   if OpenDialog1.Execute then
     RichEdit1.Lines.LoadFromFile(OpenDialog1.FileName);
end;


procedure TFTextToImage.BitBtn2Click(Sender: TObject);
var
 I : Integer;
 ThisFont : TFont;
begin
 CreateBitmap;
 ThisFont:=TFont.Create;
 for I:=0 to RichEdit1.Lines.Count do begin
 ThisFont.Assign(RichEdit1.Font);
 ILImageText(ThisFont,
             BitMap,
             10,
             i*15,
             0,
             False,
             False,
             clBlack,
             RichEdit1.Lines[i]);
 end;
 PMultiImage1.Picture.Bitmap.Assign(Bitmap);
 ThisFont.Free;
end;


procedure TFTextToImage.BitBtn3Click(Sender: TObject);
begin
 CreateBitmap;
 //ShowMessage('WARNING THE BITMAP HAS TO BE LARGE ENOUGH TO HOLD THE TEXT OTHERWISE IT WILL **** CHRASH *******');
 try
  RTF2Image(Bitmap, RichEdit1);
 except
 
 end;
 PMultiImage1.Picture.Bitmap.Assign(Bitmap);
end;


procedure TFTextToImage.BitBtn4Click(Sender: TObject);
begin
    If PMultiImage1.Picture.Bitmap = nil then exit;
    if SaveDialog1.Execute then PMultiImage1.SaveAsTIF(SaveDialog1.FileName);
end;


procedure TFTextToImage.FormDestroy(Sender: TObject);
begin
   if Bitmap <> nil then Bitmap.Free;
end;

procedure TFTextToImage.RichEdit1ResizeRequest(Sender: TObject;
  Rect: TRect);
begin
    W:=Rect.Right+Rect.Left+30;
    H:=Rect.Bottom+Rect.Top+30;
end;

end.


