(*/////////////////////////////////////////////////////////////////////////////
//                                                                           //
//   Part of Imagelib VCL/DLL Library Corporate Suite 4.0                    //
//                                                                           //
//   All rights reserved. (c) Copyright 1995, 1996, 1997, 1998.              //
//   SkyLine Tools a division by Creative Development LTD.                   //
//                                                                           //
//   Created by: Jan Dekkers,                                                //
//               Jillian Pinsker,                                            //
//               Reginald Armond,                                            //
//               Che-Chern Lin,                                              //
//               Alex Zitser,                                                //
//               Charles Ye,                                                 //
//               Song Han,                                                   //
//               Vitaly Bondarenko,                                          //
//               Jane Scarano,                                               //
//               Misha Popov;                                                //
//                                                                           //
//   and many others who provided feedback, gave tips and comments.          //
//                                                                           //
//   Call 1-800 404-3832  or 1-818 346-4200 to order ImageLib Corp. Suite.   //
//                                                                           //
/////////////////////////////////////////////////////////////////////////////*)

{These are the most importand procedures you might want to use:

   procedure Stop_Animate;
   procedure Start_Animate;
   procedure ShowFrame(FrameNumber : LongInt);
   procedure ReadGifFromFile(Filename : String);
   procedure ReadJpgFromFile(Filename : String);
   procedure ReadPngFromFile(Filename : String);
   procedure WriteGifToFile(Filename : String);
   procedure WriteJpgToFile(Filename : String);
   procedure WritePngToFile(Filename : String);
   procedure ReadGifFromStream(Stream : TMemoryStream);
   procedure ReadPngFromStream(Stream : TMemoryStream);
   procedure ReadJpgFromStream(Stream : TMemoryStream);
   procedure WriteGifToStream(var Stream : TMemoryStream);
   procedure WriteJpgToStream(var Stream : TMemoryStream);
   procedure WritePngToStream(var Stream : TMemoryStream);
   procedure SetBitmap(Value: TBitmap; Bits : Integer);
   procedure ILWebImage.SetBitmap(Value: TBitmap; Bits : Integer);
   function ILWebImage.GetBitmap :  TBitmap;
   procedure ILWebImage.Trigger;

   Make sure to set a Timer with a value of < 100 which calls Trigger;
}


unit uwebima;

interface

uses
{$IFDEF DEL32}
  Windows,
{$ELSE}
  WinTypes,
  WinProcs,
{$ENDIF}
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  ExtCtrls,
  StdCtrls,
  Buttons,
  FileCtrl,
  Menus,
  uAbout,
  TMultiP,
  Spin,
  MMOpen,
  ILWebImg,
  MMSave, ComCtrls;

type
  TWebForm = class(TForm)
    Panel1: TPanel;
    OpenDialog1: TMMOpenDialog;
    Timer1: TTimer;
    SaveDialog1: TMMSaveDialog;
    Panel2: TPanel;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    SaveImage: TSpeedButton;
    FileListBox1: TFileListBox;
    DirectoryListBox1: TDirectoryListBox;
    DriveComboBox1: TDriveComboBox;
    ComboBox1: TComboBox;
    PlayGif: TSpeedButton;
    CloseWindow: TSpeedButton;
    Save1: TMenuItem;
    N3: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    MMOpenDialog1: TMMOpenDialog;
    Abboutbox: TSpeedButton;
    ShowFrameNumber: TSpinButton;
    Panel3: TPanel;
    ILWebImage1: ILWebImage;
    ScrollBox1: TScrollBox;
    PaintBox1: TPaintBox;
    Image1: TImage;
    SpeedButton1: TSpeedButton;
    SpinEdit1: TSpinEdit;
    SpeedButton2: TSpeedButton;
    ProgressBar1: TProgressBar;
    procedure Timer1Timer(Sender: TObject);
    procedure AniGifImage1Progress(Sender: TObject; Progress,
      FrameNumber: Integer; PGifHeader: PMyGifHeader;
      PImgageDes: PMyGifImageDescriptor;
      PGraphicCt: PMyGifGraphicControlBlock);
    procedure DirectoryListBox1Change(Sender: TObject);
    procedure DriveComboBox1Change(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure FileListBox1Change(Sender: TObject);
    procedure PlayGifClick(Sender: TObject);
    procedure CloseWindowClick(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure SaveImageClick(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure ShowFrameNumberDownClick(Sender: TObject);
    procedure ShowFrameNumberUpClick(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    MaxFrames,
    FrameN : Integer;

  end;

var
  WebForm: TWebForm;

implementation

{$R *.DFM}


{******************************************************************************
Move the Image Frames
******************************************************************************}
procedure TWebForm.Timer1Timer(Sender: TObject);
begin
    ILWebImage1.Trigger;
end;

(******************************************************************************
The following is a call back function from which you can read the following
information

The following info is only valid in frame 1.

type
 PMyGifHeader = ^TMyGifHeader;
 TMyGifHeader = Record
	 ScreenWidth          : WORD; {Logical screen width}
         ScreenHeight         : WORD; {Logical screen heigth}
	 GlobalColorTableSize : Byte; {size of the color table}
         SortFlag             : Byte; {Not used by this object}
         ColorResolution      : Byte; {Not used by this object}
         GlobalColorTableFlag : Byte; {Not used by this object}
         BackGroundColor      : TCOLORREF; {Color of the GIF background}
         AspectRatio          : Byte; {Not used by this object}
 end;

This header we get from the gif file and is valid for each frame

type
 PMyGifImageDescriptor = ^TMyGifImageDescriptor;
 TMyGifImageDescriptor = Record
         Left                : WORD;{ Left of the frame}
         Top                 : WORD;{ Top of the frame}
         Width               : WORD;{ Width of the frame}
         Height              : WORD;{ Height of the frame}
         LocalColorTableFlag : Byte;{ Has Local color table 1 or 0}
         InterlaceFlag       : Byte;{ Is interlaced}
         SortFlag            : Byte;{ Not used by this object}
         LocalColorTableSize : Byte;{ size of the color table}
 end;


This header we get from the gif file and is valid for each frame

type
 PMyGifGraphicControlBlock = ^TMyGifGraphicControlBlock;
 TMyGifGraphicControlBlock = Record
         BlockSize            : Byte;{ Not used by this object}
         DisposalMethod       : Byte;{ How to dispose previous frame}
         UserInputFlag        : Byte;{ Not used by this object}
         TransparentColorFlag : Byte;{ Has transparent color 1 or 0}
         DelayTime            : WORD;{ Time to delay in mili seconds}
         TransparentColorIndex: Byte;{ Color Index to the palette of the transparent color}
 end;


Warning:  When saving gifs the pointers to the structures/records are always NIL / NULL
******************************************************************************)
procedure TWebForm.AniGifImage1Progress(Sender: TObject;
                                        Progress,
                                        FrameNumber: Integer;
                                        PGifHeader: PMyGifHeader;
                                        PImgageDes: PMyGifImageDescriptor;
                                        PGraphicCt: PMyGifGraphicControlBlock);

begin
   if ProgressBar1.Position <> Progress then
    ProgressBar1.Position:=Progress;

   {Set the Maxframes counter used for scrolling through the frames with the spin control}
   if MaxFrames <> FrameNumber then
    MaxFrames:=FrameNumber;

   //Set the max of the insert edit
   if SpinEdit1.MaxValue<> MaxFrames then
    SpinEdit1.MaxValue:=MaxFrames;
end;


{******************************************************************************

******************************************************************************}
procedure TWebForm.DirectoryListBox1Change(Sender: TObject);
{update the directory of FileListBox1 with the directory of FileListBox1}
begin
  FileListBox1.Directory := DirectoryListBox1.Directory;
end;

{******************************************************************************


******************************************************************************}
procedure TWebForm.DriveComboBox1Change(Sender: TObject);
{update the drive of DirectoryListBox1 with the drive of DriveComboBox1}
begin
  DirectoryListBox1.Drive := DriveComboBox1.Drive;
end;

{******************************************************************************


******************************************************************************}
procedure TWebForm.ComboBox1Change(Sender: TObject);
begin
 FileListBox1.Mask:=ComboBox1.text;
 FileListBox1.Update;
end;

{******************************************************************************


******************************************************************************}
procedure TWebForm.FileListBox1Change(Sender: TObject);
var
  Ext : String;
begin
  if not FileExists(FileListBox1.Filename) then exit;

  MaxFrames:=0;
  SpinEdit1.Value:=1;

  PlayGif.Down:=False;

  {Get the extension}
  Ext:=UpperCase(ExtractFileExt(FileListBox1.Filename));

 {set hourglass cursor}
  screen.cursor:=crHourGlass;

  if Ext = '.GIF' then begin
    ShowFrameNumber.Visible:=True;
    PlayGif.Enabled:=True;
    ILWebImage1.MapTransparentColor:=clBtnFace;
    ILWebImage1.ReadGifFromFile(FileListBox1.filename);
    ILWebImage1.Repaint;
  end;

  if Ext = '.PNG' then begin
    ShowFrameNumber.Visible:=False;
    PlayGif.Enabled:=False;
    ILWebImage1.ReadPngFromFile(FileListBox1.filename);
    ILWebImage1.Repaint;
  end;

  if Ext = '.JPG' then begin
    ShowFrameNumber.Visible:=False;
    PlayGif.Enabled:=False;
    ILWebImage1.ReadJpgFromFile(FileListBox1.filename);
    ILWebImage1.Repaint;
  end;

  {Reset the gauge}
  ProgressBar1.Position:=0;
  {set default cursor}
  screen.cursor:=crDefault;

  ILWebImage1.UseScrollBars:=True;

  //Initialize the paintbox width
  PaintBox1.Width:=1;
  //Paint the frames in the paintbox
  PaintBox1Paint(Nil);

end;


{******************************************************************************


******************************************************************************}
procedure TWebForm.PlayGifClick(Sender: TObject);
begin
     if PlayGif.Down then
       ILWebImage1.Start_Animate
     else
       ILWebImage1.Stop_Animate;
end;

{******************************************************************************


******************************************************************************}
procedure TWebForm.CloseWindowClick(Sender: TObject);
begin
     Close
end;

{******************************************************************************


******************************************************************************}
procedure TWebForm.Exit1Click(Sender: TObject);
begin
     Close
end;

{******************************************************************************


******************************************************************************}
procedure TWebForm.SaveImageClick(Sender: TObject);
begin
     SaveDialog1.Filter:='jpeg|*.jpg|gif|*.gif|png|*.png';
     If SaveDialog1.Execute then begin
            {save it if the extension is png}
             if UpperCase(ExtractFileExt(SaveDialog1.Filename)) =  '.PNG' then
                ILWebImage1.WritePngToFile(SaveDialog1.FileName);

             {save it if the extension is gif}
             if UpperCase(ExtractFileExt(SaveDialog1.Filename)) =  '.GIF' then
                ILWebImage1.WriteGifToFile(SaveDialog1.FileName);

             {save it if the extension is jpg}
             if UpperCase(ExtractFileExt(SaveDialog1.Filename)) =  '.JPG' then
                ILWebImage1.WriteJpgToFile(SaveDialog1.FileName);

     end;
 {set default cursor}
 screen.cursor:=crDefault;
 {update the filelist box sothat the file saved shows up}
 FileListBox1.Update;
end;

{******************************************************************************

******************************************************************************}
procedure TWebForm.About1Click(Sender: TObject);
begin
  AboutBox:=TAboutBox.Create(self);
  AboutBox.ShowModal;
  AboutBox.free;
end;


{******************************************************************************

******************************************************************************}
procedure TWebForm.ShowFrameNumberDownClick(Sender: TObject);
begin
   inc(FrameN);
   if FrameN > MaxFrames -1 then FrameN:=0;
   ILWebImage1.ShowFrame(FrameN);
end;


{******************************************************************************

******************************************************************************}
procedure TWebForm.ShowFrameNumberUpClick(Sender: TObject);
begin
   dec(FrameN);
   if FrameN < 0 then FrameN:=MaxFrames-1;
   ILWebImage1.ShowFrame(FrameN);
end;


(******************************************************************************
 PMyGifAnimation = ^TMyGifAnimation;
 TMyGifAnimation = Record
         FrameName            : String;{The name of the frame. Reserved field}
	 ScreenWidth          : WORD;{ Logical screen width. Only in frame 1}
         ScreenHeight         : WORD;{ Logical screen height. Only in frame 1}
         GlobalColorTableSize : Byte; {size of the color table}
         LocalColorTableFlag  : Byte;{ Has Local color table}
         LocalColorTableSize  : Byte;{ size of the color table}
         BackGroundColor      : TCOLORREF;{ Whats the background color. Only in frame 1}
         Left                 : WORD;{ Left position of the frame}
         Top                  : WORD;{ Top position of the frame}
         Width                : WORD;{ Height of the frame}
         Height               : WORD;{ Height of the frame}
         InterlaceFlag        : Byte;{ Is interlaced}
         DisposalMethod       : Byte;{ How to dispose previous frame}
         TransparentColorFlag : Byte;{ Has Transparent color}
         TransparentColorIndex: Byte;{ Color Index to the palette of the transparent color}
         DelayTime            : WORD;{ Time to delay in mili seconds}
         NetLoops             : Longint;{ Loops to run used by Netscape}
         HDib                 : THandle;{ Handle to the gif dib}
******************************************************************************)
procedure TWebForm.SpeedButton1Click(Sender: TObject);
var
  GifFrame : PMyGifAnimation;
  ILOne,
  IL : ILTDib;
  I,                                                     
  BitDepth : Integer;
begin
  //Chec to see if we have frames
  if ILWebImage1.AGifList.Count-1 < 0 then exit;

  //Set all frames to use a local color table (Best result)
  for I:=0 to ILWebImage1.AGifList.Count-1 do
   PMyGifAnimation(ILWebImage1.AGifList.Items[I])^.LocalColorTableFlag:=1;

  //***get the bitdepth of the first frame***//
  //Create a dib class
  ILOne:=ILTDib.Create;
  //We don't want to free the dib when destroying this class
  ILOne.DestroyDibOnExit:=False;
  //Get the first frame
  ILOne.DibBitmap:=GlobalLock(PMyGifAnimation(ILWebImage1.AGifList.Items[0])^.HDib);
  //Get the bits per pixel
  BitDepth:=ILOne.Bits;
  //Free the dibclass
  ILOne.Free;


  //Create a dib class
  IL:=ILTDib.Create;
  //We don't want to free the dib when destroying this class
  IL.DestroyDibOnExit:=False;
  //Get the dib converting it to BitDepth;
  IL.FBitmapToDib(Image1.Picture.Bitmap, BitDepth);

  //Allocate memory for the record
  GifFrame :=New(PMyGifAnimation);

  //*****Fill in the frame description*****//
  GifFrame^.FrameName:='Inserted frame'; //Only used for your internal use
  GifFrame^.ScreenWidth:=PMyGifAnimation(ILWebImage1.AGifList.Items[0])^.ScreenWidth; //Copy this from frame one
  GifFrame^.ScreenHeight:=PMyGifAnimation(ILWebImage1.AGifList.Items[0])^.ScreenHeight; //Copy this from frame one
  GifFrame^.GlobalColorTableSize:=PMyGifAnimation(ILWebImage1.AGifList.Items[0])^.GlobalColorTableSize; //Copy this from frame one

  GifFrame^.LocalColorTableFlag:=1;//Use a local colortable
  if BitDepth = 4 then
   GifFrame^.LocalColorTableSize:=16 //local color table size is 16 colors
  else
   GifFrame^.LocalColorTableSize:=255; //local color table size is 255 colors

  GifFrame^.BackGroundColor:=PMyGifAnimation(ILWebImage1.AGifList.Items[0])^.BackGroundColor; //Copy this from frame one
  GifFrame^.Left:=0;//Frame position
  GifFrame^.Top:=0;//Frame position
  GifFrame^.Width:=IL.Width; //get the width of the dib
  GifFrame^.Height:=IL.height; //get the height of the dib
  GifFrame^.InterlaceFlag:=0; //Dont' interlace;
  GifFrame^.DisposalMethod:=PMyGifAnimation(ILWebImage1.AGifList.Items[0])^.DisposalMethod; //Copy this from frame one
  GifFrame^.TransparentColorFlag:=0;//Don't use transparent
  GifFrame^.TransparentColorIndex:=0;//if transparent use the first color in the palette
  GifFrame^.DelayTime:=PMyGifAnimation(ILWebImage1.AGifList.Items[0])^.DelayTime; //Copy this from frame one
  GifFrame^.NetLoops:=PMyGifAnimation(ILWebImage1.AGifList.Items[0])^.NetLoops; //Copy this from frame one
  GifFrame^.HDib:=GlobalHandle(IL.DibBitmap);

  //Free the dib class
  IL.Free;

  //Insert the frame
  ILWebImage1.AGifList.Insert(SpinEdit1.Value, GifFrame);

  //set max value
  SpinEdit1.MaxValue:=ILWebImage1.AGifList.Count;

  PaintBox1Paint(Nil);
end;


(******************************************************************************

******************************************************************************)

procedure TWebForm.PaintBox1Paint(Sender: TObject);
var
 pTop,
 I : Integer;
 GifFrame : PMyGifAnimation;
 IL : ILTDib;
begin
     //Initialize where the first frame needs to be painted;
     pTop:=1;
    //AGiflist is a Tlist with PMyGifAnimation records
     for I:=0 to ILWebImage1.AGifList.Count-1 do begin
         //Get our frame
         GifFrame:=ILWebImage1.AGifList.Items[I];
         //Create a dib class
         IL:=ILTDib.Create;
         //We don't want to free the dib when destroying this class
         IL.DestroyDibOnExit:=False;
         //Get the gif dib
         IL.DibBitmap:=GlobalLock(GifFrame^.HDib);
         //Paint the frame
         StretchDIBits(PaintBox1.Canvas.Handle,
                       0,
                       pTop,
                       IL.Width,
                       IL.Height,
                       0,
                       0,
                       IL.Width,
                       IL.Height,
                       IL.ptrBits,
                       IL.DibBitmap^,
                       DIB_RGB_COLORS,
                       SRCCOPY);
         //Increase the top
         pTop:=pTop+IL.Height+5;
         //Set the paintbox width when needed
         if PaintBox1.Width < IL.Width then PaintBox1.Width := IL.Width;
         //Unlock the Dib (Not needed when DestroyDibOnExit is true);
         GlobalUnlock(GifFrame^.HDib);
         //Free the dibclass
         IL.Free;
     end;
     PaintBox1.Height:=pTop+5;
end;


{******************************************************************************
Make a Copy of a dib
******************************************************************************}
function AssignDIB(SourceDIB : THANDLE) : THandle;
var
  hDestDIB  : THANDLE;
  lpOldDIB : PByte;
  lpNewDIB : PByte;
  dwSize   : LongInt;
 begin

 if SourceDIB <1 then begin
     Result:=0;
     {no source dib}
     exit;
  end;
  dwSize := GlobalSize(SourceDIB);

  hDestDIB := GlobalAlloc(GHND, dwSize);
  if hDestDIB <1 then begin
     Result:=0;
     {out of memory}
     exit;
  end;

  lpOldDIB := PByte(GlobalLock(SourceDIB));
  lpNewDIB := PByte(GlobalLock(hDestDIB));
  move(lpOldDIB^, lpNewDIB^, dwSize);

  GlobalUnlock(SourceDIB);
  GlobalUnlock(hDestDIB);
  result:=hDestDIB;
end;


(******************************************************************************
Example of how to change the transparent color index and how to change the color
******************************************************************************)
procedure TWebForm.Button1Click(Sender: TObject);
var
  TP       : TPaletteEntry;
  p        : TPaletteEntry;
  GifFrame : PMyGifAnimation;
  IL : ILTDib;
  PaletteIndex,
  frame,
  N,
  I : Integer;
  THdib : THandle;
begin
  //Chec to see if we have frames
  if ILWebImage1.AGifList.Count-1 < 0 then exit;

  //Set all frames to use a local color table
  for I:=0 to ILWebImage1.AGifList.Count-1 do
   PMyGifAnimation(ILWebImage1.AGifList.Items[I])^.LocalColorTableFlag:=1;

  //We are applying it to this frame
  frame:=0;
  //We are applying it to this index
  PaletteIndex:=0;

  //Get a frame
  GifFrame:=ILWebImage1.AGifList.Items[frame];

  GifFrame^.TransparentColorFlag:=1;//use transparent
  GifFrame^.TransparentColorIndex:=PaletteIndex;//if transparent use the first color in the palette

  //Create a dib class
  IL:=ILTDib.Create;

  IL.DibBitmap:=GlobalLock(GifFrame^.HDib);

  TP.peRed := GetRValue(clLime);  //Change the Transcolor to lime
  TP.peGreen := GetGValue(clLime);//Change the Transcolor to lime
  TP.peBlue := GetBValue(clLime); //Change the Transcolor to lime
  TP.peFlags := 0;

  //Update the palette
  SetPaletteEntries(IL.Palette,   // handle of logical palette
                    PaletteIndex,// index of first entry to set
                    1,  // number of entries to set
                    TP);

   //Update the color change to the dib
   for N := 0  to IL.NumColors -1 do begin
         if GetPaletteEntries(IL.Palette, N, 1, P) > 0 then begin
          IL.DibBitmap^.bmiColors[N].rgbRed   :=p.peRed;
          IL.DibBitmap^.bmiColors[N].rgbGreen :=p.peGreen;
          IL.DibBitmap^.bmiColors[N].rgbBlue  :=p.peBlue;
         end;
   end;

  //make a copy of the dib
  THdib:=AssignDIB(GlobalHandle(IL.DibBitmap));

  //Free the dibclass (and the old dib)
  IL.Free;

  //Update the dib
  GifFrame^.HDib:=THdib;
end;


end.


